#!/bin/bash
################################################################################
## Copyright:   HUAWEI Tech. Co., Ltd.
## Filename:    install.sh
## Description: install oms
## Version:     FusionInsight Hadoop V100R002C02
## Created:     Wednesday, May 15, 2013
################################################################################
# ---------------------------------------------------------------------------- #
#                                   变量定义                                   #
# ---------------------------------------------------------------------------- #
declare g_bigdataDataHome="$1"              # 大数据产品数据存储根目录
declare g_operatorType="$2"                 # 当前操作的类别
declare g_omsDbDataHome=""                  # OMS 数据库数据的存放目录
declare g_controllerHome=""                 # controller安装目录
declare g_bigdataHome=""                    # bigdata安装目录
declare g_omsHome=""                        # OMS安装目录
declare g_omServerWorkspace=""              # om-server安装的工作区目录
declare g_omServerHome=""                   # om-server安装的工作区目录
declare g_omAgentWorkspace=""               # om-agent安装的工作区目录
declare g_omAgentHome=""                    # om-server安装的工作区目录
declare g_bigdataCommon=""                  # common工作区目录 /opt/huawei/Bigdata/common
declare g_bigdataCommonWorkspace=""         # common工作区目录 /opt/huawei/Bigdata/common/runtime0
declare g_omsPackageName=""                 # OMS安装tar包的文件名(不带全路径)
declare g_localIp=""                        # 本端IP
declare g_peerIp=""                         # 对端IPd
declare g_omsInsFileName=""                 # OMS安装tar包的文件名(带全路径)
declare g_omsConfigFile=""                  # OMS配置文件,保存各个输入参数
declare g_wsFloatIP=""                      # 用户在web页面访问系统的浮动ip
declare g_wsFloatIPNetmask=""               # 用户在Web页面访问系统的子网掩码
declare g_wsFloatIPInterface=""             # 用户在Web页面访问系统的网卡
declare g_wsGateway=""                      # 用户在Web页面访问系统的网关
declare g_omFloatIP=""                      # 各个节点访问主controller的浮动ip
declare g_omFloatIPNetmask=""               # 各个节点访问主controller的子网掩码
declare g_omFloatIPInterface=""             # 各个节点访问主controller的的网卡
declare g_omGateway=""                      # 各个节点访问主controller的的网关
declare g_ntpServerIP=""                    # ntp时间基准服务器的ip，支持多ip，每个ip以逗号分隔
declare g_haMode=""                         # ha模式：单机(single)或者双机(double)
declare g_logHome=""                        # 日志根目录
declare g_logFile=""                        # 日志文件
declare g_ssoServerIP=""                    # SSOServerIP
declare g_ssoServerPort=""                  # SSOServerPort
declare g_masterldapIP=""                   # masterldapip
declare g_masterldapPort=""                 # masterldaport
declare g_tomcatclassespath=""              # explanatory
declare g_osOptimizatLogFile=""             # 优化OS日志文件
declare g_curPath=""                        # 当前脚本所在的路径
declare g_scriptName=""                     # 当前脚本的脚本名称
declare g_omsLdapPackageName=""             # OMS的LDAP安装包名称(不带路径名)
declare g_omsKerberosPackageName=""         # OMS的Kerberos安装包名称（不带路径名）
declare g_omsLdapInsFileName=""             # OMS的LDAP安装包名称(带路径名)
declare g_omsKerberosInsFileName=""         # OMS的Kerberos安装包名称(带路径名)
declare -i retVal=0                         # 返回值
declare SUDOSCRIPT="sudoExecute.sh"         # OMS执行sudo命令的脚本sudoExecute.sh
declare g_oms_config_path=""
declare g_controller_sftp_url=""            # explanatory
declare g_nodeip=""                         #
declare g_oms_configmodle_path=""
declare g_securityconfigmodlePath=""
declare g_defaultcasserverPort=20009        # 默认的casserver端口号
declare g_kentab_path=""
declare g_changepw_file_path=""
declare g_om_plugin_file_name="Manager.properties"
declare g_plugin_path=""                    # explanatory
declare g_webserver_port=28443              # explanatory
declare g_randon_key_dir=""                 #随机密钥所在路径
declare g_KerberosInsPackName="FusionInsight-okerberos-1.17.tar.gz"
declare g_LdapServerInsPackName="FusionInsight-oldapserver-2.7.0.tar"
declare g_MetaPackName="FusionInsight-ometa-2.7.0.tar.gz"
declare g_littleMem=4096                    #4G
declare g_criticalValueMem=10240            #10G 最小内存数
declare  SUDO_PATH_OMS=""                   # OMS侧sudoExecute.sh路径
declare GLOBAL_INSTALL_USER=""              # 安装用户
declare g_super_user="root"                 # root用户名
declare g_certHAConf=""
declare HA_SSL_CERT_PWD=""                  # HA 证书密码
declare g_isUpdateCommonWorkspace="true"    #升级时，是否需要更新common工作区
declare g_tls_protocol_min=""               #表示当前操作系统中ldapserver支持的最低版本TLS协议
declare g_packageDistributeSubdir=""
declare default_realm="HADOOP.COM"
declare g_kerberos_realm="$3"               #表示当前FI安装时，使用的域名

# ---------------------------------------------------------------------------- #
#                                   函数定义                                   #
# ---------------------------------------------------------------------------- #
################################################################################
# Function: get_cur_path
# Description: 获取脚本所在的目录及脚本名
# Parameter:
#   input:
#   N/A
#   output:
#   N/A
# Return: 0 -- success; not 0 -- failure
# Others: N/A
################################################################################
get_cur_path()
{
    cd "$(dirname "${BASH_SOURCE-$0}")"
    g_curPath="${PWD}"
    g_scriptName="$(basename "${BASH_SOURCE-$0}")"
    cd - > /dev/null
}


################################################################################
# Function: init_log
# Description: 初始化日志文件
# Parameter:
#   input:
#   N/A
#   output:
#   N/A
# Return: 0 -- success; not 0 -- failure
# Others: N/A
################################################################################
init_log()
{
    # controller安装日志存放路径。在constants.sh脚本加载之前，使用父脚本导出的
    # 环境变量BIGDATA_LOG_HOME
    g_logHome="${BIGDATA_LOG_HOME}"
    local logPath="${g_logHome}/controller/scriptlog"
    g_logFile="${logPath}/install.log"

    #系统优化的日志文件
    g_osOptimizatLogFile="${logPath}/install_os_optimization.log"

    # 创建日志文件和修改文件权限
    mkdir -p "${logPath}"
    if [ ! -f "${g_logFile}" ] ; then
        touch "${g_logFile}"
    fi

    if [ ! -f "${g_osOptimizatLogFile}" ] ; then
        touch "${g_osOptimizatLogFile}"
    fi

    find "${logPath}" -type f | xargs -I{} chmod 600 "{}" >> "${g_logFile}" 2>&1 || return $?
    find "${logPath}" -type d | xargs -I{} chmod 700 "{}" >> "${g_logFile}" 2>&1 || return $?

    return 0
}

################################################################################
# Function: init_home_authority
# Description: 初始化根目录权限
# Parameter:
#   input:
#   N/A
#   output:
#   N/A
# Return: 0 -- success; not 0 -- failure
# Others: N/A
################################################################################
init_home_authority()
{
    log_debug "${LINENO}" "init_home_authority"
    
    # 修改g_controllerHome目录及其子目录权限
    chmod 700 "${g_controllerHome}" -R

    # 改变controller目录权限为750，omm的ommdba用户需要访问security文件夹key文件
    chmod 750 "${g_controllerHome}"

    #修改g_controllerHome指定文件后缀的权限
    for var in "${NON_EXECUTABLE_FILES[@]}";
    do
        find "${g_controllerHome}" -type f -name "*$var" | xargs -I{} chmod 600 "{}"
    done

    # 以下目录更改为业务组件需要的权限
    chmod 770 "${g_bigdataDataHome}"
    chmod o+t "${g_bigdataDataHome}"

    chmod 770 "${BIGDATA_LOG_HOME}"
    
    # 修改数据存储目录,日志目录，安装目录及其子目录的权限
    sudo ${INSTALL_SUDO_PATH} software_dir_chown_omm  ${g_omServerWorkspace} ${g_operatorType} || return 1
    return ${INS_SUCCESS}
}

################################################################################
# Function: modify_file_authority
# Description: 修改文件权限
# Parameter:
#   input:
#   N/A
#   output:
#   N/A
# Return: 0 -- success; not 0 -- failure
# Others: N/A
################################################################################
modify_file_authority()
{
 log_debug "${LINENO}" "modify_file_authority start"
 
 sudo ${INSTALL_SUDO_PATH} chmod_database_sql_dir "${g_controllerHome}" >> "${g_logFile}" 2>&1

 source "${g_omServerWorkspace}/.controller_profile"
 local tomcatHome=${OM_TOMCAT_HOME}
 log_debug "${LINENO}" "tomcatHome=${tomcatHome}"
 
 chmod 600 ${tomcatHome}/conf/security/*  >> "${g_logFile}" 2>&1

 local omCertHome="${g_controllerHome}/packaged-distributables/${g_packageDistributeSubdir}/tomcat.crt*"
 local omKeystoreHome="${g_controllerHome}/packaged-distributables/${g_packageDistributeSubdir}/tomcat.keystore*"
 chmod 600 ${omCertHome}
 chmod 600 ${omKeystoreHome}
 
 #从分发子目录拷贝出来的tomcat文件也改一下
 omCertHome="${g_controllerHome}/packaged-distributables/tomcat.crt*"
 omKeystoreHome="${g_controllerHome}/packaged-distributables/tomcat.keystore*"
 chmod 600 ${omCertHome}
 chmod 600 ${omKeystoreHome}

 local webWc2Jar="${tomcatHome}/webapps/web/WEB-INF/lib/wc2frm*.jar"
 local controllerWc2Jar="${g_controllerHome}/share/om/controller/lib/wc2frm*.jar"
 chmod 700 ${webWc2Jar}
 chmod 700 ${controllerWc2Jar}

 local controllerLogDir="${g_logHome}/controller"
 chmod 700 ${controllerLogDir}

 local componentsDir="${g_controllerHome}/etc/components"
 chmod 700 ${componentsDir} -R  >> "${g_logFile}" 2>&1  

 if [ -f "${g_controllerHome}/tools/main.jar" ]; then
     chmod 600 ${g_controllerHome}/tools/main.jar
 fi

 if [ -d ${g_bigdataHome} ]; then
     chmod 750 ${g_bigdataHome}
 fi
 
 if [ -d ${g_omServerWorkspace} ]; then
     chmod 750 ${g_omServerWorkspace}
 fi

 if [ -d ${g_omAgentWorkspace} ]; then
     chmod 750 ${g_omAgentWorkspace}
 fi

 if [ -d ${g_bigdataCommon}/tools ]; then
     chmod 750 ${g_bigdataCommon}/tools -R
 fi
 #修改wcc密钥目录文件权限640
 keydir="${g_bigdataCommon}/security"
 find "${keydir}" -type f -name "*" | xargs -I{} chmod 640 "{}"

 #change files and directories that both root and none root user can execute to 750 and root:wheel
 sudo ${INSTALL_SUDO_PATH} security_software_dir_and_file_chown_root  ${g_omServerWorkspace}


 sudo ${INSTALL_SUDO_PATH} create_softlink_for_libnsl
 
 log_debug "${LINENO}" "modify_file_authority end"
}


################################################################################
# Function: replace_casserver
# Description: 替换securityconfig中的casserverip
# Parameter:
#   input:
#   N/A
#   output:
#   N/A
# Return: 0 -- success; not 0 -- failure
# Others: N/A
################################################################################
replace_casserver()
{
    if [ -f ${g_securityconfigmodlePath} ] ; then
        sudo ${INSTALL_SUDO_PATH} exec_omm_cmd "cp -rf ${g_securityconfigmodlePath} ${g_tomcatclassespath}" > /dev/null 2>&1
        if [ $? -ne 0 ] ; then
           log_error "${LINENO}" "failed to copy the security config modle to tomcat path."
        fi
    fi
    # security-context.xml文件路径
    local targetFile="${g_tomcatclassespath}/security-context.xml"
    sed -i "s:#casServerIP#:${g_ssoServerIP}:g"  "${targetFile}"
    sed -i "s:#casServerPort#:${g_ssoServerPort}:g"  "${targetFile}"
    sed -i "s:#omfloatIP#:${g_wsFloatIP}:g"  "${targetFile}"
    sed -i "s:#webServerPort#:${g_webserver_port}:g"  "${targetFile}"

    sed -i "s:#omfloatIP#:${g_wsFloatIP}:g"  "${g_securityconfigmodlePath}"
    sed -i "s:#webServerPort#:${g_webserver_port}:g"  "${g_securityconfigmodlePath}"
    return ${INS_SUCCESS}
}



################################################################################
# Function: install_prepare
# Description: 安装前准备：不同的操作系统需要做些不同的适配工作
# Parameter:
#   input:
#   N/A
#   output:
#   N/A
# Return: 0 -- success; not 0 -- failure
# Others: N/A
################################################################################
install_prepare()
{
    log_info "${LINENO}" "Start to prepare for installation."
    # 关闭防火墙
    exec_cmd stop_iptables
    retVal=$?
    if [ ${retVal} -ne 0 ] ; then
        showLog_error "${LINENO}" "Failed to stop iptables."
        return ${retVal}
    fi

    # 配置sysctl
    exec_cmd config_sysctl
    retVal=$?
    if [ ${retVal} -ne 0 ] ; then
        showLog_error "${LINENO}" "Failed to config sysctl."
        return ${retVal}
    fi

    # 配置limits
    exec_cmd config_limits
    retVal=$?
    if [ ${retVal} -ne 0 ] ; then
        showLog_error "${LINENO}" "Failed to config limits."
        return ${retVal}
    fi

    # 配置/etc/sudoes
    exec_cmd config_sudoers
    retVal=$?
    if [ ${retVal} -ne 0 ] ; then
        showLog_error "${LINENO}" "Failed to config sudoers."
        return ${retVal}
    fi
    log_info "${LINENO}" "Succeed to prepare for installation."
    return ${INS_SUCCESS}
}

################################################################################
# Function: set_ha_dead_time
# Description: 设置主controller宕机，备controller等待升主的时间
# Parameter:
#   input:
#   $1 -- dead time
#   output:
#   N/A
# Return: 0 -- success; not 0 -- failure
# Others: N/A
################################################################################
set_ha_dead_time()
{
    local deadTime=$1

    # 判断入参
    if [ -z "${deadTime}" ] ; then
        log_error "${LINENO}" "The input parameter is empty."
        return ${INS_DEBUG_ERROR}
    fi

    # 判断要配置的文件是否存在
    local configFile="${g_omsHome}/workspace/ha/module/haarb/conf/haarb.xml"
    if [ ! -f "${configFile}" ] ; then
        log_error "${LINENO}" "The ${configFile} file does not exist."
        return ${INS_FILE_NOT_EXIST}
    fi

    sed -i "s/<deadtime value=\"[0-9]*\"/<deadtime value=\"${deadTime}\"/g" "${configFile}" > /dev/null 2>&1

    return ${INS_SUCCESS}
}

################################################################################
################################################################################
# Function: sntp_sync_time
# Description: 使用sntp命令同步ntp服务器的时间
# Parameter:
#   input:ntp服务器ip
#   N/A
#   output:
#   N/A
# Return: 0 -- success; not 0 -- failure
# Others: N/A
################################################################################
sntp_sync_time()
{
    local ntp_server_ip=$1
    #sntp协议的时间戳最大支持2036年2月7日6:28:15(UTC)，如果系统时间年份大于等于2036年，就把系统时间改为2035年01月01日(UTC)，确保sntp强制同步成功。
    if [ $(date '+%Y') -ge 2036 ]; then
        log_debug "${LINENO}" "system time is going to change to 20350101(UTC) ."
        date -u -s '20350101' >> "${g_logFile}" 2>&1
    fi
    sntp -v -P no -r ${ntp_server_ip} >> "${g_logFile}" 2>&1
    if [ $? -ne 0 ]; then
        showLog_error "${LINENO}" "sntp -P no -r ${ntp_server_ip} failed."
        return 1
    fi

    log_debug "${LINENO}" "sntp -P no -r ${ntp_server_ip} successfully."

    return 0
}

################################################################################
# Function: ntpdate_sync_time
# Description: 使用ntpdate命令同步ntp服务器的时间
# Parameter:
#   input:ntp服务器ip
#   N/A
#   output:
#   N/A
# Return: 0 -- success; not 0 -- failure
# Others: N/A
################################################################################
ntpdate_sync_time()
{
    local ntp_server_ip=$1

    #等待3秒钟接收ntp服务器的相应并强制同步时间
    ntpdate -t 3 ${ntp_server_ip} >> "${g_logFile}" 2>&1
    if [ $? -ne 0 ]; then
        showLog_error "${LINENO}" "ntpdate ${ntp_server_ip} failed."
        return 1
    fi

    log_debug "${LINENO}" "ntpdate ${ntp_server_ip} successfully."

    return 0
}

################################################################################
# Function: sync_time
# Description: 同步ntp服务器时间
# Parameter:
#   input:ntp服务器ip
#   N/A
#   output:
#   N/A
# Return: 0 -- success; not 0 -- failure
# Others: N/A
################################################################################
function sync_time()
{
    local ntp_server_ip=$1

    log_debug "${LINENO}" "sync_time"

    if [ -z "$ntp_server_ip" ]; then
        showLog_error "${LINENO}" "ntp_server_ip is empty."
        return 1
    fi

    ping -c 1 ${ntp_server_ip} >> "${g_logFile}" 2>&1
    if [ $? -ne 0 ]; then
        showLog_error "${LINENO}" "ping ntp server ${ntp_server_ip} failed."
        return 1
    fi

    log_debug "${LINENO}" "stop ntpd service."
    service ntpd stop >> "${g_logFile}" 2>&1
    service ntp stop >> "${g_logFile}" 2>&1

    which sntp > /dev/null 2>&1
    if [ $? -eq 0 ]; then
        sntp_sync_time ${ntp_server_ip}
        return $?
    fi

    which ntpdate > /dev/null 2>&1
    if [ $? -eq 0 ]; then
        ntpdate_sync_time ${ntp_server_ip}
        return $?
    fi

    showLog_error "${LINENO}" "can't find sntp or ntpdate programe."
    return 1
}

################################################################################
# Function: add_route_tables
# Description: 建立路由表项
# Parameter:
#   input:
#   N/A
#   output:
#   N/A
# Return: 0 -- success; not 0 -- failure
# Others: N/A
################################################################################
add_route_tables()
{
    log_info "${LINENO}" "Start to create route table variable file."

    sudo ${INSTALL_SUDO_PATH} add_route_tables >> "${g_logFile}" 2>&1
    ret=$?
    if [ ${ret} -ne 0 ]; then
        return ${ret}
    fi

    return ${INS_SUCCESS}
}

################################################################################
# Function: modify_config_file
# Description: 修改配置文件：用变量替换配置文件中的一些特殊标识
# Parameter:
#   input:
#   N/A
#   output:
#   N/A
# Return: 0 -- success; not 0 -- failure
# Others: N/A
################################################################################
modify_config_file()
{
    # 修改floatip.xml配置文件,OM安装包里的文件，不用判断文件存在性
    local targetFile="${g_controllerHome}/inst/conf/floatip.xml"
    sed -i "s/wsFloatIpValue/${g_wsFloatIP}/g" "${targetFile}"
    sed -i "s/wsNetmaskValue/${g_wsFloatIPNetmask}/g" "${targetFile}"
    sed -i "s/wsInterfaceValue/${g_wsFloatIPInterface}/g" "${targetFile}"
    sed -i "s/wsGateWayValue/${g_wsGateway}/g" "${targetFile}"
    sed -i "s/omFloatIpValue/${g_omFloatIP}/g" "${targetFile}"
    sed -i "s/omNetmaskValue/${g_omFloatIPNetmask}/g" "${targetFile}"
    sed -i "s/omInterfaceValue/${g_omFloatIPInterface}/g" "${targetFile}"
    sed -i "s/omGateWayValue/${g_omGateway}/g" "${targetFile}"
    sed -i "s/haModeValue/${g_haMode}/g" "${targetFile}"

    # 替换以下配置文件中的OM_HOME特殊标识,都是OM安装包里的文件，不用判断文件存在性
    local targetDir="${g_controllerHome}/inst/conf"
    sed -i -e "s:#BIGDATA_HOME#:${g_bigdataHome}:g" -e "s:#HUAWEI_COM_ZONE#:${HUAWEI_COM_ZONE}:g" -e "s:#NAMED_CONF#:${NAMED_CONF}:g" "${targetDir}/filesync.xml"
    sed -i -e "s:#OMS_RUN_PATH#:${g_omsHome}:g" "${targetDir}/filesync.xml"
    sed -i -e "s:#OM_LOG_HOME#:${g_logHome}:g" "${targetDir}/filesync.xml"
    sed -i -e "s:#BIGDATA_DATA_HOME#:${g_bigdataDataHome}:g" "${targetDir}/filesync.xml"
    sed -i -e "s:#BIGDATA_COMMON_WORKSPACE#:${g_bigdataCommonWorkspace}:g" "${targetDir}/filesync.xml"
    sed -i -e "s:#OMS_SERVER_WORKSPACE#:${g_omServerWorkspace}:g" "${targetDir}/filesync.xml"
    
    for cfg in "$g_controllerConfHome/omscfg"/nodes_properties*.ini
    do
        sed -i -e "s:#OMS_SERVER_WORKSPACE#:${g_omServerWorkspace}:g" -e "s:#OMS_RUN_PATH#:${g_omsHome}:g" "${cfg}" >> ${g_logFile} 2>&1 || return $?
    done

    return ${INS_SUCCESS}
}

################################################################################
# Function: config_sudoers
# Description: 配置/etc/sudoers文件，方便在omm用户下执行命令
# Parameter:
#   input:
#   N/A
#   output:
#   N/A
# Return: 0 -- success; not 0 -- failure
# Others: N/A
################################################################################
config_sudoers()
{
    log_debug "${LINENO}" "Config command to /etc/sudoers file."

    local -a cmdArray=("${SUDO_PATH_OMS}")

    for cmd in "${cmdArray[@]}" ; do
        config_sudo "${cmd}"
        if [ $? -ne 0 ] ; then
            showLog_error "${LINENO}" "Failed to config the ${cmd} command to /etc/sudoers."
            return ${INS_CONFIG_SUDO_FAILURE}
        fi
    done



    # 配置sudoers：调用操作系统差异函数，即不同的操作系统该函数内容不一样。
    set_sudoers
    if [ $? -ne 0 ]; then
       showLog_error "${LINENO}" "Failed to config /etc/sudoers."
       return ${INS_CONFIG_SUDO_FAILURE}
    fi

    return ${INS_SUCCESS}
}

################################################################################
# Function: config_ha_plugin
# Description: 配置ha插件
# Parameter:
#   input:
#   N/A
#   output:
#   N/A
# Return: 0 -- success; not 0 -- failure
# Others: N/A
################################################################################
config_ha_plugin()
{
    log_info "${LINENO}" "Start to config ha plugin."
    # 修改配置文件：用变量替换配置文件中的一些特殊标识。该方法不会出错，不用判断返回值
    modify_config_file

    # 源配置文件所在目录
    local srcConfigDir="${g_controllerHome}/inst/conf"
    # 源脚本所在目录
    local srcScriptDir="${g_controllerHome}/inst/script"

    # 配置同步目录
    local targetDir="${g_omsHome}/workspace/ha/module/hasync/plugin/conf"
    exec_cmd rm -f "${targetDir}"/filesync.xml || return ${INS_COPY_FILE_FAILURE}
    exec_cmd cp -p "${srcConfigDir}/filesync.xml" "${targetDir}/filesync.xml" || return ${INS_COPY_FILE_FAILURE}

    # 配置ha监控资源(配置文件和脚本)
    targetDir="${g_omsHome}/workspace/ha/module/harm/plugin/conf"

    exec_cmd cp -p "${srcConfigDir}/floatip.xml" "${targetDir}" || return ${INS_COPY_FILE_FAILURE}
    exec_cmd cp -p "${srcConfigDir}/controller.xml" "${targetDir}" || return ${INS_COPY_FILE_FAILURE}
    exec_cmd cp -p "${srcConfigDir}/tomcat.xml" "${targetDir}" || return ${INS_COPY_FILE_FAILURE}
    exec_cmd cp -p "${srcConfigDir}/targetRoute.xml" "${targetDir}" || return ${INS_COPY_FILE_FAILURE}
    exec_cmd cp -p "${srcConfigDir}/aos_rm_conf.xml" "${targetDir}" || return ${INS_COPY_FILE_FAILURE}
    exec_cmd cp -p "${srcConfigDir}/acs_rm_conf.xml" "${targetDir}" || return ${INS_COPY_FILE_FAILURE}
    exec_cmd cp -p "${srcConfigDir}/oldap.xml" "${targetDir}" || return ${INS_COPY_FILE_FAILURE}
    exec_cmd cp -p "${srcConfigDir}/okerberos.xml" "${targetDir}" || return ${INS_COPY_FILE_FAILURE}
    exec_cmd cp -p "${srcConfigDir}/httpd.xml" "${targetDir}" || return ${INS_COPY_FILE_FAILURE}
    exec_cmd cp -p "${srcConfigDir}/feed_watchdog.xml" "${targetDir}" || return ${INS_COPY_FILE_FAILURE}

    targetDir="${g_omsHome}/workspace/ha/module/harm/plugin/script"

    exec_cmd cp -p "${srcScriptDir}/floatip" "${targetDir}" || return ${INS_COPY_FILE_FAILURE}
    exec_cmd cp -p "${srcScriptDir}/controller" "${targetDir}" || return ${INS_COPY_FILE_FAILURE}
    exec_cmd cp -p "${srcScriptDir}/tomcat" "${targetDir}" || return ${INS_COPY_FILE_FAILURE}
    exec_cmd cp -p "${srcScriptDir}/aos_rm_cmd.sh" "${targetDir}" || return ${INS_COPY_FILE_FAILURE}
    exec_cmd cp -p "${srcScriptDir}/acs_rm_cmd.sh" "${targetDir}" || return ${INS_COPY_FILE_FAILURE}

    exec_cmd cp -p "${srcScriptDir}/ntp_tickadj.sh" "${targetDir}" || return ${INS_COPY_FILE_FAILURE}
    exec_cmd cp -p "${srcScriptDir}/om_route_conf.sh" "${targetDir}" || return ${INS_COPY_FILE_FAILURE}
    exec_cmd cp -p "${srcScriptDir}/route_set.sh" "${targetDir}" || return ${INS_COPY_FILE_FAILURE}
    exec_cmd cp -p "${srcScriptDir}/updateip.sh" "${targetDir}" || return ${INS_COPY_FILE_FAILURE}
    exec_cmd cp -p "${srcScriptDir}/targetRoute.sh" "${targetDir}" || return ${INS_COPY_FILE_FAILURE}
    exec_cmd cp -p "${srcScriptDir}/setTargetRoute.sh" "${targetDir}" || return ${INS_COPY_FILE_FAILURE}
    exec_cmd cp -p "${srcScriptDir}/configNtpRoute.sh" "${targetDir}" || return ${INS_COPY_FILE_FAILURE}
    exec_cmd cp -p "${srcScriptDir}/oldap.sh" "${targetDir}" || return ${INS_COPY_FILE_FAILURE}
    exec_cmd cp -p "${srcScriptDir}/okerberos.sh" "${targetDir}" || return ${INS_COPY_FILE_FAILURE}
    exec_cmd cp -p "${srcScriptDir}/httpd.sh" "${targetDir}" || return ${INS_COPY_FILE_FAILURE}
    exec_cmd cp -p "${srcScriptDir}/feed_watchdog.sh" "${targetDir}" || return ${INS_COPY_FILE_FAILURE}
    # 配置告警发送工具
    targetDir="${g_omsHome}/workspace/ha/module/hacom/plugin/script"
    rm -f "${targetDir}/send_alarm.sh"    
    exec_cmd cp -p "${srcScriptDir}/send_alarm.sh" "${targetDir}" || return ${INS_COPY_FILE_FAILURE}
    rm -f "${targetDir}/sendAlarm"    
    exec_cmd cp -p "${srcScriptDir}/sendAlarm" "${targetDir}" || return ${INS_COPY_FILE_FAILURE}
    #双机生成HA SSL证书
    if [ "${g_haMode}" = "double" ]; then
      gen_ha_ssl_cert
      if [ $? -ne 0 ]; then
        return 1
      fi
    fi
    log_info "${LINENO}" "Succeed to config ha plugin."
    return ${INS_SUCCESS}
}

################################################################################
# Function: gen_ha_ssl_cert
# Description: 产生HA通信的SSL证书
# Parameter:
#   input:
#   N/A
#   output:
#   N/A
# Return: 0 -- success; not 0 -- failure
# Others: N/A
################################################################################
function gen_ha_ssl_cert()
{ 
   log_info "${LINENO}" "Start to generate ha SSL cert."
   
   #拷贝HA SSL根证书
   local securityHome="${g_controllerHome}/security"
   local certHADir="${securityHome}/certHA"
   userhaCertDir="${g_softwareHome}/hasslCert"
   
   
   if [ -f ${userhaCertDir}/root-ca.crt ]; then
      cp -p ${userhaCertDir}/root-ca.crt ${certHADir}/
      if [ $? -ne 0 ]; then
         log_error "${LINENO}" "Failed to copy the HA SSL root-ca.crt cert to ${g_omsHome}/workspace/ha/local/cert/."
         return 1
      fi
   fi
   if [ -f ${userhaCertDir}/root-ca.pem ]; then
      cp -p ${userhaCertDir}/root-ca.pem ${certHADir}/
      if [ $? -ne 0 ]; then
         log_error "${LINENO}" "Failed to copy the HA SSL root-ca.pem to ${g_omsHome}/workspace/ha/local/cert/."
         return 1
      fi
   fi
   #生成HA SSL用户证书
   fileCount=$(ls -l "${userhaCertDir}" | grep "^-" | wc -l )
   if [ -f ${userhaCertDir}/hasslCert.ini -a ${fileCount} -gt 1 ]; then
      ha_ssl_cert_pwd=$(cat ${userhaCertDir}/hasslCert.ini | cut -d '=' -f2- | sed 's/^[[:space:]]*//g;s/[[:space:]]*$//g')
   else
      g_certHAConf="${g_controllerHome}/security/certHA/conf/certHA.ini"
      HA_SSL_CERT_PWD="$(cat ${g_certHAConf} | grep '^HA_SSL_CERT_DEFAULT_PWD=' | cut -d '=' -f2-)"
      ha_ssl_cert_pwd=$(getDecryptWord ${HA_SSL_CERT_PWD} AES256)
      
      #安全要求需要重新加解密存放，使用CBC加解密
      ha_cert_defult_pwd=$(getEncryptWord "${ha_ssl_cert_pwd}" AES256_CBC_IGNORE_KEY)
      sed -i "s/HA_SSL_CERT_DEFAULT_PWD=$HA_SSL_CERT_PWD/HA_SSL_CERT_DEFAULT_PWD=$ha_cert_defult_pwd/g" $g_certHAConf > /dev/null 2>&1
      if [ $? -ne 0 ]; then
        log_error "${LINENO}" "Failed to save the HA SSL default passwd."
        return 1
      fi
   fi
   encrypt_passwd=$(echo $(${g_omsHome}/workspace/ha/module/hacom/tools/key-tool -e "${ha_ssl_cert_pwd}") | cut -d ':' -f2- | sed 's/^[[:space:]]*//g;s/[[:space:]]*$//g')
   ${g_omsHome}/workspace/ha/module/hacom/script/gen-cert.sh --server-ca --country=CN --state=guangdong --city=shenzhen --company=huawei --organize=IT --common-name="${g_localIp}" --IP-DNS="DNS:$(hostname)" --root-ca-file=${certHADir}/root-ca.crt --root-key-file=${certHADir}/root-ca.pem --server-ca-file=${certHADir}/server.crt --server-key-file=${certHADir}/server.pem > /dev/null 2>&1 <<EOF
${ha_ssl_cert_pwd}
${ha_ssl_cert_pwd}
EOF
   if [ $? -ne 0 ]; then
      log_error "${LINENO}" "Failed to generate the HA SSL user cert."
      return 1
   fi
   #修改HA SSL证书权限
   chmod 600 ${g_omsHome}/workspace/ha/local/cert/root.key
   chown ${OMM_USER}:${OMM_USER_GROUP} ${g_omsHome}/workspace/ha/local/cert/root.key
   chmod 700 ${securityHome}
   chown ${OMM_USER}:${OMM_USER_GROUP} ${securityHome}
   chmod 700 ${certHADir} -R
   chmod 600 ${certHADir}/* -R
   chmod 700 ${certHADir}/conf
   chown ${OMM_USER}:${OMM_USER_GROUP} ${certHADir} -R
   #配置证书参数信息
   ${g_omsHome}/workspace/ha/module/hacom/script/config_ha.sh -q false -S ssl=true,twoway=true,rootca=${certHADir}/root-ca.crt,serverca=${certHADir}/server.crt,serverkey=${certHADir}/server.pem,keypass=${encrypt_passwd}  >> "${g_logFile}" 2>&1
   if [ $? -ne 0 ]; then
      log_error "${LINENO}" "Failed to config the HA SSL."
      return 1
   fi
   log_info "${LINENO}" "Succeed to generate ha SSL cert."
}

################################################################################
# Function: config_omm
# Description: 配置omm
# Parameter:
#   input:
#   N/A
#   output:
#   N/A
# Return: 0 -- success; not 0 -- failure
# Others: N/A
################################################################################
config_omm()
{
    log_info "${LINENO}" "Start to config omm."

    # 配置ha插件
    config_ha_plugin
    retVal=$?
    if [ ${retVal} -ne 0 ] ; then
        showLog_error "${LINENO}" "Failed to config ha plugins."
        return ${retVal}
    fi

    # 配置OMS
    local targetFile="${g_omsHome}/workspace/conf/oms-config.ini"
    exec_cmd cp -p "${g_omsConfigFile}" "${targetFile}" > /dev/null 2>&1 || return ${INS_COPY_FILE_FAILURE}
    sudo ${INSTALL_SUDO_PATH} exec_omm_cmd "${g_omsHome}/tools/omsconfig.sh -f ${targetFile}" > /dev/null 2>&1
    if [ $? -ne 0 ]; then
        showLog_error "${LINENO}" "Failed to config OMS."
        return ${INS_CONFIG_OMS_FAILURE}
    fi

    # 设置主controller宕机，备controller等待升主的时间
    set_ha_dead_time 31
    retVal=$?
    if [ ${retVal} -ne 0 ] ; then
        showLog_error "${LINENO}" "Failed to set ha dead time."
        return ${retVal}
    fi
    # 设置CEP进程启动参数，当机器內存小于10G时，进程启动內存参数修改为4G
    cepConfigFile="${g_omsHome}/workspace/bin/omm_s_cep_ctl.sh"
    memTotal=$(free -m |grep Mem | awk  '{print $2}'| sed "s/[[:space:]]/_/g")
    if [ "${memTotal}" -lt "${g_criticalValueMem}" ]; then
        sed -i "s/-Xmx[0-9]*m/-Xmx${g_littleMem}m/g" "${cepConfigFile}" >> ${g_logFile} 2>&1
        retVal=$?
        if [ ${retVal} -ne 0 ]; then
           showLog_error "${LINENO}" "Failed to config cep memory parameter."
               return ${retVal}
        fi
    fi
    log_info "${LINENO}" "Succeed to config omm."
    return ${INS_SUCCESS}
}

################################################################################
# Function: config_crontab
# Description: 把审计加到crontab中
# Parameter:
#   input:
#   N/A
#   output:
#   N/A
# Return: 0 -- success; not 0 -- failure
# Others: N/A
################################################################################
config_crontab()
{
    log_info "${LINENO}" "Start config crontab."
    if [ "$g_operatorType" = "$UPGRADE_OPERATOR" ]; then
        log_info "${LINENO}" "UPGRADE, no need to config crontab."
        return 0
    fi

    sudo ${INSTALL_SUDO_PATH} config_crontab "${CRONTAB_FILE}" "${CRON_SERVICE_NAME}" >> "${g_logFile}" 2>&1
    retVal=$?
    if [ ${retVal} -ne 0 ] ; then
        showLog_error "${LINENO}" "Failed to config crontab."
        return ${retVal}
    fi
    log_info "${LINENO}" "Succeed to config crontab."
    return ${INS_SUCCESS}
}

################################################################################
# Function: config_common_workspace
# Description: 更新common工作区配置版本配套文件，生成版本文件相关信息
# Parameter:
#   input:
#   N/A
#   output:
#   N/A
# Return: 0 -- success; not 0 -- failure
# Others: N/A
################################################################################
config_common_workspace()
{
    update_common_mapping ${g_bigdataCommonWorkspace} ${g_version} || return 1
    local common_release="${g_bigdataCommonWorkspace}/${RELEASE_CONF_FILENAME}"
    echo -e "SECURITY_VERSION=${SECURITY_VERSION}" > "${common_release}"
    echo -e "JAVA_VERSION=${JAVA_VERSION}" >> "${common_release}"
    chmod 600 "${common_release}" >> "$g_logFile" 2>&1
    return 0
}
################################################################################
# Function: init_common_workspace
# Description: 初始化common工作区
# Parameter:
#   input:
#   N/A
#   output:
#   N/A
# Return: 0 -- success; not 0 -- failure
# Others: N/A
################################################################################
init_common_workspace()
{
    #安装时创建common工作区，切换软连接
    if [ "$g_operatorType" != "$UPGRADE_OPERATOR" ]; then
        g_bigdataCommonWorkspace="${g_bigdataCommonHome}/${COMMON_WORKSPACE_NAME_0}"
        log_debug "${LINENO}" "g_bigdataCommonWorkspace=${g_bigdataCommonWorkspace}."
        mkdir -p ${g_bigdataCommonWorkspace}
        [ -L "${g_bigdataCommon}" ] &&  rm -rf "${g_bigdataCommon}"
        ln -sf "${g_bigdataCommonWorkspace}" "${g_bigdataCommon}"
        config_common_workspace || return 1
        exec_cmd mv "${g_controllerHome}"/common_tools "${g_bigdataCommonWorkspace}"/tools || return 1 
        return 0
    fi
    #升级场景
    is_update_common_resource "${g_controllerConfHome}/${RELEASE_CONF_FILENAME}" "${g_bigdataCommon}/${RELEASE_CONF_FILENAME}"
    ret=$?
    if [ $ret -eq $INS_PARSE_CONFIG_FAILURE ]; then
        log_info $LINENO "Check whether need to upgrade the common workspace failed."
        return $ret
    elif [ $ret -eq 1 ]; then
        g_isUpdateCommonWorkspace="false"
        g_bigdataCommonWorkspace="$(readlink -f ${g_bigdataCommon})"
        log_debug $LINENO "g_bigdataCommonWorkspace=${g_bigdataCommonWorkspace}"
        log_info $LINENO "The common workspace resource version is not updated, skip the upgrade."
        return 0
    else
        log_info $LINENO "Upgraded installation deployment, Need to deploy the new common workspace."
    fi
    #初始化g_bigdataCommonWorkspace    
    local curCommonWorkspaceName="$(basename $(readlink -f ${g_bigdataCommon}))"
    if [ "${curCommonWorkspaceName}" = "${COMMON_WORKSPACE_NAME_0}" ]; then
        g_bigdataCommonWorkspace="${g_bigdataCommonHome}/${COMMON_WORKSPACE_NAME_1}"
    else
        g_bigdataCommonWorkspace="${g_bigdataCommonHome}/${COMMON_WORKSPACE_NAME_0}"
    fi
    log_debug "${LINENO}" "g_bigdataCommonWorkspace=${g_bigdataCommonWorkspace}."
    
    #创建common工作区并修改权限
    exec_cmd mkdir -p ${g_bigdataCommonWorkspace} -m 750 || return $?
    sudo $INSTALL_SUDO_PATH restrict_chown -R "${OMM_USER}:${FI_COMMON_GROUP}" "${g_bigdataCommonWorkspace}" >> ${g_logFile} 2>&1 || return $?
    
    config_common_workspace || return 1
    exec_cmd mv "${g_controllerHome}"/common_tools "${g_bigdataCommonWorkspace}"/tools || return 1
}
################################################################################
# Function: init_global_param
# Description: 初始化全局变量
# Parameter:
#   input:
#   N/A
#   output:
#   N/A
# Return: 0 -- success; not 0 -- failure
# Others: N/A
################################################################################
init_global_param()
{
    log_info "${LINENO}" "Initialize global parameter value."

    # 初始化g_controllerHome
    g_controllerHome="$(dirname "${g_curPath}")"
    log_debug "${LINENO}" "g_controllerHome=${g_controllerHome}."

    # 初始化 om sever 安装的工作区目录
    g_omServerWorkspace="$(dirname "${g_controllerHome}")"
    log_debug "${LINENO}" "g_omServerWorkspace=${g_omServerWorkspace}."
    
    # 初始化g_bigdataHome
    g_bigdataHome="$(dirname "${g_omServerWorkspace}")"
    log_debug "${LINENO}" "g_bigdataHome=${g_bigdataHome}."
    
    # 初始化 om agent
    g_omAgentHome="${g_bigdataHome}/${OM_AGENT_HOME_NAME}"
    log_debug "${LINENO}" "g_omAgentHome=${g_omAgentHome}."

    local omServerWorkspaceName="$(basename "${g_omServerWorkspace}")"
    log_debug "${LINENO}" "omServerWorkspaceName=${omServerWorkspaceName}."

    local omServerVersion=${omServerWorkspaceName#*om-server_}
    log_debug "${LINENO}" "omServerVersion=${omServerVersion}."

    g_omAgentWorkspace="${g_omAgentHome}_${omServerVersion}"
    log_debug "${LINENO}" "g_omAgentWorkspace=${g_omAgentWorkspace}."

    # 初始化g_bigdataHome
    g_omServerHome="${g_bigdataHome}/${OM_SERVER_HOME_NAME}"
    log_debug "${LINENO}" "g_omServerHome=${g_omServerHome}."

    # 初始化g_bigdataCommon
    g_bigdataCommonHome="${g_bigdataHome}/${COMMON_HOME_NAME}"
    g_bigdataCommon="${g_bigdataCommonHome}/${COMMON_WORKSPACE_NAME}"
    log_debug "${LINENO}" "g_bigdataCommon=${g_bigdataCommon}."

    g_version="$(cat ${g_omServerWorkspace}/om/etc/om/VERSION)"
    g_omsServerWorkspaceName="${OM_SERVER_HOME_NAME}_${g_version}"
    log_debug "${LINENO}" "g_omsServerWorkspaceName=${g_omsServerWorkspaceName}."

    g_controllerConfHome="${g_omServerWorkspace}/om/etc/om"
    init_common_workspace || return 1

    # 初始化g_omsDbDataHome
    g_omsDbDataHome="${g_bigdataDataHome}/${DB_CTL_DIR}"
    log_debug "${LINENO}" "g_omsDbDataHome=${g_omsDbDataHome}."

    # 初始化g_omsInsFileName
    g_omsPackageName="$(ls "${g_controllerHome}/omm" | grep '^OMS.*\.tar$')"
    if [ "$(echo "${g_omsPackageName}" | wc -w)" != "1" ] ; then
        showLog_error "${LINENO}" "The OMS installation package in the ${g_controllerHome}/omm path is not unique."
        return ${INS_FILE_NOT_UNIQUE}
    fi
    g_omsInsFileName="${g_controllerHome}/omm/${g_omsPackageName}"
    log_debug "${LINENO}" "g_omsInsFileName=${g_omsInsFileName}."

    g_omsHome="${OMS_INSTALL_DIRNAME}"
    g_omsHome="${g_omServerWorkspace}/${g_omsHome}"
    log_debug "${LINENO}" "g_omsHome=${g_omsHome}."

    # 初始化g_omsConfigFile
    g_omsConfigFile="${g_controllerHome}/inst/conf/oms-config.ini"
    log_debug "${LINENO}" "g_omsConfigFile=${g_omsConfigFile}."

    # 初始化g_wsFloatIP，该变量值已在软件安装包里的install.sh里计算出来，并且写到了
    # ${g_controllerHome}/inst/conf/oms-config.ini文件里了，这里直接读出来即可
    g_wsFloatIP="$(get_key_value "${HA}" "${WS_FLOAT_IP}" "${g_omsConfigFile}")"
    retVal=$?
    log_debug "${LINENO}" "g_wsFloatIP=${g_wsFloatIP}."
    if [ ${retVal} -ne 0 ] ; then
        log_error "${LINENO}" "Failed to get the g_wsFloatIP parameter value."
        return ${retVal}
    fi

    # 初始化g_wsFloatIPNetmask
    g_wsFloatIPNetmask="$(get_key_value "${HA}" "${WS_FLOAT_IP_NETMASK}" "${g_omsConfigFile}")"
    retVal=$?
    log_debug "${LINENO}" "g_wsFloatIPNetmask=${g_wsFloatIPNetmask}."
    if [ ${retVal} -ne 0 ] ; then
        log_error "${LINENO}" "Failed to get the g_wsFloatIPNetmask parameter value."
        return ${retVal}
    fi

    # 初始化g_wsFloatIPInterface
    g_wsFloatIPInterface="$(get_key_value "${HA}" "${WS_FLOAT_IP_INTERFACE}" "${g_omsConfigFile}")"
    retVal=$?
    log_debug "${LINENO}" "g_wsFloatIPInterface=${g_wsFloatIPInterface}. ${WS_FLOAT_IP_INTERFACE}"
    if [ ${retVal} -ne 0 ] ; then
        log_error "${LINENO}" "Failed to get the g_wsFloatIPInterface parameter value."
        return ${retVal}
    fi

    # 初始化g_wsGateway
    g_wsGateway="$(get_key_value "${HA}" "${WS_GATEWAY}" "${g_omsConfigFile}")"
    retVal=$?
    log_debug "${LINENO}" "g_wsGateway=${g_wsGateway}."
    if [ ${retVal} -ne 0 ] ; then
        log_error "${LINENO}" "Failed to get the g_wsGateway parameter value."
        return ${retVal}
    fi

    # 初始化g_omFloatIP
    g_omFloatIP="$(get_key_value "${HA}" "${OM_FLOAT_IP}" "${g_omsConfigFile}")"
    retVal=$?
    log_debug "${LINENO}" "g_omFloatIP=${g_omFloatIP}."
    if [ ${retVal} -ne 0 ] ; then
        log_error "${LINENO}" "Failed to get the g_omFloatIP parameter value."
        return ${retVal}
    fi

    # 初始化g_localIp
    g_localIp="$(get_key_value "${HA}" "server1_ip1" "${g_omsConfigFile}")"
    retVal=$?
    log_debug "${LINENO}" "g_localIp=${g_localIp}."
    if [ ${retVal} -ne 0 ] ; then
        log_error "${LINENO}" "Failed to get the g_localIp parameter value."
        return ${retVal}
    fi

    # 初始化g_peerIp
    g_peerIp="$(get_key_value "${HA}" "server2_ip1" "${g_omsConfigFile}")"
    retVal=$?
    log_debug "${LINENO}" "g_peerIp=${g_peerIp}."
    if [ ${retVal} -ne 0 ] ; then
        log_error "${LINENO}" "Failed to get the g_peerIp parameter value."
        return ${retVal}
    fi
    # 单机的情况
    if [ "x${g_peerIp}" = "x" ] ; then
       g_peerIp=${g_localIp}
    fi

    # 初始化 g_omFloatIp
    g_omFloatIp="$(get_key_value "${HA}" "om_float_ip" "${g_omsConfigFile}")"
    retVal=$?
    log_debug "${LINENO}" "g_omFloatIp=${g_omFloatIp}."
    if [ ${retVal} -ne 0 ] ; then
        log_error "${LINENO}" "Failed to get the g_omFloatIp parameter value."
        return ${retVal}
    fi
    # 单机的情况
    if [ "x${g_omFloatIp}" = "x" ] ; then
       g_omFloatIp=${g_localIp}
    fi
    # 初始化g_omFloatIPNetmask
    g_omFloatIPNetmask="$(get_key_value "${HA}" "${OM_FLOAT_IP_NETMASK}" "${g_omsConfigFile}")"
    retVal=$?
    log_debug "${LINENO}" "g_omFloatIPNetmask=${g_omFloatIPNetmask}."
    if [ ${retVal} -ne 0 ] ; then
        log_error "${LINENO}" "Failed to get the g_omFloatIPNetmask parameter value."
        return ${retVal}
    fi

    # 初始化g_omFloatIPInterface
    g_omFloatIPInterface="$(get_key_value "${HA}" "${OM_FLOAT_IP_INTERFACE}" "${g_omsConfigFile}")"
    retVal=$?
    log_debug "${LINENO}" "g_omFloatIPInterface=${g_omFloatIPInterface}."
    if [ ${retVal} -ne 0 ] ; then
        log_error "${LINENO}" "Failed to get the g_omFloatIPInterface parameter value."
        return ${retVal}
    fi

    # 初始化g_omGateway
    g_omGateway="$(get_key_value "${HA}" "${OM_GATEWAY}" "${g_omsConfigFile}")"
    retVal=$?
    log_debug "${LINENO}" "g_omGateway=${g_omGateway}."
    if [ ${retVal} -ne 0 ] ; then
        log_error "${LINENO}" "Failed to get the g_omGateway parameter value."
        return ${retVal}
    fi

    # 初始化g_haMode
    g_haMode="$(get_key_value "${HA}" "${HA_MODE}" "${g_omsConfigFile}")"
    retVal=$?
    log_debug "${LINENO}" "g_haMode=${g_haMode}."
    if [ ${retVal} -ne 0 ] ; then
        log_error "${LINENO}" "Failed to get the g_haMode parameter value."
        return ${retVal}
    fi

    # 初始化g_ntpServerIP
    g_ntpServerIP="$(get_key_value "${HA}" "${NTP_SERVER_IP}" "${g_omsConfigFile}")"
    retVal=$?
    log_debug "${LINENO}" "g_ntpServerIP=${g_ntpServerIP}."
    if [ ${retVal} -ne 0 ] ; then
        log_error "${LINENO}" "Failed to get the g_ntpServerIP parameter value."
        return ${retVal}
    fi

    #初始化g_ssoServerIP
    g_ssoServerIP="$(get_key_value "${HA}" "${SSO_SERVER_IP}" "${g_omsConfigFile}")"
    retVal=$?
    log_debug "${LINENO}" "g_ssoServerIP=${g_ssoServerIP}."

    #初始化g_ssoServerPort
    if [ ${retVal} -eq 0 ] ; then
        g_ssoServerPort="$(get_key_value "${HA}" "${SSO_SERVER_PORT}" "${g_omsConfigFile}")"
        retVal=$?
        log_debug "${LINENO}" "g_ssoServerPort=${g_ssoServerPort}."
        if [ ${retVal} -ne 0 ] ; then
            log_error "${LINENO}" "Failed to get the g_ssoServerPort parameter value."
            return ${retVal}
        fi

    fi

    #如果ssoip为空，则说明是独立部署，需要将该值赋值为wsip,端口固定填写为8443
    if [ "${g_ssoServerIP}" == "" ]; then
      g_ssoServerIP=${g_wsFloatIP}
      g_ssoServerPort=${g_defaultcasserverPort}
    fi

    #根据os类型 cpu类型初始化分发包平台子目录
    g_packageDistributeSubdir="${g_os_type}-${g_cpu_type}"

    #初始化 g_controller_sftp_url
    g_controller_sftp_url="${g_omFloatIp}\:${g_omServerWorkspace}/${CONTROLLER_HOME_NAME}/packaged-distributables/${g_packageDistributeSubdir}"
    retVal=$?
    log_debug "${LINENO}" "g_controller_sftp_url=${g_controller_sftp_url}."
    if [ ${retVal} -ne 0 ] ; then
        log_error "${LINENO}" "Failed to get the g_controller_sftp_url parameter value."
        return ${retVal}
    fi
    
    # 初始化g_tls_protocol_min
    g_tls_protocol_min="$(get_key_value "${HA}" "tls_protocol_min" "${g_omsConfigFile}")"
    retVal=$?
    log_debug "${LINENO}" "tls_protocol_min=${g_tls_protocol_min}."
    if [ ${retVal} -ne 0 ] ; then
        log_error "${LINENO}" "Failed to get the tls_protocol_min parameter value."
        return ${retVal}
    fi
    
    g_tomcatclassespath="${g_omServerWorkspace}/${TOMCAT_INSTALL_DIR}/webapps/web/WEB-INF/classes"            # explanatory
    g_oms_config_path="${g_controllerHome}/etc/om/omsconfig"
    g_oms_configmodle_path="${g_controllerHome}/etc/om/omsconfigmodle"
    g_securityconfigmodlePath=${g_oms_configmodle_path}/securityconfig/security-context.xml
    g_kentab_path="${g_controllerHome}/meta-0.0.1-SNAPSHOT/kerberos/scripts/genkeytab.sh"
    g_changepw_file_path="${g_omServerWorkspace}/${TOMCAT_INSTALL_DIR}/webapps/cas/WEB-INF/view/jsp/default/ui/casChangePasswordView.jsp"
    g_cas_error_path="${g_omServerWorkspace}/${TOMCAT_INSTALL_DIR}/webapps/cas/WEB-INF/view/jsp/errors.jsp"

    if [ -z ${BIGDATA_SUDO_HOME} ]; then
        BIGDATA_SUDO_HOME="/var/lib/sudo/Bigdata"
    fi
    log_info "${LINENO}" "Succeed to initialize global parameter value."
    return ${INS_SUCCESS}
}

################################################################################
# Function: check_input_param
# Description: 校验输入参数是否合法
# Parameter:
#   input:
#   $1 -- g_bigdataDataHome Bigdata数据存放根目录
#   output:
#   N/A
# Return: 0 -- success; not 0 -- failure
# Others: N/A
################################################################################
check_input_param()
{
    log_debug "${LINENO}" "Validate the input parameter."

    # 判断输入参数是否为空
    if [ -z "${g_bigdataDataHome}" ] ; then
        log_error "${LINENO}" "The input parameter is empty."
        return ${INS_DEBUG_ERROR}
    fi

    # 判断输入的参数是否是目录
    if [ ! -d "${g_bigdataDataHome}" ] ; then
        log_error "${LINENO}" "The ${g_bigdataDataHome} directory do not exist."
        return ${INS_DEBUG_ERROR}
    fi
    log_debug "${LINENO}" "Succeed to validate the input parameter."
    return ${INS_SUCCESS}
}

################################################################################
# Function: install_oms
# Description: install oms
# Parameter:
#   input:
#   N/A
#   output:
#   N/A
# Return: 0 -- success; not 0 -- failure
# Others: N/A
################################################################################
install_oms()
{
    log_info "${LINENO}" "Start to install oms."

    #配置perl的目录，用于规避初次切换用户时，自动创建perl5目录导致GaussDB安装失败的问题
    sudo ${INSTALL_SUDO_PATH} configPerlHome  >> "${g_logFile}" 2>&1
    if [ $? -ne 0 ] ; then
        showLog_error "${LINENO}" "Failed to modify /etc/profile.d/perl-homedir.sh."
        return ${INS_DEBUG_ERROR}
    fi
    
    # 把OMS安装包解压到临时目录里
    local tmpDir="${g_bigdataHome}/tmp/omsInstallFile"
    exec_cmd rm -rf "${tmpDir}"
    exec_cmd mkdir -p "${tmpDir}" || return ${INS_CREATE_FILE_FAILURE}
    
    log_info "${LINENO}" "g_omsInsFileName : ${g_omsInsFileName}"
    log_info "${LINENO}" "tmpDir : ${tmpDir}"
    
    exec_cmd tar -xf "${g_omsInsFileName}" -C "${tmpDir}"
    if [ $? -ne 0 ] ; then
        showLog_error "${LINENO}" "Failed to decompress the ${g_omsInsFileName} file."
        return ${INS_DECOMPRESS_FAILURE}
    fi

    local omsPackageName="$(basename "${g_omsPackageName%.tar}")"
    #修改端口号
    local modifyPortScript="${g_curPath}/modifyOmmServerPort.sh"
    chmod 700 $modifyPortScript
    $modifyPortScript "${tmpDir}/${omsPackageName}/package/product_adapter.properties" >> "${g_logFile}" 2>&1

    #安装omm_sudoExecute.sh    
    log_info "${LINENO}" "src path : ${tmpDir}/${omsPackageName}/package/setup/omm_sudoExecute.sh"
    log_info "${LINENO}" "target path : ${BIGDATA_SUDO_HOME}/sudo/install/components/omm_sudoExecute.sh"
    sudo ${INSTALL_SUDO_PATH} cp_sudo_file "${tmpDir}/${omsPackageName}/package/setup/omm_sudoExecute.sh" "${BIGDATA_SUDO_HOME}/sudo/install/components/"

    # 执行OMS安装脚本
    local installScript="${tmpDir}/${omsPackageName}/install.sh"
    sudo ${INSTALL_SUDO_PATH} chmod_oms_install_script >> "${g_logFile}" 2>&1
    if [ "$g_operatorType" = "$UPGRADE_OPERATOR" ]; then
        exec_cmd "${installScript}" -p "${g_omsHome}" -u "${OMM_USER}" -g "${OMM_USER_GROUP}" -h "${OMM_USER_HOME}" -d "${g_bigdataDataHome}/${DB_OM_DIR}" -du "${DB_CREATER}" -l "${g_logHome}" -t "$g_bigdataHome/tmp" -k "$g_bigdataCommon/security/keystore/keystore.xml" -x "$g_bigdataCommon/security/rp/rkc1;$g_bigdataCommon/security/rkp/rk2;$g_bigdataCommon/security/rk3d/k3" -m "${UPGRADE_OPERATOR}" -n 2500 -e "${g_bigdataCommonWorkspace}/.common_profile"
        retVal=$?
        log_info "${LINENO}" "UPGRADE, upgrade oms, install oms."
    else
        exec_cmd "${installScript}" -p "${g_omsHome}" -u "${OMM_USER}" -g "${OMM_USER_GROUP}" -h "${OMM_USER_HOME}" -d "${g_bigdataDataHome}/${DB_OM_DIR}" -du "${DB_CREATER}" -l "${g_logHome}" -t "$g_bigdataHome/tmp" -k "$g_bigdataCommon/security/keystore/keystore.xml" -x "$g_bigdataCommon/security/rp/rkc1;$g_bigdataCommon/security/rkp/rk2;$g_bigdataCommon/security/rk3d/k3" -n 2500 -e "${g_bigdataCommonWorkspace}/.common_profile"
        retVal=$?
    fi
    # 删除掉存放OMS安装包的临时目录
    exec_cmd rm -rf "${tmpDir}"
    if [ ${retVal} -ne 0 ]; then
        log_error "${LINENO}" "Failed to install OMS installation package."
        log_error "${LINENO}" "For details about the error, see the log file ${g_logHome}/omm/oms/install_oms.log."
        return ${INS_INSTALL_OMS_FAILURE}
    fi
 
    #区分用户执行任务特性，修改文件属组为${FI_COMMON_GROUP}
    sudo ${INSTALL_SUDO_PATH} security_file_chown_omm_wheel  "${g_logFile}" >> "${g_logFile}" 2>&1 || return ${INS_MODIG_AUTHORITY_FAILURE}
    
    # 修改证书目录下文件权限为600
    chmod 600 ${g_controllerHome}/security/cert/root/*
    chmod 600 ${g_controllerHome}/security/cert/subcert/certFile/*
    
    log_info "${LINENO}" "Succeed to install oms."
    
    #创建/opt/huawei/Bigdata/components目录，保证不注册任何部件的情况下controller也能启动成功
    local cmpsDir="${g_bigdataHome}/components"
    if [ ! -d "${cmpsDir}" ]; then
        sudo ${INSTALL_SUDO_PATH} exec_omm_cmd mkdir ${cmpsDir} || return ${INS_CREATE_FILE_FAILURE}
    fi
    
    return ${INS_SUCCESS}
}

##############################################################
## @Usage getEncryptKey
## @Return 明 文
## @Description OMS方法for  root
##############################################################
getDecryptWord()
{
    source ${g_bigdataCommonWorkspace}/.common_profile
    
    local STR_SRC="${1}"
    local encType="${2}"
    local KEY=""    

    local wcc=$(find ${g_controllerHome}/share/om/controller/lib/ -maxdepth 1 -name wc2frm*.jar)
    local log4j=$(find ${g_controllerHome}/share/om/controller/lib -maxdepth 1 -name log4j*.jar)
    local commons=$(find ${g_controllerHome}/share/om/controller/lib -maxdepth 1 -name commons-codec*.jar)
    local javaArgs="-Dbeetle.application.home.path=${WCC_PROFILE_DIR}"
    local classpath="${wcc}:${log4j}:${commons}:${g_controllerHome}/tools/main.jar"
    local className="com.omm.encrypt.DecryptCommandWithoutParam"
    local javaCommand="${JAVA_HOME}/bin/java -cp ${classpath} ${javaArgs} ${className}"

    if [ "$(id -u)" -eq 0 ]; then
        su - "${OMM_USER}" -c "$javaCommand <<EOF
strSrc:$STR_SRC
encType:$encType
key:$KEY
EOF
"
        if [ $? -ne 0 ]; then
           log_error "${LINENO}" "Failed to execute the command."
           return 1
        fi
    fi
    if [ "$(id -un)" == "${OMM_USER}" ]; then
        $javaCommand <<EOF
strSrc:$STR_SRC
encType:$encType
key:$KEY
EOF
        if [ $? -ne 0 ]; then
           log_error "${LINENO}" "Failed to execute the command with ${OMM_USER}."
           return 1
        fi
    fi
}

##############################################################
## @Usage getEncryptKey
## @Return 明 文
## @Description OMS方法for  root
##############################################################
getEncryptWord()
{
    source "${g_bigdataCommonWorkspace}"/.common_profile
    local JAVA_HOME=$(sudo ${INSTALL_SUDO_PATH} get_omm_env JAVA_HOME)
    
    local STR_SRC="${1}"
    local encType="${2}"
    local KEY=""
    
    local wcc=$(find ${g_controllerHome}/share/om/controller/lib/ -maxdepth 1 -name wc2frm*.jar)
    local log4j=$(find ${g_controllerHome}/share/om/controller/lib -maxdepth 1 -name log4j*.jar)
    local commons=$(find ${g_controllerHome}/share/om/controller/lib -maxdepth 1 -name commons-codec*.jar)
    local javaArgs="-Dbeetle.application.home.path=${WCC_PROFILE_DIR}"
    local classpath="${wcc}:${log4j}:${commons}:${g_controllerHome}/tools/main.jar"
    local className="com.omm.encrypt.EncryptCommandWithoutParam"
    local javaCommand="${JAVA_HOME}/bin/java -cp ${classpath} ${javaArgs} ${className}"
     
    if [ "$(id -u)" -eq 0 ]; then
        su - "${OMM_USER}" -c "$javaCommand <<EOF
strSrc:$STR_SRC
encType:$encType
key:$KEY
EOF
"
        if [ $? -ne 0 ]; then
           log_error "${LINENO}" "Failed to execute the command."
           return 1
        fi
    fi
    if [ "$(id -un)" == "${OMM_USER}" ]; then
        $javaCommand <<EOF
strSrc:$STR_SRC
encType:$encType
key:$KEY
EOF
        if [ $? -ne 0 ]; then
           log_error "${LINENO}" "Failed to execute the command with ${OMM_USER}."
           return 1
        fi
    fi
}

################################################################################
# Function: replace_changepw_file
# Description: 替换模板中的默认配置项
# Parameter:
#   input:
#   N:A
#   output:
#   N:A
# Return: 0 -- success; not 0 -- failure
# Others: N:A
################################################################################
replace_changepw_file()
{
    log_debug "${LINENO}" "start to replace change password file."

    sed -i "s:#om_float_ip#:${g_wsFloatIP}:g"  `grep "#om_float_ip#" -rl $g_changepw_file_path`
    sed -i "s:#default_port#:${g_webserver_port}:g"  `grep "#default_port#" -rl $g_changepw_file_path`
    sed -i "s:#om_float_ip#:${g_wsFloatIP}:g"  `grep "#om_float_ip#" -rl $g_cas_error_path`
    sed -i "s:#default_port#:${g_webserver_port}:g"  `grep "#default_port#" -rl $g_cas_error_path`
}

################################################################################
# Function: export_env_variable
# Description: 设置omm用户的环境变量
# Parameter:
#   input:
#   N/A
#   output:
#   N/A
# Return: 0 -- success; not 0 -- failure
# Others: N/A
################################################################################
export_env_variable()
{
    log_debug "${LINENO}" "Export environment variable."

    if [ ! -f "${OMM_USER_HOME}/.profile" ] ; then
        touch "${OMM_USER_HOME}/.profile" || return ${INS_WRITE_FILE_FAILURE}
        chmod 640 "${OMM_USER_HOME}/.profile"
    fi

    profileFile="${g_omServerHome}/.controller_profile"
    log_debug "${LINENO}" "Export environment variable. ${profileFile}"
    # 如果${OMM_USER_HOME}/.profile中没有source全局变量配置文件，则增加
    grep "^source[[:space:]]*${profileFile}[[:space:]]*$" "${OMM_USER_HOME}/.profile" >> "${g_logFile}" 2>&1
    if [ $? -ne 0 ] ; then
        echo "source ${profileFile}" >> "${OMM_USER_HOME}/.profile" || return ${INS_WRITE_FILE_FAILURE}
    fi
    
    #把${OMM_USER_HOME}/.profile增加到${OMM_USER_HOME}/.bashrc文件中
    if [ -f "${OMM_USER_HOME}/.bashrc" ] ; then
        grep "^source[[:space:]]*${OMM_USER_HOME}/.profile[[:space:]]*$" "${OMM_USER_HOME}/.bashrc" >> "${g_logFile}" 2>&1
        if [ $? -ne 0 ] ; then
           echo "source ${OMM_USER_HOME}/.profile" >> "${OMM_USER_HOME}/.bashrc" || return ${INS_WRITE_FILE_FAILURE}
        fi
    fi

    echo "export SUDO_PATH_OMS=${BIGDATA_SUDO_HOME}/sudo/runtime/${SUDOSCRIPT}" >> "${g_omServerWorkspace}/.controller_profile" || return ${INS_WRITE_FILE_FAILURE}

    echo "export USE_EXTERNAL_NTP_OMM=${USE_EXTERNAL_NTP}" >> "${g_omServerWorkspace}/.controller_profile" || return ${INS_WRITE_FILE_FAILURE}

    #将包分发子目录设置到环境上下文中
    echo "export OS_TYPE=${g_os_type}" >> "${g_omServerWorkspace}/.controller_profile" || return ${INS_WRITE_FILE_FAILURE}
    echo "export CPU_ARCH=${g_cpu_type}" >> "${g_omServerWorkspace}/.controller_profile" || return ${INS_WRITE_FILE_FAILURE}

    if [ ! -f "${g_bigdataCommonWorkspace}/.common_profile" ]; then
        touch "${g_bigdataCommonWorkspace}/.common_profile"
    fi
    chmod 750 "${g_bigdataCommonWorkspace}/.common_profile"

    echo "export OS_TYPE=${g_os_type}" >> "${g_bigdataCommonWorkspace}/.common_profile" || return ${INS_WRITE_FILE_FAILURE}
    echo "export CPU_ARCH=${g_cpu_type}" >> "${g_bigdataCommonWorkspace}/.common_profile" || return ${INS_WRITE_FILE_FAILURE}

   #将用户dba环境编码格式改为'en_US.UTF-8'
    sudo ${INSTALL_SUDO_PATH} set_ommdba_code
    if [ $? -ne 0 ] ; then
         log_error "${LINENO}" "Failed to set ommdba code."
     return 1
    fi

    chown "${OMM_USER}":"${OMM_USER_GROUP}" "${OMM_USER_HOME}/.profile"
    chown "${OMM_USER}":"${OMM_USER_GROUP}" "${g_bigdataCommonWorkspace}/.common_profile"

    SUDO_PATH_OMS=${BIGDATA_SUDO_HOME}/sudo/runtime/${SUDOSCRIPT}
    
    chown "${OMM_USER}":"${OMM_USER_GROUP}" "${g_bigdataDataHome}/Manager/" -R >> "${g_logFile}" 2>&1
    chmod 700 "${g_bigdataDataHome}/Manager" -R >> "${g_logFile}" 2>&1

    return ${INS_SUCCESS}
}

################################################################################
# Function: waitforNtp
# Description: 主函数
# Parameter:
#   input:
#   output:
# Return: 0 -- success; not 0 -- failure
# Others: N/A
################################################################################
waitforNtp()
{
    if [ "$g_operatorType" = "$UPGRADE_OPERATOR" ]; then
        log_info "${LINENO}" "UPGRADE, no need to start ntp."
        return 0
    fi
    local -i MAX_TIMES=60
    local -i i=0

    echo -n "    Waiting for ntp to startup..."
    for ((i=0; i<MAX_TIMES; i++)) ; do
        sudo ${INSTALL_SUDO_PATH}  ntpq_np > /dev/null 2>&1
        if [ $? -ne 0 ] ; then
            sleep 10
            echo -n "."
        else
            break
        fi
    done

    echo " "
    if  [ $i -ge $MAX_TIMES ] ; then
        showLog_error "${LINENO}"  "Wait for ntp to startup timeout."
        return 1
    fi

    return ${INS_SUCCESS}
}

################################################################################
# Function: install_os_optimization
# Description: 执行OS优化脚本
# Parameter:
#   input:
#   N/A
#   output:
#   N/A
# Return: 0 -- success; not 0 -- failure
# Others: N/A
################################################################################
function install_os_optimization()
{
    log_info "${LINENO}" "The script to perform operating system optimization."

    for line in $(find ${g_controllerHome}/inst/plugin/ -maxdepth 2 -mindepth 2 -name "install.sh" 2>/dev/null)
    do
        log_info "${LINENO}" "Start execute ${line}"
        chmod 700 $line
        $line "${g_osOptimizatLogFile}" "${SUDO_PATH_OMS}" >> "${g_logFile}" 2>&1
        retVal=$?
        if [ ${retVal} -ne 0 ] ; then
            showLog_error "${LINENO}" "Failed to optimize the operating system."
            return ${INS_CREATE_FILE_FAILURE}
        fi
        log_info "${LINENO}" "execute ${line} success"
    done
    
    log_info "${LINENO}" "perform operating system optimization success"
    return ${INS_SUCCESS}
}

################################################################################
# Function: install_logman
# Description:定时日志压缩处理工具安装
# Parameter:
#   input:
#   N/A
#   output:
#   N/A
# Return: 0 -- success; not 0 -- failure
# Others: N/A
################################################################################
function install_logman()
{
    log_info "${LINENO}" "The script to install logman."
    install_logman=${g_controllerHome}/inst/logman/install.sh
    bash ${install_logman} "${g_omServerWorkspace}" "${g_logHome}" "oms"

    return $?
}

################################################################################
# Function: config_confs_pathvalue
# Description:替换配置文件中的数据目录、安装目录、日志目录的路径值
# Parameter:
#   input:
#   N/A
#   output:
#   N/A
# Return: 0 -- success; not 0 -- failure
# Others: N/A
################################################################################
function config_confs_pathvalue()
{
    local logPlaceholder="#OM_LOG_HOME#"
    local bigdataPlaceholder="#BIGDATA_HOME#"
    local bigdataDataPlaceholder="#BIGDATA_DATA_HOME#"
    local controllerHomePlaceholder="#CONTROLLER_HOME#"
    local -a targetFileList=("${g_controllerHome}/bin/tools/services.ini"
                            "${g_controllerHome}/tools/modifyip/conf/log4j.properties"
                            "${g_controllerHome}/share/om/acs/config/log4j.properties"
                            "${g_controllerHome}/share/om/aos/config/log4j.properties"
                            "${g_controllerHome}/share/om/acs/config/DBConfig.xml"
                            "${g_controllerHome}/share/om/aos/config/DBConfig.xml"
                            "${g_controllerHome}/etc/om/log4j.properties"
                            "${g_controllerHome}/etc/om/log4j.properties.DEFAULT"
                            "${g_controllerHome}/etc/om/log4j.properties.FATAL"
                            "${g_controllerHome}/etc/om/log4j.properties.INFO"
                            "${g_controllerHome}/etc/om/log4j.properties.DEBUG"
                            "${g_controllerHome}/etc/om/log4j.properties.WARN"
                            "${g_controllerHome}/etc/om/backupconfig/DBConfig.xml"
                            "${g_controllerHome}/inst/logman/logman.cfg"

                            )

    change_file_placeholder    "${logPlaceholder}" "${g_logHome}" "${targetFileList[*]}"
    change_file_placeholder    "${bigdataPlaceholder}" "${g_bigdataHome}" "${targetFileList[*]}"
    change_file_placeholder    "${bigdataDataPlaceholder}" "${g_bigdataDataHome}" "${targetFileList[*]}"
    change_file_placeholder    "${controllerHomePlaceholder}" "${g_controllerHome}" "${targetFileList[*]}"
}

################################################################################
# Function: set_install_sudo_env
# Description:设置安装sudo文件和安装用户到环境变量（${HOME}/.bashrc）
# Parameter:
#   input:
#   N/A
#   output:
#   N/A
# Return: 0 -- success; not 0 -- failure
# Others: N/A
################################################################################
function set_install_sudo_env()
{
   user_home="$HOME/.bashrc"
   user_env="$HOME/env_file"
   if [ ! -f "${user_env}" ] ; then
        touch ${user_env}
   fi
   if [ ! -f "${user_home}" ] ; then
        touch ${user_home}
   fi
   grep INSTALL_SUDO_PATH "${user_env}"  >> "${g_logFile}" 2>&1
   if [ $? -eq 0 ]; then
       sed -i '/export INSTALL_SUDO_PATH.*/d' "${user_env}"
   fi
   echo "export INSTALL_SUDO_PATH=${BIGDATA_SUDO_HOME}/sudo/install/installSudoExecute.sh" >> "${user_env}"
   if [ $? -ne 0 ]; then
      return 1
   fi
   grep INSTALL_USER "${user_env}"  >> "${g_logFile}" 2>&1
   if [ $? -eq 0 ]; then
       sed -i '/export INSTALL_USER.*/d' "${user_env}"
   fi
   echo "export INSTALL_USER=${GLOBAL_INSTALL_USER}" >> "${user_env}"
   if [ $? -ne 0 ]; then
      return 1
   fi
   grep "^source ${user_env}" ${user_home}  > /dev/null 2>&1 
   if [ $? -ne 0 ] ; then
        echo "source ${user_env}" >> ${user_home} 
   fi
   source ${user_home} > /dev/null 2>&1
   if [ $? -ne 0 ]; then
        return 1
   fi

}


################################################################################
# Function: adapter_common_group
# Description: 升级适配ficommon
# Return: 0 -- success; not 0 -- failure
# Others: N/A
################################################################################
adapter_common_group()
{
    sudo ${INSTALL_SUDO_PATH} add_user_group "${g_logFile}" >> "${g_logFile}" 2>&1
    if [ $? -ne 0 ]; then
        showLog_error "${LINENO}" "Failed to add ${FI_COMMON_GROUP} group."
        return 1
    fi

    sudo ${INSTALL_SUDO_PATH} change_user_supplementary_group "${g_logFile}" >> "${g_logFile}" 2>&1
    if [ $? -ne 0 ]; then
        showLog_error "${LINENO}" "Failed to change supplementary group of ${OMM_USER} user to ${FI_COMMON_GROUP}."
        return 1
    fi
}
################################################################################
# Function: mkdir_Manager_dir
# Description:创建Manager数据目录（eg:/srv/BigData/Manager）并设置权限
# Parameter:
#   input:
#   N/A
#   output:
#   N/A
# Return: 0 -- success; not 0 -- failure
# Others: N/A
################################################################################
mkdir_Manager_dir()
{
    log_info "${LINENO}" "start mkdir_Manager_dir, ready to check dir: ${g_bigdataDataHome}/${OM_DATA_DIR}"
    mountpoint -q "${g_bigdataDataHome}/${OM_DATA_DIR}"
    if [ $? -eq 0 ] ; then
        log_info "${LINENO}" "${OM_DATA_DIR} has mount a partion, so do not need to mkdir"
        chmod 770 ${g_bigdataDataHome}/${DB_OM_DIR}
        mkdir -p ${g_bigdataDataHome}/${OM_DATA_DIR}/${OM_DATA_UPLOAD_DIR}
        chmod 700 ${g_bigdataDataHome}/${OM_DATA_DIR}
        chmod 700 ${g_bigdataDataHome}/${OM_DATA_DIR}/${OM_DATA_UPLOAD_DIR}
        return 0
    fi

    if [ "$g_operatorType" != "$UPGRADE_OPERATOR" ]; then
        sudo ${INSTALL_SUDO_PATH} rm_manager_dataHome "${g_bigdataDataHome}/${OM_DATA_DIR}" "${g_logFile}"        
    fi
    sudo ${INSTALL_SUDO_PATH} check_dataHome_space "${g_bigdataDataHome}"
    if [ $? -eq 0 ] ; then
        log_info "${LINENO}" "${g_bigdataDataHome} is less than 50G."
        sudo ${INSTALL_SUDO_PATH} check_Manager_dataHome_type
        if [ $? -eq 0 ] ; then
            mkdir -p "${g_bigdataHome}/${OM_DATA_DIR}"
            chmod 700 "${g_bigdataHome}/${OM_DATA_DIR}"
            
            if [ "$g_operatorType" = "$UPGRADE_OPERATOR" ]; then
                sudo ${INSTALL_SUDO_PATH} copy_managerData         
            fi
            
            sudo ${INSTALL_SUDO_PATH} rm_manager_dataHome "${g_bigdataDataHome}/${OM_DATA_DIR}" "${g_logFile}"   
            if [ "$g_operatorType" != "$UPGRADE_OPERATOR" ]; then
                sudo ${INSTALL_SUDO_PATH} software_data_chown "${g_bigdataDataHome}" "${GLOBAL_INSTALL_USER}"
            fi
            sudo ${INSTALL_SUDO_PATH} exec_omm_cmd "ln -s \"${g_bigdataHome}/${OM_DATA_DIR}\" \"${g_bigdataDataHome}/${OM_DATA_DIR}\""
        fi       
    fi
    
    mkdir -p ${g_bigdataDataHome}/${DB_OM_DIR}
    chmod 770 ${g_bigdataDataHome}/${DB_OM_DIR}

    mkdir -p ${g_bigdataDataHome}/${OM_DATA_DIR}/${OM_DATA_UPLOAD_DIR}
    chmod 700 ${g_bigdataDataHome}/${OM_DATA_DIR}
    chmod 700 ${g_bigdataDataHome}/${OM_DATA_DIR}/${OM_DATA_UPLOAD_DIR}
}

################################################################################
# Function: main
# Description: 主函数
# Parameter:
#   input:
#   N/A
#   output:
#   N/A
# Return: 0 -- success; not 0 -- failure
# Others: N/A
################################################################################
main()
{
    umask 027

    # 判断安装用户
    if [ $(id -u) -eq 0 ] ; then
        GLOBAL_INSTALL_USER=${g_super_user}
    else
        if [ $(id -un) != "${INSTALL_USER}" ]; then
            echo "ERROR: The user does not have the permission to execute the script."
            return 1
        else
            GLOBAL_INSTALL_USER=$(id -un)
        fi
    fi

    # 校验输入参数是否合法
    check_input_param
    retVal=$?
    if [ ${retVal} -ne 0 ] ; then
        showLog_error "${LINENO}" "The input parameter is incorrect."
        return ${retVal}
    fi

    # 初始化各个变量
    init_global_param
    retVal=$?
    if [ ${retVal} -ne 0 ] ; then
        showLog_error "${LINENO}" "Failed to initialize parameters."
        return ${retVal}
    fi


    # 修改配置文件中的路径参数
    config_confs_pathvalue
    retVal=$?
    if [ ${retVal} -ne 0 ] ; then
        showLog_error "${LINENO}" "Failed to config configurations path values."
        return ${retVal}
    fi

    #设置安装sudo文件和安装用户到环境变量（${HOME}/.bashrc）--适配非root安装
    if [ "${GLOBAL_INSTALL_USER}" = "${g_super_user}" ]; then
        set_install_sudo_env
        retVal=$?
        if [ ${retVal} -ne 0 ] ; then
           showLog_error "${LINENO}" "Failed to export install sudo env."
           return ${retVal}
        fi
    fi

    if [ "$g_operatorType" = "$UPGRADE_OPERATOR" ]; then
        exec_cmd sed -i '/export JAVA_HOME.*/d' "${OMM_USER_HOME}/.profile"
        exec_cmd sed -i '/export JRE_HOME.*/d' "${OMM_USER_HOME}/.profile"
        exec_cmd sed -i '/.controller_profile/d' "${OMM_USER_HOME}/.profile"
    else
        # 初始化omm用户
        if [ $(id -u) -eq 0 ] ; then
            sudo ${INSTALL_SUDO_PATH} init_omm_user "${g_ommid}" "${g_logFile}" >> "${g_logFile}" 2>&1
            retVal=$?
            if [ ${retVal} -ne 0 ] ; then
               showLog_error "${LINENO}" "Failed to initialize the omm user."
               return ${retVal}
            fi
        fi
        # 初始化ommdba用户
        sudo ${INSTALL_SUDO_PATH} init_ommdba_user "${g_ommdbaid}" "${g_logFile}" >> "${g_logFile}" 2>&1
        retVal=$?
        if [ ${retVal} -ne 0 ] ; then
           showLog_error "${LINENO}" "Failed to initialize the ommdba user."
           return ${retVal}
        fi
    fi

    #创建ficommon组，修改omm/ommdba用户附属组
    adapter_common_group
    if [ $? -ne 0 ] ; then
        showLog_error "${LINENO}" "Failed to adapter common group."
        return 1
    fi

    #创建Manager数据目录（eg:/srv/BigData/Manager）并设置权限
    mkdir_Manager_dir
    
    #创建${g_omServerWorkspace}/tmp
    omServer_tmp_dir="${g_omServerWorkspace}/tmp"
    exec_cmd mkdir -p "${omServer_tmp_dir}"
    retVal=$?
    if [ ${retVal} -ne 0 ] ; then
        showLog_error "${LINENO}" "Failed to create the g_omServerWorkspace tmp dir."
        return ${retVal}
    fi
    chmod 1770 ${omServer_tmp_dir}

    tmp_dir="${g_bigdataHome}/tmp"
    exec_cmd mkdir -p "${tmp_dir}"
    retVal=$?
    if [ ${retVal} -ne 0 ] ; then
        showLog_error "${LINENO}" "Failed to create the tmp dir."
        return ${retVal}
    fi
    chmod 1770 ${tmp_dir}

    #创建${g_omServerWorkspace}/tmp
    packageDistributableHome="${g_bigdataHome}/packaged-distributables/${g_packageDistributeSubdir}"
    exec_cmd mkdir -p "${packageDistributableHome}"
    retVal=$?
    if [ ${retVal} -ne 0 ] ; then
        showLog_error "${LINENO}" "Failed to create the g_omServerWorkspace tmp dir."
        return ${retVal}
    fi
    
    chmod 700 "${packageDistributableHome}"

    # 初始化目录权限
    init_home_authority
    if [ $? -ne 0 ] ; then
        showLog_error "${LINENO}" "Failed to chown the ${g_bigdataHome},${BIGDATA_LOG_HOME},${g_bigdataDataHome} path."
        return 1
    fi

    # 设置环境变量
    export_env_variable
    if [ $? -ne 0 ]; then
        showLog_error "${LINENO}" "Failed to export env variable."
    return 1
    fi

    # 安装前准备：不同的操作系统需要做些不同的适配工作
    install_prepare
    retVal=$?
    if [ ${retVal} -ne 0 ] ; then
        showLog_error "${LINENO}" "Failed to prepare for installation."
        return ${retVal}
    fi

    # 如果没有安装jre，则安装jre
    if [ "${g_isUpdateCommonWorkspace}" = "true" ]; then
        sudo ${INSTALL_SUDO_PATH} exec_omm_cmd "${g_curPath}/installjre.sh ${g_bigdataCommonWorkspace}/.common_profile ${g_logFile} ${g_bigdataCommonWorkspace} >> ${g_logFile} 2>&1" > /dev/null 2>&1
        retVal=$?
        if [ ${retVal} -ne 0 ] ; then
            showLog_error "${LINENO}" "Failed to install jre."
            return ${retVal}
        fi
        
        # 更改jre目录属主和权限
        sudo ${INSTALL_SUDO_PATH} jre_dir_chown_ficommon "${JRE_INSTALL_DIR}" "${g_bigdataCommonWorkspace}">> "${g_logFile}" 2>&1
        if [ $? -ne 0 ];then
             showLog_error "${LINENO}" "Failed to change group of jre."
             return 1
        fi
    fi
    
    #设置随机key放到${CONTROLLER_HOME}/security/wcc/目录下，并设置到.controller_profile文件中
    createRandonKey >> ${g_logFile} 2>&1
    retVal=$?
    if [ ${retVal} -ne 0 ]; then
        log_error "${LINENO}" "Failed to create random key."
        return ${retVal}
    fi

    # 安装OMS
    install_oms
    retVal=$?
    if [ ${retVal} -ne 0 ] ; then
        showLog_error "${LINENO}" "Failed to install oms."
        return ${retVal}
    fi

    # 检查数据库是否在运行
    if [ "$g_operatorType" != "$UPGRADE_OPERATOR" ]; then
        is_db_running
        retVal=$?
        if [ ${retVal} -ne 0 ] ; then
            return ${retVal}
        fi
    fi

    #设置aos、controller使用的用户权限管理插件监控目录
    local aosPluginDir="${g_omServerHome}/om/share/om/aos/plugin"
    sudo ${INSTALL_SUDO_PATH} exec_omm_cmd "echo "export AOS_COMPONENT_WATCH_DIR=${aosPluginDir}" >> "${g_omServerWorkspace}/.controller_profile" || return ${INS_WRITE_FILE_FAILURE}" > /dev/null 2>&1

    sed -i -e "s:#BIGDATA_COMMON#:${g_bigdataCommon}:g" "${g_controllerHome}/share/om/acs/config/application.properties"
    sed -i -e "s:#BIGDATA_LOG_HOME#:${BIGDATA_LOG_HOME}:g" "${g_controllerHome}/share/om/acs/config/log4j.properties"

    #替换备份恢复配置文件中的变量信息
    sed -i -e "s:#BIGDATA_COMMON#:${g_bigdataCommon}:g" "${g_controllerHome}/etc/om/backupconfig/application.properties"

    #生成aos插件所需要的配置文件
    sudo ${INSTALL_SUDO_PATH} gen_aos_pluginfile "${g_controllerHome}"

    #设置omm用户下的LD_LIBRARY_PATH
    add_library_path
    retVal=$?
    if [ ${retVal} -ne 0 ] ; then
        showLog_error "${LINENO}" "Failed to add_library_path "
        return ${retVal}
    fi
    
    log_info "${LINENO}" "Begin to start ntp."
    # 配置ntp
    # root下USE_EXTERNAL_NTP变量为YES时，禁止FI的NTP功能
    if [ -z "${USE_EXTERNAL_NTP}" -o "${USE_EXTERNAL_NTP}" != "YES" ]; then
        local if_upgrade_operation=0
        if [ "$g_operatorType" = "$UPGRADE_OPERATOR" ]; then
            if_upgrade_operation=1
        fi

        "${g_controllerHome}/inst/installntp.sh" "${if_upgrade_operation}" "${g_logHome}/controller/scriptlog/" "${g_ntpServerIP}" "${NTPD_OPTIONS}" "${NTPD_OPTIONS_FILE}" "${g_omFloatIP}" "${g_controllerHome}/inst/conf" "${g_omsHome}/workspace/ha/module/harm/plugin/conf" "${g_controllerHome}/inst/script" "${g_omsHome}/workspace/ha/module/harm/plugin/script" "${INSTALL_SUDO_PATH}" "${g_controllerHome}" "${g_omAgentHome}" "${g_bigdataHome}"
        retVal=$?
        if [ ${retVal} -ne 0 ]; then
            showLog_error "${LINENO}" "Failed to install ntp."
            return ${retVal}
        fi
    fi
    log_info "${LINENO}" "Start ntp successfully."
    
    # 安装controller
    log_info $LINENO "${g_controllerHome}/inst/installcontroller.sh ${g_bigdataDataHome} ${g_omsHome}/${DB_INSTALL_DIR} ${g_omFloatIP} ${g_wsFloatIP} ${g_omsHome} ${BIGDATA_LOG_HOME} ${g_logFile} ${g_ssoServerIP}#${g_ssoServerPort}#${g_masterldapIP}#${g_masterldapPort} ${g_ommid} ${g_localIp} ${g_peerIp} ${g_bigdataCommonWorkspace} ${g_operatorType} >> ${g_logFile} 2>&1"
    sudo ${INSTALL_SUDO_PATH} exec_omm_cmd "${g_controllerHome}/inst/installcontroller.sh ${g_bigdataDataHome} ${g_omsHome}/${DB_INSTALL_DIR} ${g_omFloatIP} ${g_wsFloatIP} ${g_omsHome} ${BIGDATA_LOG_HOME} ${g_logFile} ${g_ssoServerIP}#${g_ssoServerPort}#${g_masterldapIP}#${g_masterldapPort} ${g_ommid} ${g_localIp} ${g_peerIp} ${g_bigdataCommonWorkspace} ${g_operatorType} >> ${g_logFile} 2>&1" > /dev/null 2>&1
    retVal=$?
    if [ ${retVal} -ne 0 ]; then
        showLog_error "${LINENO}" "Failed to install controller."
        return ${retVal}
    fi

    log_info "${LINENO}" " g_operatorType=${g_operatorType}"
    sudo ${INSTALL_SUDO_PATH} exec_omm_cmd  "${g_controllerHome}/inst/security/install_security.sh ${g_localIp} ${g_peerIp} ${g_omFloatIP} "${g_omServerWorkspace}/.controller_profile" "${g_bigdataCommonWorkspace}/.common_profile" "${g_operatorType}" "${g_tls_protocol_min}" "
    retVal=$?
    if [ ${retVal} -ne 0 ]; then
        showLog_error "${LINENO}" "Failed to install security."
        return ${retVal}
    fi
    
    # 替换changepw file中的占位符
    replace_changepw_file
    retVal=$?
    if [ ${retVal} -ne 0 ] ; then
      showLog_error "${LINENO}" "Failed to replace changepw file."
      return ${retVal}
    fi

    
    # 初 casserverIp
    replace_casserver
    retVal=$?
    if [ ${retVal} -ne 0 ] ; then
        showLog_error "${LINENO}" "Failed to replace casserverIp."
        return ${retVal}
    fi


    #建立相应的路由表项
    add_route_tables
    retVal=$?
    if [ ${retVal} -ne 0 ] ; then
        showLog_error "${LINENO}" "Failed to create route table variable file."
        return ${retVal}
    fi

    # 配置OMM
    config_omm
    retVal=$?
    if [ ${retVal} -ne 0 ]; then
        showLog_error "${LINENO}" "Failed to config OMM."
        return ${retVal}
    fi

    local targetDir="${g_omsHome}/workspace/ha/module/harm/plugin/conf"
    find "${targetDir}" -type f -name "*.xml" | xargs -I{} chmod 600 "{}"

    # 配置sshd
    sudo ${INSTALL_SUDO_PATH} config_sshd "${g_logFile}" >> "${g_logFile}" 2>&1
    retVal=$?
    if [ ${retVal} -ne 0 ] ; then
        showLog_error "${LINENO}" "Failed to config sshd."
        return ${retVal}
    fi

    # 执行监控和告警的预启动脚本
    local adapterCMD="${g_controllerHome}/inst/adapter.sh ${g_controllerHome}/adapter ${g_omsHome}"
    sudo ${INSTALL_SUDO_PATH} exec_omm_cmd "${adapterCMD}" >> "${g_logFile}" 2>&1
    if [ $? -ne 0 ]; then
        showLog_error "${LINENO}" "Failed to execute the ${g_controllerHome}/inst/adapter.sh script."
        return ${INS_EXEC_SH_FAILURE}
    fi

    # 创建标记文件:标示controller安装完成
    create_mark_file "${g_controllerHome}/omsetup.completed"
    chmod 600 "${g_controllerHome}/omsetup.completed"
    retVal=$?
    if [ ${retVal} -ne 0 ] ; then
        return ${retVal}
    fi

    # 增加umask 077到环境变量文件(.controller_profile)
    local profileFile="${g_omServerWorkspace}/.controller_profile"
    echo "umask 077" >> "${profileFile}" || return ${INS_WRITE_FILE_FAILURE}

    # 磁盘管理进程配置和启动，结果记录入日志.
    configDiskManger
    retVal=$?
    if [ ${retVal} -ne 0 ] ; then
        showLog_error "${LINENO}" "Failed to configDiskManger."
        return ${retVal}
    fi

    #备份数据库的配置文件
    sudo ${INSTALL_SUDO_PATH} backup_postgresql_conf "$g_omsServerWorkspaceName" >> "${g_logFile}" 2>&1
    retVal=$?
    if [ ${retVal} -ne 0 ]; then
        showLog_error "${LINENO}" "Failed to backup config of gaussdb."
        return ${retVal}
    fi
    
    # 配置审计crontab
    config_crontab
    retVal=$?
    if [ ${retVal} -ne 0 ]; then
        showLog_error "${LINENO}" "Failed to config crontab."
        return ${retVal}
    fi
    
    # 日志管理工具
    install_logman
    retVal=$?
    if [ ${retVal} -ne 0 ]; then
        showLog_error "${LINENO}" "Failed to install logman."
        return ${retVal}
    fi

    # 修改文件权限
    modify_file_authority

    #安装nodeagent
    if [ "$g_operatorType" != "$UPGRADE_OPERATOR" ]; then
        ${g_curPath}/installAgentForOms.sh "${g_bigdataDataHome}" "${g_operatorType}"
        retVal=$?
        if [ ${retVal} -ne 0 ]; then
            showLog_error "${LINENO}" "Failed to install agent for OMS node."
            return ${retVal}
        fi
    fi
    
    showLog_info "${LINENO}" "install kerberos realm is ${g_kerberos_realm}."
    #安装场景可以支持指定域名安装，不指定则默认为HADOOP.COM
    if [ -z "${g_kerberos_realm}" ];then
       g_kerberos_realm="${default_realm}"
    fi
    
    #安装场景且不是HADOOP.COM域名，则需要生成指定域名
    if [ "$g_operatorType" != "$UPGRADE_OPERATOR" ] && [ "${g_kerberos_realm}" != "${default_realm}" ]; then
        #自动生成域名
        sudo ${INSTALL_SUDO_PATH} exec_omm_cmd "${g_curPath}/setupUniqueRealm.sh ${g_bigdataDataHome}" "${g_kerberos_realm}" >> "${g_logFile}" 2>&1
        if [ $? -ne 0 ]; then
            showLog_error "${LINENO}" "Failed to install agent for OMS node."
            return 1
        fi
    fi
    
    #sync the disk
    sync
    sleep 2
    
    return ${INS_SUCCESS}
}

################################################################################
# Function: is_db_running
# Description: 检查pt数据库是否在运行
# Parameter:
#   input:
#   N/A
#   output:
#   N/A
# Return: 0 -- success; not 0 -- failure
# Others: N/A
################################################################################
is_db_running()
{
    log_debug "${LINENO}" "Check whether db is running."

    sudo ${INSTALL_SUDO_PATH} is_db_running "${g_omsServerWorkspaceName}" >> "${g_logFile}" 2>&1
    if [ $? -ne 0 ] ; then
        showLog_error "${LINENO}" "The database is not running."
        return ${INS_GTE_DB_STATUS_FAILURE}
    fi

    return ${INS_SUCCESS}
}

################################################################################
# Function: upgrade_random_key
# Description: 升级随机密钥
# Parameter:
#   input:
#   N/A
#   output:
#   N/A
# Return: 0 -- success; not 0 -- failure
# Others: N/A
################################################################################
upgrade_random_key()
{
    if [ "${g_isUpdateCommonWorkspace}" != "true" ]; then
         return 0
    fi
    
    #C60X版本随机密钥安装在${BIGDATA_HOME}/security目录
    if [ -d "${g_bigdataHome}/security/keystore" ]; then
        /bin/cp -rpf "${g_bigdataHome}/security" "${g_bigdataCommonWorkspace}" >> "${g_logFile}" 2>&1 || return ${INS_COPY_FILE_FAILURE}
        local wcc_profile_dir="${g_bigdataCommonWorkspace}/security/config"
        echo "crypt_keystore=${g_bigdataCommon}/security/keystore/keystore.xml" > $wcc_profile_dir/application.properties || return $?
        echo "crypt_keygen_rootkey_components=${g_bigdataCommon}/security/rp/rkc1;${g_bigdataCommon}/security/rkp/rk2;${g_bigdataCommon}/security/rk3d/k3" >> $wcc_profile_dir/application.properties || return $?
        echo "crypt_keygen_iteration_count=2500" >> $wcc_profile_dir/application.properties || return $?
        
        ln -sf "${g_bigdataCommonWorkspace}" "${g_bigdataCommon}" || return $?  
        return 0
    fi

    /bin/cp -rpf "${g_bigdataCommon}/security" "${g_bigdataCommonWorkspace}" >> "${g_logFile}" 2>&1 || return ${INS_COPY_FILE_FAILURE}
}

################################################################################
# Function: createRandonKey
# Description:生成密钥文件夹，创建wcc依赖的配置文件，并设置到.controller_profile文件中
# Parameter:
#   input:
#   N/A
#   output:
#   N/A
# Return: 0 -- success; not 0 -- failure
# Others: N/A
################################################################################
createRandonKey()
{
    log_debug "${LINENO}" "createRandonKey"
    
    local commonProfile="${g_bigdataCommonWorkspace}/.common_profile"
    source "${commonProfile}" >> "${g_logFile}" 2>&1
    
    keydir="${g_bigdataCommonWorkspace}/security"
    wcc_profile_dir="${keydir}/config"
    
    if [ "$g_operatorType" != "$UPGRADE_OPERATOR" ]; then
    
        mkdir -p "${keydir}" || return ${INS_MKDIR_FAILURE}
        if [ -d "${keydir}" ]; then
            chmod 750 "${keydir}"
        fi

        mkdir -p "$wcc_profile_dir" || return ${INS_MKDIR_FAILURE}
        
        chmod 750 "${wcc_profile_dir}"
        touch $wcc_profile_dir/application.properties || echo "create file application.properties failure"
        touch $wcc_profile_dir/log4j.properties || echo "create file log4j.properties failure"
    
        echo "crypt_keystore=${g_bigdataCommon}/security/keystore/keystore.xml
crypt_keygen_rootkey_components=${g_bigdataCommon}/security/rp/rkc1;${g_bigdataCommon}/security/rkp/rk2;${g_bigdataCommon}/security/rk3d/k3
crypt_keygen_iteration_count=2500" > $wcc_profile_dir/application.properties
    
        echo "log4j.logger.org.wcc=OFF
log4j.appender.FILE=org.apache.log4j.RollingFileAppender
log4j.appender.FILE.MaxFileSize=10MB
log4j.appender.FILE.MaxBackupIndex=10
log4j.appender.FILE.Append=true
log4j.appender.FILE.Encoding=UTF-8
log4j.appender.FILE.layout = org.apache.log4j.PatternLayout
log4j.appender.FILE.layout.ConversionPattern=[%-5p] %d{yyyy-MM-dd HH:mm:ss,SSS} [%t] %3x - %m -%37c %n
log4j.appender.FILE.File=${BIGDATA_LOG_HOME}/audit/wcc/wcc.log"> $wcc_profile_dir/log4j.properties
    
        chmod 750 "$wcc_profile_dir/application.properties"
        chmod 750 "$wcc_profile_dir/log4j.properties"

        #copy key
        cp -r /tmp/backupDir/${g_bigdataCommonWorkspace}/security/keystore ${g_bigdataCommonWorkspace}/security
        cp -r /tmp/backupDir/${g_bigdataCommonWorkspace}/security/rk3d ${g_bigdataCommonWorkspace}/security
        cp -r /tmp/backupDir/${g_bigdataCommonWorkspace}/security/rkp ${g_bigdataCommonWorkspace}/security
        cp -r /tmp/backupDir/${g_bigdataCommonWorkspace}/security/rp ${g_bigdataCommonWorkspace}/security

        chmod -R u+rwX,g+rX,o-rwx "${keydir}"
        find "${keydir}" -type f -name "*" | xargs -I{} chmod 640 "{}"
        
        if [ -d "${BIGDATA_LOG_HOME}/audit" ]; then
            chmod 700 "${BIGDATA_LOG_HOME}/audit"
            chown ${OMM_USER}:${OMM_USER_GROUP} ${BIGDATA_LOG_HOME}/audit -R || return ${INS_MODIG_AUTHORITY_FAILURE}
        fi
        
        if [ -d "${BIGDATA_LOG_HOME}/audit/wcc" ]; then
            chmod 700 "${BIGDATA_LOG_HOME}/audit/wcc"
            chown ${OMM_USER}:${OMM_USER_GROUP} ${BIGDATA_LOG_HOME}/audit/wcc -R || return ${INS_MODIG_AUTHORITY_FAILURE}         
        fi
        if [ -f "${BIGDATA_LOG_HOME}/audit/wcc/wcc.log" ]; then
            chmod 600 "${BIGDATA_LOG_HOME}/audit/wcc/wcc.log"
            chown ${OMM_USER}:${OMM_USER_GROUP} ${BIGDATA_LOG_HOME}/audit/wcc/wcc.log -R || return ${INS_MODIG_AUTHORITY_FAILURE}         
        fi

        #区分用户执行任务特性，修改文件组属组为${FI_COMMON_GROUP}
        sudo ${INSTALL_SUDO_PATH} security_dir_chown_omm_wheel ${g_bigdataCommonWorkspace} "${g_logFile}" >> "${g_logFile}" 2>&1 || return ${INS_MODIG_AUTHORITY_FAILURE}
    else
        upgrade_random_key || return $?
    fi
    
    grep "^export[[:space:]]*WCC_PROFILE_DIR=.*$" "${commonProfile}" >> "${g_logFile}" 2>&1
    if [ $? -ne 0 ]; then
        echo "export WCC_PROFILE_DIR=$wcc_profile_dir" >> "${commonProfile}" || return ${INS_WRITE_FILE_FAILURE}
    fi
    
    grep "^source[[:space:]]*${g_bigdataCommon}/.common_profile[[:space:]]*$" "${OMM_USER_HOME}/.profile" >> "${g_logFile}" 2>&1
    if [ $? -ne 0 ]; then
        echo "source ${g_bigdataCommon}/.common_profile" >> "${OMM_USER_HOME}/.profile" || return ${INS_WRITE_FILE_FAILURE}
    fi
    
    return 0
}

################################################################################
# Function: configDiskManger
# Description: 配置磁盘管理进程
# Parameter:
#   input:
#   N/A
#   output:
#   N/A
# Return: 0 -- success; not 0 -- failure
# Others: N/A
################################################################################
configDiskManger()
{
    log_debug "${LINENO}" "configDiskManger start"
    sudo ${INSTALL_SUDO_PATH} configOMSDiskManger "${g_controllerHome}" >/dev/null
    if [ $? != 0 ] ;then
          return 1
    fi

    log_debug "${LINENO}" "configDiskManger end"
}

################################################################################
# Function: add_library_path
# Description: 配置ommdba的执行路径到omm账户lib目录
# Parameter:
#   input:
#   N/A
#   output:
#   N/A
# Return: 0 -- success; not 0 -- failure
# Others: N/A
################################################################################
add_library_path()
{
    bashFile="/home/${DB_CREATER}/.bashrc"
    grep "^source[[:space:]]*${bashFile}[[:space:]]*$" "${g_omServerWorkspace}/.controller_profile" >> "${g_logFile}" 2>&1
    if [ $? -ne 0 ] ; then
        echo "source ${bashFile}" >> "${g_omServerWorkspace}/.controller_profile" || return ${INS_WRITE_FILE_FAILURE}
    fi
    return 0
}
# ---------------------------------------------------------------------------- #
#                                 获取当前路径                                 #
# ---------------------------------------------------------------------------- #
get_cur_path
cd "${g_curPath}"

# ---------------------------------------------------------------------------- #
#                                 初始化日志文件                               #
# ---------------------------------------------------------------------------- #
. "${g_curPath}/func/log.sh" || { echo "[${g_scriptName}:${LINENO}] ERROR: Failed to load ${g_curPath}/func/log.sh."; exit 1;}

init_log || exit 1

# ---------------------------------------------------------------------------- #
#                                   导入头文件                                 #
# ---------------------------------------------------------------------------- #
. "${g_curPath}/func/constants.sh" || { log_error "${LINENO}" "Failed to load ${g_curPath}/func/constants.sh."; exit 1; }
. "${g_curPath}/func/functions.sh" || { log_error "${LINENO}" "Failed to load ${g_curPath}/func/functions.sh."; exit 1; }
. "${g_curPath}/oss/interface/interface.sh" || { log_error "${LINENO}" "Failed to load ${g_curPath}/oss/interface/interface.sh."; exit 1; }
. "${g_curPath}/../etc/om/release" || { log_error "${LINENO}" "Failed to load ${g_curPath}/../etc/om/release."; exit 1; }

# ---------------------------------------------------------------------------- #
#                                 脚本开始运行                                 #
# ---------------------------------------------------------------------------- #
main "$@"
exit $?
