#!/bin/bash

################################################################################
## Copyright:   HUAWEI Tech. Co., Ltd.
## Filename:    cancel heartbeat check
## Description:
################################################################################

function getCurPath() {
    cd "$(dirname "${BASH_SOURCE-$0}")"
    g_curPath="$(pwd)"
    cd - >/dev/null
}

# 恢复心跳检查
function main()
{
    showLog_info "${LINENO}" "Start restore heartbeat."
    local controller_propties="${CONTROLLER_HOME}/etc/om/controller.properties"
    local om_heartbeat_check=$(grep -w "controller.node.heartbeat.check.enable" "${controller_propties}" | grep -v "^#")
    local om_heartbeat_check_new="controller.node.heartbeat.check.enable=true"

    sed -i "s#${om_heartbeat_check}#${om_heartbeat_check_new}#g" "${controller_propties}"
    if [ $? -ne 0 ]; then
        showLog_error "${LINENO}" "Failed to set heartbeat check."
        return 1
    fi

    ${CONTROLLER_HOME}/sbin/restart-controller.sh
}

if [ "$(whoami)" != "omm" ]; then
    echo "Only omm user can execute this script."
    exit 1;
fi

getCurPath
# ---------------------------------------------------------------------------- #
#                                 导入头文件                                     #
# ---------------------------------------------------------------------------- #
. "${g_curPath}/../func/functions.sh" || {
    echo "Failed to load functions.sh."
    exit 1
}
. "${g_curPath}/../func/log.sh" || {
    echo "Failed to load log.sh."
    exit 1
}
. "${g_curPath}/../func/constants.sh" || {
    echo "Failed to load constants.sh."
    exit 1
}

main "$@"