#!/bin/bash
declare OMM_USER="omm"
declare OMM_WHEEL="wheel"

init_env()
{
    #־
    get_path
    source "${PARENT_PATH}/common/log.sh"
    
    #ommû
    if [ -f "/home/omm/.profile" ] ;then
        source "/home/omm/.profile"
    else
        log_and_show "ERROR" "${LINENO}" "no /home/omm/.profile, source omm env failed"
        return 1
    fi
    
    return 0
}

###################################################
#
# ȡ·
#
###################################################
get_path()
{
    local path=""

    pushd $(dirname "$0") > /dev/null
    path="$(readlink -e "$(pwd)")"
    popd >/dev/null
    if [ -z "${path}" ]; then
        echo "current path is null."
        return 1
    fi

    CURRENT_DIR="${path}"
    PARENT_PATH=$(dirname "${path}")
    echo "PARENT_PATH=$PARENT_PATH."
    if [ -z "$PARENT_PATH" ]; then
        echo "Init parameter PARENT_PATH failed."
        return 1
    fi

    return 0
}

main()
{   
    init_env
    if [ $? -ne 0 ];then
        log_and_show "ERROR" "${LINENO}" "init env failed"
        return 1
    fi
    
    #replace sudo/install scripts
    /bin/bash "${PARENT_PATH}"/common/replace_sudoExecute.sh
    if [ $? -ne 0 ];then
        log_and_show "ERROR" "${LINENO}" "replace sudo failed"
        return 1
    fi
    log_and_show "INFO" "${LINENO}" "replace sudo successfully"

    #replace diskmgt/ini-plugin/notify/datanode_notify.sh
    /bin/bash "${PARENT_PATH}"/common/replace_datanode_notify.sh
    if [ $? -ne 0 ];then
        log_and_show "ERROR" "${LINENO}" "replace datanode_notify.sh failed"
        return 1
    fi
    log_and_show "INFO" "${LINENO}" "replace datanode_notify.sh successfully"
    
    #add path of updateElectronicTag.sh to osFile
    /bin/bash "${PARENT_PATH}"/common/add_updateElectronicTag_to_os.sh
    if [ $? -ne 0 ];then
        log_and_show "WARN" "${LINENO}" "add path of updateElectronicTag.sh to osFile failed"
    fi
    log_and_show "INFO" "${LINENO}" "add path of updateElectronicTag.sh to osFile successfully"
    
    return 0
}

#ű ǿΪ /bin/bash
if [ "$BASH" != "/bin/bash" ]; then
   /bin/bash $0 "$@"
   exit $?
fi

main
exit $?