# coding: utf-8

import sys

'''
 [RPM_VER]:[192.168.110.17]:db4.x86_64:package db4.x86_64 is not installed
 [RPM_VER]:[192.168.110.17]:db4-cxx.x86_64:cxx.x86_64 is not installed
 [RPM_VER]:[192.168.110.17]:db4-devel.x86_64:devel.x86_64 is not installed
 [RPM_VER]:[192.168.110.17]:db4-utils.x86_64:utils.x86_64 is not installed
 [RPM_VER]:[192.168.110.17]:dbus.x86_64:1.6.12
 [RPM_VER]:[192.168.110.17]:dbus-glib.x86_64:glib
 [RPM_VER]:[192.168.110.17]:dbus-libs.x86_64:libs
'''


def read_ver_file(strinfile):
    with open(strinfile) as file:
        verlist = file.readlines()
        return verlist


def get_dit_rpm_ver(listver, ditrpm):
    ditrpmver = {}
    strip = listver[1]
    strrpmname = listver[2]
    strver = listver[3]

    if strrpmname in ditrpm:
        # 存在rpm包
        ditrpmver = ditrpm[strrpmname]
        if strver in ditrpmver:
            # 存在版本号记录，IP地址加入到列表中
            lstip = ditrpmver[strver]
            lstip.append(strip)
            ditrpmver[strver] = lstip
        else:
            # 新的版本号,直接加入
            lstip = []
            lstip.append(strip)
            ditrpmver[strver] = lstip
        return ditrpmver

    lstip = []
    lstip.append(strip)
    ditrpmver[strver] = lstip

    return ditrpmver


def readver(strinfile):
    verlist = read_ver_file(strinfile)
    ditrpm = {}
    for aver in verlist:
        listver = aver.strip().split('#')
        if len(listver) < 4:
            continue
        ditrpmver = get_dit_rpm_ver(listver, ditrpm)
        strrpmname = listver[2]
        ditrpm[strrpmname] = ditrpmver
    return ditrpm


def get_max_ver(ditver):
    maxver = ''
    for (strver, listip) in list(ditver.items()):
        if strver > maxver:
            maxver = strver
    return maxver


def record_err_msg(err_msg, strfailedfile):
    with open(strfailedfile, mode='a') as file:
        file.write('\n'.join(err_msg))


def vercmp(ditrpm):
    listcmp = []
    for (strrpmname, ditver) in list(ditrpm.items()):
        if len(ditver) <= 1:
            continue
        maxver = get_max_ver(ditver)
        for (strver, listip) in list(ditver.items()):
            if strver >= maxver:
                continue
            listcmp.append('[ERROR] [%s] version [%s] in the hosts[%s] is lower than others [%s]' % (
                strrpmname, strver, ','.join(listip), maxver))
    return listcmp


if __name__ == "__main__":
    strinfile = sys.argv[1]
    strfailedfile = sys.argv[2]
    ditvers = readver(strinfile)
    if ditvers != None:
        err_msg = vercmp(ditvers)
        record_err_msg(err_msg, strfailedfile)

    pass
