#!/bin/bash

#-----------------------------------------------------------------------------------------------------------------
# ܸϢнҶ
#-----------------------------------------------------------------------------------------------------------------
source "$(dirname "$0")"/sharefuncs.sh
declare -a diskConfigArray
declare -a pathConfigArray
declare -a g_DiskInfoArray
declare -a g_PartitionNameArray
declare -a g_PartitionArray

#빫־
SCRIPT_NAME="$(basename "${BASH_SOURCE-$0}")"
LOG_FUNC_FILE="$(dirname "$0")"/log.sh
. "${LOG_FUNC_FILE}" || { echo "[$(date -d today +'%Y-%m-%d %H:%M:%S')] [ERROR]: Failed to load ${LOG_FUNC_FILE}. [${SCRIPT_NAME}:${LINENO}]($$)"; exit 1;}

ip=""
 
exec_cmd()
{
    local -i retVal=0

    # һΪϵͳĲΪ
    local    cmd="$1"

    # λһʧ,ȡĲ
    shift
    
    # $@˫ţÿ˫ţַֹпո
    "${cmd}" "$@"
    retVal=$?
    if [ "${retVal}" -eq 255 ] ; then
        exit 255
    fi

    return 0
}

#-----------------------------------------------------------------------------------------------------------------
#func : ÿһϢзָ,ָʽ
#param : һ̨Ϣ(jsonʽ)
#-----------------------------------------------------------------------------------------------------------------
function getConfigForEachDisk() {
    log "[INFO]" "${LINENO}" "${ip}: start dividing the host config file to get configurations for each disk."

    #ȷ֮ǰûв
    unset diskConfigArray
    unset diskLineNumArray
    local diskLineNum

    #¼Ϣа"name"кţע⣺ϢhostnameʣҪų
    count=0
    for diskLineNum in $(echo "$1" | awk '/"nodes",[[:digit:]]+,"node","disks",[[:digit:]]+,"disk","name"/{print NR}')
    do
        diskLineNumArray["${count}"]="${diskLineNum}"
        count=$(expr ${count} + 1)
    done

    #ַ¼ͬһ²ͬdiskϢ
    for j in "${!diskLineNumArray[@]}"
    do
        if [ "${j}" != $(( ${#diskLineNumArray[@]} - 1 )) ]
        then
            diskConfigArray[j]=$(echo "$1" | sed -n ${diskLineNumArray[${j}]},$(( ${diskLineNumArray[ ((${j} + 1)) ]} - 1 ))p)
        else
            diskConfigArray[j]=$(echo "$1" | sed -n "${diskLineNumArray[${j}]}"',$p')
        fi
    done

    log "[INFO]" "${LINENO}" "${ip}: dividing the host config file success."
}

#-----------------------------------------------------------------------------------------------------------------
#func : ÿһ̵Ϣзָ,ָʽ
#param : һ̵Ϣ(jsonʽ)
#return : pathϢϹ淶ֱӷش
#-----------------------------------------------------------------------------------------------------------------
function getConfigForEachPath()
{
    log "[INFO]" "${LINENO}" "${ip}: divide the disk config file to get configurations for each path."

    unset pathConfigArray
    unset pathLineNumArray
    unset pathArray

    local pathValue
    local pathSize

    #ȡͬһdiskùص㣬ӦСϢ
    count=0
    for pathLineNum in $(echo "$1" | awk '/"path"/{print NR}')
    do
        pathLineNumArray["${count}"]="${pathLineNum}"
        count=$(expr ${count} + 1)
    done

    for k in "${!pathLineNumArray[@]}"
    do
        if [ "${k}" != $(( ${#pathLineNumArray[@]} - 1 )) ]
        then
            pathArray["${k}"]=$(echo "$1" | sed -n ${pathLineNumArray[${k}]},$(( ${pathLineNumArray[ ((${k} + 1)) ]} - 1 ))p)
        else
            pathArray["${k}"]=$(echo "$1" | sed -n "${pathLineNumArray[${k}]}"',$p')
        fi

        #ȡصϢ(صĿ¼ԼӦĴС)
        pathValue=$(echo "${pathArray[${k}]}" | egrep '"nodes",[[:digit:]]+,"node","disks",[[:digit:]]+,"disk","paths",[[:digit:]]+,"path"' | cut -d '"' -f 14)
        pathSize=$(echo "${pathArray[${k}]}" | egrep '"nodes",[[:digit:]]+,"node","disks",[[:digit:]]+,"disk","paths",[[:digit:]]+,"size"' | cut -d '"' -f 14)

        #pathValueΪ
        if [ -z "${pathValue}" ]
        then
            log "[ERROR]" "${LINENO}" "${ip}: the ${k} path value is empty."
            return 1
        fi

        #pathSizeֻ򸡵
        if [[ "${pathSize}" =~ [[:digit:]]+[\.]?[[:digit:]]* ]]
        then
            pathConfigArray[k]="${pathValue} ${pathSize}"
        elif [ -z "${pathSize}" ]
        then
            pathConfigArray[k]="${pathValue} -1"
        else
            log "[ERROR]" "${LINENO}" "${ip}: the partition size format of path ${pathValue} is not correct, it should be integer or float number."
            return 1
        fi
        
    done
}


#-----------------------------------------------------------------------------------------------------------------
#func : cpuǷļƥ(=cpu*cpu)
#param : cpuܺ
#-----------------------------------------------------------------------------------------------------------------
function checkCpuCoreNum() {

    #cpuCoreNumֻ
    if [[ "$1" =~ [[:digit:]]+ ]]
    then
        totalCoreNum=$(cat /proc/cpuinfo |grep "processor"|sort -u|wc -l)

        if [ "${totalCoreNum}" -ge $1 ]
        then
            log "[INFO]" "${LINENO}" "${ip}: the cpu cores number '${totalCoreNum}' match the config file $1."
        else
            log "[ERROR]" "${LINENO}" "${ip}: the cpu cores number '${totalCoreNum}' does not match the config file $1."
            return 1
        fi
    else
        log "[ERROR]" "${LINENO}" "${ip}: the cpu cores number $1 format is not correct, it should be integer."
        return 1
    fi
}

#-----------------------------------------------------------------------------------------------------------------
#func : ڴСǷļƥ
#param : ڴС
#-----------------------------------------------------------------------------------------------------------------
function checkMemory() {
    log "[INFO]" "${LINENO}" "${ip}: start checking memory size."

    #memoryʹ򸡵
    if [[ "$1" =~ [[:digit:]]+[\.]?[[:digit:]]* ]]
    then

        realMemory=$(free -g | sed -n '2p' | awk '{print $2}')

        # 10% less is ok
        configMemory=$(echo $1*0.9 | bc)


        ifMoreThanLowerBound=$(echo "${realMemory} > ${configMemory}" | bc)

        if [ "${ifMoreThanLowerBound}" -eq 1 ]
        then
            log "[INFO]" "${LINENO}" "${ip}: real memory size ${realMemory} match the config file $1, 10% less (${configMemory}) is OK."
        else
            log "[ERROR]" "${LINENO}" "${ip}: real memory size ${realMemory} does not match the config file $configMemory."
            return 1
        fi
    else
        log "[ERROR]" "${LINENO}" "${ip}: the memory size $1 format is not correct, it should be integer or float number."
        return 1
    fi
}

#-----------------------------------------------------------------------------------------------------------------
#func : ļǷһ
#param : 
#-----------------------------------------------------------------------------------------------------------------
function checkDiskNum () {
    log "[INFO]" "${LINENO}" "${ip}: start checking disk number"
    log "[INFO]" "${LINENO}" "${ip}: disk number in config file is : $1"

    realDiskNum=$(cat /proc/partitions | sed -n '2,$p' | sed '/^$/d' | awk '{print $4}' | egrep -o [[:alpha:]]+ | sort | uniq | wc -l)

    if [ ${realDiskNum} -ge $1 ]
    then
        log "[INFO]" "${LINENO}" "${ip}: the real disk number ${realDiskNum} match the config file $1."
    else
        log "[ERROR]" "${LINENO}" "${ip}: the real disk number ${realDiskNum} does not match the config file $1."
        return 1
    fi
}

function checkTimeZone()
{
    configTimeZone=$1
    log "[INFO]" "${LINENO}" "${ip}: start checking time zone"
    timezone=$(date -R | awk '{print $6}')

    if [ -z "${configTimeZone}" ]
    then
        log "[WARNING]" "${LINENO}" "${ip}: timezone is not configured, skip check."
        return 1
    fi

    if [ x"$timezone" = x"$configTimeZone" ]
    then
        log "[INFO]" "${LINENO}" "${ip}: timezone $configTimeZone is OK."
    else
        log "[ERROR]" "${LINENO}" "${ip}: timezone check failed, current timezone is '$timezone', configured timezone is '$configTimeZone'."
        return 1
    fi
}

#-----------------------------------------------------------------------------------------------------------------
#func : жϴʵСǷļֱ˳
#param : 1. 
#         2. ԤڴС
#-----------------------------------------------------------------------------------------------------------------
function checkDiskSize() {
    log "[INFO]" "${LINENO}" "${ip}: start checking size of disk : $1"
    log "[INFO]" "${LINENO}" "${ip}: diskSize in config file is $2"

    #diskSizeֻ򸡵
    if [[ "$2" =~ [[:digit:]]+[\.]?[[:digit:]]* ]]
    then
        realDiskSize=$(parted $1 unit GB print | grep "Disk $1" | awk '{print $3}' | egrep -o [[:digit:]]+[\.]?[[:digit:]]*)
        log "[INFO]" "${LINENO}" "${ip}: real diskSize of config is $2"

        upperDiskSizeBound=$(echo $2*1.1 | bc)
        lowerDiskSizeBound=$(echo $2*0.9 | bc)

        ifMoreThanLowerBound=$(echo "${realDiskSize} > ${lowerDiskSizeBound}" | bc)
        if [ ${ifMoreThanLowerBound} = 1 ]
        then
            log "[INFO]" "${LINENO}" "${ip}: real diskSize ${realDiskSize} match the config file $2."
        else
            log "[ERROR]" "${LINENO}" "${ip}: real diskSize ${realDiskSize} does not match the config file $2."
            return 1
        fi
    else
        log "[ERROR]" "${LINENO}" "${ip}: the disk size $2 format is not correct, it should be integer or float number."
        return 1
    fi
}

function initDiskPartitions()
{
    unset g_DiskInfoArray

    for diskName in $(fdisk -l 2>/dev/null | grep "Disk /dev" | awk -F":" '{print $1}' | awk '{print $2}')
    do
        diskInfo=$(fdisk -l $diskName 2>/dev/null | grep "^/dev" | awk '{print $1}' 2>/dev/null)

        # 鲻, ΪǴ̱
        if [ x"${diskInfo}" = x ]
        then
            diskInfo="${diskName}"
        fi

        diskInfo=`echo ${diskInfo} | tr " " "|"`
        g_DiskInfoArray=( "${g_DiskInfoArray[@]}" "|${diskInfo}|" )
    done
}
#-----------------------------------------------------------------------------------------------------------------
#func : жϴʵСǷļֱ˳
#param : 1. ôĳһصϢ
#-----------------------------------------------------------------------------------------------------------------
function checkPath() {
    #ȡĹصϢ
    pathValue=$(echo "$1" | awk '{print $1}')
    pathSize=$(echo "$1" | awk '{print $2}')
    
    log "[INFO]" "${LINENO}" "${ip}: start checking path '${pathValue}'"

    #ȡʵϢ
    partitionInfo=`${CMD_CHKDFP} | grep -w "${pathValue}$"`
    partitionName=""
    retValue=0

    if [ -n "${partitionInfo}" ]
    then
        partitionName=$(echo $partitionInfo | awk {'print $1'})
        g_PartitionNameArray=( "${g_PartitionNameArray[@]}" "$partitionName" )
        g_PartitionArray=( "${g_PartitionArray[@]}" "$pathValue" )
        log "[INFO]" "${LINENO}" "${ip}: the partition '${pathValue}' exists, name is ${partitionName}."
    else
        log "[ERROR]" "${LINENO}" "${ip}: the partition '${pathValue}' does not exist."
        retValue=1
        return "$retValue"
    fi

    # ÷ǷΪUUIDػby-id
    partitionUuid=$(cat /etc/fstab | awk '{print $1,$2}' | grep -w "${pathValue}$" | awk '{print $1}' | grep -i uuid)
    partitionbyid=$(cat /etc/fstab | awk '{print $1,$2}' | grep -w "${pathValue}$" | awk '{print $1}' | grep -i by-id)
    if [ -n partitionUuid -o -n partitionbyid ]
    then
        log "[INFO]" "${LINENO}" "${ip}: partition ${pathValue} is mounted by uuid or by-id."
    else
        log "[ERROR]" "${LINENO}" "${ip}: partition ${pathValue} is not mounted by uuid or by-id."
        retValue=1
    fi
    
    #жϷʣǷ(õռܹ80%)
    partitionUsed=$(echo $partitionInfo | awk {'print $5'} | sed 's/%//')
    if [ ${partitionUsed} -gt 80 ]
    then
        log "[ERROR]" "${LINENO}" "${ip}: Insufficient disk space in partition '${pathValue}'."
        retValue=1
    fi

    # жϷСļǷһ
    if [ "${pathSize}" = "-1" ]
    then
        log "[WARNING]" "${LINENO}" "${ip}: partition ${pathValue} size is not configured, skip check."
        return "$retValue"
    fi
    
    partitionSize=$(echo $partitionInfo | awk {'print $2'})
    partitionSize=$(echo ${partitionSize}/1024/1024 | bc)
    partitionSizeLowerBound=$(echo $pathSize*0.9 | bc)
    ifMoreThanLowerBound=$(echo "${partitionSize} >= ${partitionSizeLowerBound}" | bc)
    if [ ${ifMoreThanLowerBound} = 1 ]
    then
        log "[INFO]" "${LINENO}" "${ip}: partition '${pathValue}' size '$partitionSize'(G) matches the configured size '${pathSize}'(G), 10% less is OK."
    else
        log "[ERROR]" "${LINENO}" "${ip}: partition '${pathValue}' size '$partitionSize'(G) does not match the configured size '${pathSize}'(G)."
        retValue=1
    fi
    
    ThresholdLog=130
    if [ "${pathValue}" = "/var/log" ]
    then
        partitionAvailable=$(echo $partitionInfo | awk {'print $4'})
        partitionAvailable=$(echo ${partitionAvailable}/1024/1024 | bc)
        ifMoreThanLowerBound=$(echo "${partitionAvailable} >= ${ThresholdLog}" | bc)
        if [ ${ifMoreThanLowerBound} = 1 ]
        then 
            log "[INFO]" "${LINENO}" "${ip}: The available space of the '${pathValue}' partition is '${partitionAvailable}' (GB), which is large than the size '${ThresholdLog}'(GB) of logs to be retained for seven days."   
        else
            log "[WARNING]" "${LINENO}" "${ip}: The available space of the '${pathValue}' partition is '${partitionAvailable}' (GB), which is smaller than the size '${ThresholdLog}'(GB) of logs to be retained for seven days."
            
            retValue=1     
        fi
    fi
    
    return $retValue
}

#-----------------------------------------------------------------------------------------------------------------
#func : ȡʵСǷĿ¼ôСϢ
#param : 1. ôĳһصϢ
#-----------------------------------------------------------------------------------------------------------------
function getPathinfo() {
    #ȡĹصϢ
    pathValue=$(echo "$1" | awk '{print $1}')
    pathSize=$(echo "$1" | awk '{print $2}')
    
    log "[INFO]" "${LINENO}" "${ip}: start getting path '${pathValue}'"

    #ȡʵϢ
    partitionAll=$(${CMD_CHKDFP})
    partitionName=""
    partitionInfo=""
    retValue=0
    dirpath="partion"
    apartition="${pathValue}"
    toppartition="subpartion" 
    #ָĿ¼װ··пĿ¼Ȱƥڣ˵ϼ飬ֱҵϼ򲻴
    while true   
    do
        #״μ'/'
        partitionInfo=$(echo "${partitionAll}" | grep -w "${apartition}$")
        if [ -n "${partitionInfo}" ];then
            break
        else
            if [ "${apartition}" = "/" ];then
                #жǷ񵽴ﶥĿ¼,ûҵĿ¼,Ѿѵ'/',˳
                log "[ERROR_DEBUG]" "${LINENO}" "${ip}: the path '${pathValue}'  of partition '${apartition}' does not exist"
                break
            else
                apartition=$(dirname "${apartition}")
            fi
        fi
    done
    
    if [ "${apartition}" != "${pathValue}" ];then
        #/optĿ¼ж,ҪжOPTǷ                   #   10     11    01   00    
        opt=$(echo "${apartition}" | grep "opt" )                   #   I       N    I   
        #OPTĿ¼,ֱʾ,optĿ¼жopt
        if [ -z "${opt}" ];then
            log "[WARNING]" "${LINENO}" "${ip}: the partition '${pathValue}' does not exist."
            dirpath="dir"
        fi
    fi
    
    if [ -n "${partitionInfo}" ]
    then
        partitionName=$(echo $partitionInfo | awk {'print $1'})
        g_PartitionNameArray=( "${g_PartitionNameArray[@]}" "$partitionName" )
        g_PartitionArray=( "${g_PartitionArray[@]}" "$pathValue" )
        #echo "[INFO] ${ip}: the partition '${apartition}' of path '${pathValue}' exists, name is ${partitionName}."
    else
        log "[INFO]" "${LINENO}" "${ip}: the partition '${pathValue}' does not exist."
        retValue=1
        return "$retValue"
    fi

    # ÷ǷΪUUIDػby-id
    partitionUuid=$(cat /etc/fstab | awk '{print $1,$2}' | grep -w "${apartition}$" | awk '{print $1}' | grep -i uuid)
    partitionbyid=$(cat /etc/fstab | awk '{print $1,$2}' | grep -w "${apartition}$" | awk '{print $1}' | grep -i by-id)
    if [ -n partitionUuid -o -n partitionbyid ]
    then
        log "[INFO]" "${LINENO}" "${ip}: partition ${apartition} is mounted by uuid or by-id."
    else
        log "[ERROR]" "${LINENO}" "${ip}: partition ${apartition} is not mounted by uuid or by-id."
        retValue=1
    fi
    
    #жϷʣǷ(õռܹ80%)
    partitionUsed=$(echo $partitionInfo | awk {'print $5'} | sed 's/%//')
    if [ ${partitionUsed} -gt 80 ]
    then
        log "[ERROR]" "${LINENO}" "${ip}: Insufficient disk space in partition '${pathValue}'."
        retValue=1
    fi

    # жϷСļǷһ
    if [ "${pathSize}" = "-1" ]
    then
        log "[WARNING]" "${LINENO}" "${ip}: partition ${pathValue} size is not configured, skip check."
        return "$retValue"
    fi
    #־ռС
    ThresholdLog=130
    if [ "${pathValue}" = "/var/log" ]&&[ "${dirpath}" = "partion" ]
    then
        partitionAvailable=$(echo $partitionInfo | awk {'print $4'})
        partitionAvailable=$(echo ${partitionAvailable}/1024/1024 | bc)
        ifMoreThanLowerBound=$(echo "${partitionAvailable} >= ${ThresholdLog}" | bc)
        if [ ${ifMoreThanLowerBound} = 1 ]
        then 
            log "[INFO]" "${LINENO}" "${ip}: The available space of the '${pathValue}' partition is '${partitionAvailable}' (GB), which is large than the size '${ThresholdLog}'(GB) of logs to be retained for seven days."   
        else
            if [ ${partitionAvailable} -gt 50 ]
            then
                log "[WARNING]" "${LINENO}" "${ip}: The available space of the '${pathValue}' partition is '${partitionAvailable}' (GB). You are advised to allocate a partition with at least '${ThresholdLog}'(GB) for the log directory."
            else
                log "[ERROR]" "${LINENO}" "${ip}: The available space of the '${pathValue}' partition is '${partitionAvailable}' (GB). You are advised to allocate a partition with at least '${ThresholdLog}'(GB) for the log directory."
            fi
            
            retValue=1     
        fi
    fi
    
    #صǰ,ڵõĵطȫжϷǷ㹻
    partitionSize=$(echo $partitionInfo | awk {'print $2'})
    partitionSize=$(echo "scale=1; ${partitionSize}/1024/1024" | bc -l)
    partitionSizeLowerBound=$(echo $pathSize*0.9 | bc)
    ifMoreThanLowerBound=$(echo "${partitionSize} >= ${partitionSizeLowerBound}" | bc)
    
    #ָ·Ŀ¼,ҪȫַڷǷ㹻,Ϣ,㴦
    log "[INFO]" "${LINENO}" "${ip}: dirPathPartionInfo ${pathValue} ${pathSize} ${apartition} ${partitionSize}"
    retValue=10
    return $retValue
}

function checkIsTogether()
{
    diskPartitions=$(echo $1 | tr "|" " ")
    configPartition=$(echo $2 | tr "|" " ")

    ret=0

    for partitionName in ${configPartition}
    do
        if [[ "${diskPartitions}" =~ "${partitionName}" ]]
        then
            a=""
        else
            ret=1
        fi
    done
    return $ret
}


function checkNics()
{
    local nics=""
    if [ -f /sbin/ifconfig ]; then
        IFCONFIG="/sbin/ifconfig"
    else
        IFCONFIG="/usr/bin/ifconfig"
    fi
    [ -f ${IFCONFIG} ] && nics=$(${IFCONFIG} -a|grep ^eth|awk '{print $1}')
    [ -f /sbin/ip ] && nics=$(/sbin/ip a|grep ": en\|: eth"|awk '{print $2}'|cut -f1 -d ':')
    for nic in $nics
    do
        speed=$(${CMD_CHKETH} ${nic} | grep "Speed: " | sed 's/^.*Speed:\s*//g' | sed 's/Mb\/s$//g' | sed 's/Gb\/s$/000/g')
        result=$(echo ${speed} | grep "Unknown!")
        if [ "Unknown!" = "${result}" ]; then
            log "[WARNING]" "${LINENO}" "${ip}: Nic '${nic}' is not configured, speed is Unknown."
        fi

        result=$(echo ${speed} | egrep "[[:digit:]]+")
        if [ "" = "${result}" ]; then
            log "[WARNING]" "${LINENO}" "${ip}: Nic '${nic}' invalid config, speed is ${speed}."
        else
            if [ ${result} -ge 100 ]; then
                log "[INFO]" "${LINENO}" "${ip}: Nic '${nic}' speed configured '${result}Mb/s'."
            else
                log "[WARNING]" "${LINENO}" "${ip}: Nic '${nic}' speed configured '${result}Mb/s', speed is not enough."
            fi
        fi
    done
}

function checkIPv6Protocol()
{
    exec_cmd sysctl -a | grep ipv6
    ret=$?
    if [ $ret -ne 0 ]; then
        log "[ERROR]" "${LINENO}" "${ip}: IPv6 Protocol stack in ${ip} is closed, please check. return code:${ret}"
        return 1
    fi
}

function checkSshPort(){
    local clienSshPort=$(grep -E "[[:blank:]]*Port[[:blank:]]" /etc/ssh/ssh_config | awk -F " " '{print $NF}')
    local serverSshPort=$(grep -E "[[:blank:]]*Port[[:blank:]]" /etc/ssh/sshd_config | awk -F " " '{print $NF}')
    if [ "${clienSshPort}"X != "${serverSshPort}"X ]; then
        log "[ERROR]" "${LINENO}" "${ip}: The port of ssh_config<${clienSshPort}> and sshd_config<${serverSshPort}> are inconsistent."
        return 1
    fi
}

#-------------------------------------------------------------------------
#shell忪ʼ
#-------------------------------------------------------------------------


echo "=========================="

 
#¼ļiphostname
ip=$(echo "$1" | egrep '"nodes",[[:digit:]]+,"node","ip"' | cut -d '"' -f 8)
serviceip=$(echo "$1" | egrep '"nodes",[[:digit:]]+,"node","serviceip"' | cut -d '"' -f 8)
hostName=$(echo "$1" | egrep '"nodes",[[:digit:]]+,"node","hostname"' | cut -d '"' -f 8)
cpuCoreNum=$(echo "$1" | egrep '"nodes",[[:digit:]]+,"node","cpu"' | cut -d '"' -f 8)
memory=$(echo "$1" | egrep '"nodes",[[:digit:]]+,"node","memory"' | cut -d '"' -f 8)
timezone=$(echo "$1" | egrep '"nodes",[[:digit:]]+,"node","timezone"' | cut -d '"' -f 8)
g_ommid=$2

log "[INFO]" "${LINENO}" "${ip}: start checking host information:serviceip:${serviceip};hostName:${hostName}."

#ִscripts/modulesµļ
for checkItem in $(find $(dirname "$0")/../modules/ -name 'check.sh' | sort )
do
    exec_cmd "${checkItem}" "${ip}" "${g_ommid}" "${hostName}" "${serviceip}"
done

#cpu
checkCpuCoreNum "${cpuCoreNum}"

#ڴС
checkMemory "${memory}"

#ÿϢָɸ̵Ϣ
getConfigForEachDisk "$1"

#
checkDiskNum "${#diskConfigArray[@]}"

#ڵʱ
checkTimeZone "${timezone}"

#ֽȫ

${CMD_CHKMNT} 

initDiskPartitions

# 
checkNics

# IPV6ЭջǷ
checkIPv6Protocol

# ssh˿һ
checkSshPort

declare -a aPath
declare -a aPathSize
declare -a aPartion
declare -a aPartionSize
maxPath=0

#ÿ̵ϢõһиϢ
for j in "${!diskConfigArray[@]}"
do
    #ȡÿ̵·(/dev/[hs]d[a-z])  С
    diskName=$(echo "${diskConfigArray[${j}]}" | egrep '"nodes",[[:digit:]]+,"node","disks",[[:digit:]]+,"disk","name"' | cut -d '"' -f 12)
    diskSize=$(echo "${diskConfigArray[${j}]}" | egrep '"nodes",[[:digit:]]+,"node","disks",[[:digit:]]+,"disk","size"' | cut -d '"' -f 12)


    #ļָpathΪλ
    getConfigForEachPath "${diskConfigArray[${j}]}"
    
    if [ $? != 0 ]
    then
        log "[ERROR]" "${LINENO}" "${ip}: stop checking disk ${diskName}."
        continue
    fi

    unset g_PartitionNameArray
    unset g_PartitionArray
    
    maxPath=$((${maxPath} + ${#pathConfigArray[@]}))
    
    #жÿصӦСļǷһ
    for k in "${!pathConfigArray[@]}"
    do
        result=$(getPathinfo "${pathConfigArray[${k}]}")
        rt=$?
        echo "${result}"

        if [ $rt -eq 10 ];then
            tmp=$(echo "${result}" | grep "dirPathPartionInfo")
            if [ -n "${tmp}"  ];then
                tmpPath=$(echo "${tmp}" | cut -d ' ' -f 6 )
                tmpPathSize=$(echo "${tmp}" | cut -d ' ' -f 7 )
                tmpPartion=$(echo "${tmp}" | cut -d ' ' -f 8 )
                tmpPartionSize=$(echo "${tmp}" | cut -d ' ' -f 9 )
                
                m=1024
                #ҷѾռ,ͬʱҿλ
                for (( i = 0; i < "${maxPath}"; i++ ))
                do
                    
                    #Ƿհ,λ
                    if [ -z ${aPartion[${i}]} ];then
                        #¼һλ
                        if [ ${m} -eq 1024 ];then
                            m=${i}
                        fi
                        continue
                    fi
                    #ҵͺϲĿ¼ƺС
                    if [ "${tmpPartion}" = ${aPartion[${i}]} ]; then
                        aPath[i]=$(echo "${aPath[i]};${tmpPath}")
                        aPathSize[i]=$((${aPathSize[i]} + ${tmpPathSize}  ))
                         m=1024
                        break
                    fi
                done
                #ҵλ,ûҵͬ,¼
                if [ ${m} -lt 1024 ];then
                    aPath[m]=${tmpPath}
                    aPathSize[m]=${tmpPathSize}
                    aPartion[m]=${tmpPartion}
                    aPartionSize[m]=${tmpPartionSize}
                fi    
            fi
        fi
    done
done
#жÿСļ·Ƿһ
for k in "${!aPartion[@]}"
do  
    if [ -z ${aPartion[${k}]} ];then
        continue
    fi
    partitionSizeLowerBound=$(echo ${aPathSize[${k}]}*0.9 | bc)
    ifMoreThanLowerBound=$(echo "${aPartionSize[${k}]} >= ${partitionSizeLowerBound}" | bc)
    if [ ${ifMoreThanLowerBound} = 1 ];then
        log "[INFO]" "${LINENO}" "${ip}: the partition '${aPartion[${k}]}' size '${aPartionSize[${k}]}'(G) match the configured size '${aPathSize[${k}]}'(G) of directories:'${aPath[${k}]}'."    
    else
        log "[ERROR]" "${LINENO}" "${ip}: the partition '${aPartion[${k}]}' size '${aPartionSize[${k}]}'(G) does not match the configured size '${aPathSize[${k}]}'(G) of directories:'${aPath[${k}]}'."            
    fi
done
#űȫִʱҪ0űԱ֤ӡȷ־Ϣ
#㺯$?ֵΪűһִгɹ񣬴˾echoܱ֤űֵΪ0
log "[INFO]" "${LINENO}" "${ip}: execute the check scripts on host ${ip} success." 


