#!bin/bash
################################################################################
## Copyright:   HUAWEI Tech. Co., Ltd.
## Filename:    log.sh
## Description: 日志函数，由各个模块调用
## Version:     FusionInsight Hadoop V100R002C02
## Created:     May 24, 2017
################################################################################
# ---------------------------------------------------------------------------- #
#                                   函数定义                                   #
# ---------------------------------------------------------------------------- #
log()
{
    # 打印的日志级别
    local logLevel="$1"
    shift

    # 外部调用日志打印函数时所在的行号
    local lineNO="$1"
    shift

    # 打印时间、日志级别、日志内容、脚本名称、调用日志打印函数的函数、打印时的行号及脚本的进程号
    local logTime="$(date -d today +'%Y-%m-%d %H:%M:%S')"
	
    # 调用日志打印函数的函数名称
    local funcName="${FUNCNAME[1]}"
	
	
    echo "[${logTime}] ${logLevel} $* [${SCRIPT_NAME}(${funcName}):${lineNO}]($$)"

    return 0
}