#!/bin/bash

if [ -f "$HOME/.bashrc" ]; then
    . $HOME/.bashrc
fi

if [[ $UID -ne 0 && -n "${INSTALL_SUDO_PATH}" ]];then
    export CMD_CHKETH="sudo ${INSTALL_SUDO_PATH} check_ethtool" 
    export CMD_CHKSUDOERS="sudo ${INSTALL_SUDO_PATH} check_sudoers" 
    export CMD_CHKSRV="sudo ${INSTALL_SUDO_PATH} check_service" 
    export CMD_CHKPRF="sudo ${INSTALL_SUDO_PATH} check_profile" 
    export CMD_CHKHST="sudo ${INSTALL_SUDO_PATH} check_hosts" 
    export CMD_CHKNST="sudo ${INSTALL_SUDO_PATH} check_netstat" 
    export CMD_CHKMNT="sudo ${INSTALL_SUDO_PATH} check_mounta" 
    export CMD_CHKDFP="sudo ${INSTALL_SUDO_PATH} check_dfP" 
    export CMD_CHKTAL="sudo ${INSTALL_SUDO_PATH} check_tail"
    export CMD_CHKCTL="sudo ${INSTALL_SUDO_PATH} check_sysctl"
    export CMD_CHKITP="sudo ${INSTALL_SUDO_PATH} check_iftop"
    export CMD_CHKCRN="sudo ${INSTALL_SUDO_PATH} check_cron"
    export CMD_CHKFND="sudo ${INSTALL_SUDO_PATH} check_find"
    export CMD_CHKSMT="sudo ${INSTALL_SUDO_PATH} check_smartctl"
    export CMD_CHKSTAT="sudo ${INSTALL_SUDO_PATH} check_stat"
else
    if [ -f /sbin/ethtool ]; then
        export CMD_CHKETH="/sbin/ethtool"
    else
        export CMD_CHKETH="/usr/sbin/ethtool"
    fi
    export CMD_CHKSUDOERS="cat /etc/sudoers" 
    export CMD_CHKSRV="/sbin/service" 
    export CMD_CHKPRF="write_nss"
    export CMD_CHKHST="check_root_hosts"
    export CMD_CHKNST="netstat" 
    export CMD_CHKMNT="mount -a" 
    export CMD_CHKDFP="df -P" 
    export CMD_CHKTAL="tail -n "
    export CMD_CHKCTL="/sbin/sysctl -p"
    export CMD_CHKITP="check_root_iftop"
    export CMD_CHKCRN="cat"
    export CMD_CHKFND="find"
    export CMD_CHKSMT="/usr/sbin/smartctl"
    export CMD_CHKSTAT="stat"

    ################################################################################
    # Function: check_iftop
    # Description: iftop
    # Parameter:
    #   input:
    #   $1 : Path
    #   $2 : params
    #   $3 : lan
    #   output:
    #   N/A
    # Return: 0 -- success; not 0 -- failure
    # Others: N/A
    ################################################################################    
    function write_nss()
    {
        sed -i "/NSS_SDB_USE_CACHE=/d" /etc/profile
        echo "export NSS_SDB_USE_CACHE=no">>/etc/profile
        return $?
    }
    ################################################################################
    # Function: check_iftop
    # Description: iftop
    # Parameter:
    #   input:
    #   $1 : Path
    #   $2 : params
    #   $3 : lan
    #   output:
    #   N/A
    # Return: 0 -- success; not 0 -- failure
    # Others: N/A
    ################################################################################    
    function check_root_iftop()
    {   
        Path=$1
        params=$2
        lan=$3
        if [ -z ${Path} ]||[ -z ${lan} ]||[ -z ${params} ];then
            return 1
        fi    
        ${Path}/Lib/iftop/iftop ${params} ${lan}
        return $? 
    }
    ################################################################################
    # Function: check_root_hosts
    # Description: ֻɾFIװĿ¼Ŀ¼־Ŀ¼HomeĿ¼µļ
    # Parameter:
    #   input:
    #   $1 : serviceip
    #   $2 : hostNamecfg
    #   output:
    #   N/A
    # Return: 0 -- success; not 0 -- failure
    # Others: N/A
    ################################################################################  
    function check_root_hosts()
    {   
        serviceip=$1
        hostNamecfg=$2

        if [ -z ${serviceip} ]||[ -z ${hostNamecfg} ];then
            return 1
        fi    
        
        echo ${serviceip} ${hostNamecfg}>>/etc/hosts
        return $? 
    }
    export -f check_root_hosts
    export -f check_root_iftop
    export -f write_nss
    
fi  