#!/bin/bash

checkDns()
{
    ip=$1
    local dns_file="/etc/resolv.conf"

    log "[INFO]" "${LINENO}" "${ip}: start checking DNS configuration in file ${dns_file}."

    if [ ! -f ${dns_file} ]; then
        log "[INFO]" "${LINENO}" "${ip}: ${dns_file} doesn't exist."
        return
    fi

    ${CMD_CHKCRN} ${dns_file} | grep -q ^[[:blank:]]*nameserver

    if [ $? -eq 0 ]; then
        log "[WARNING]" "${LINENO}" "${ip}: If nameserver is configured improperly, the network speed is slowed down, which affects the subsequent installation or operations. Check whether the item is correctly configured."
    else
        log "[INFO]" "${LINENO}" "${ip}: nameserver is not configured in the file ${dns_file}."
    fi
}

