#!/bin/bash

function checkHostName() 
{
    log "[INFO]" "${LINENO}" "${ip}: start checking hostname in shell."
    ip=$1
    flag=0
    #Զĵǰshellлȡhostname
    hostNameToCheck=$(hostname)

    # hostnameʽ
    formatCheck=$(echo ${hostNameToCheck} | egrep "^[a-zA-Z0-9]([-a-zA-Z0-9]*[a-zA-Z0-9])*$")
    if [ -z "${formatCheck}" ]
    then
        log "[ERROR]" "${LINENO}" "${ip}: hostname '${hostNameToCheck}' format error, correct format is '^[a-zA-Z0-9]([-a-zA-Z0-9]*[a-zA-Z0-9])*\$'"
    fi

    formatCheck=$(echo ${hostNameToCheck} | egrep ^"[[:digit:]]+$")
    if [ -n "${formatCheck}" ]; then
        log "[ERROR]" "${LINENO}" "${ip}: The host name cannot contain only digits."
    fi

    log "[INFO]" "${LINENO}" "${ip}: start checking hostname in config file."

    #Զļлȡhostname
    if [ -f /etc/sysconfig/network ]
    then
        hostnameFile=/etc/sysconfig/network
        hostName_hosts=$(${CMD_CHKCRN} ${hostnameFile} | grep "HOSTNAME" | grep -vw "^[[:space:]]*#[[:space:]]*HOSTNAME" | grep "${hostNameToCheck}")
        
    elif [ -f /etc/HOSTNAME ]
    then
        hostnameFile=/etc/HOSTNAME
        hostName_hosts=$(${CMD_CHKCRN} ${hostnameFile} | grep -vw "^[[:space:]]*#*" | grep "${hostNameToCheck}")
    fi

    if [ -f "/etc/redhat-release" ]; then
        ${CMD_CHKCRN} "/etc/redhat-release" | grep "release 7" > /dev/null 2>&1
        if [ $? -eq 0 ]; then
            hostnameFile=/etc/hostname
            hostName_hosts=$(${CMD_CHKCRN} ${hostnameFile} | grep -vw "^[[:space:]]*#*" | grep "${hostNameToCheck}")
        fi
    fi

    which hostnamectl > /dev/null 2>&1
    if [ $? -eq 0 ]; then
        which hostname > /dev/null 2>&1
        if [ $? -eq 0 ]; then
           hostnameFile=/etc/hostname
           hostName_hosts=$(${CMD_CHKCRN} ${hostnameFile} | grep -vw "^[[:space:]]*#*" | grep "${hostNameToCheck}")
        fi
    fi
    
    if [ -z "${hostName_hosts}" ]
    then
        log "[ERROR]" "${LINENO}" "${ip}: the hostname in ${hostnameFile} does not match ${hostNameToCheck}."
    fi

}