#!/bin/bash

#-------------------------------------------------------------------------------------
# ָϵͳУnss-softokn.x86_64.rpmnss-util.x86_64.rpmİ汾ź
#-------------------------------------------------------------------------------------
function checkNSS()
{
    ip=$1
    log "[INFO]" "${LINENO}" "${ip}: start checking NSS version and configuration."
        
    NEED_ADD_SOFTOKN=0
    NEED_ADD_UTIL=0
    UPGRADE_NSS_SOFTOKN=0
    UPGRADE_NSS_UTIL=0

    #nss-softoknҪͰ汾3.14.3-22
    NSS_NEED_VER=3.14.3
    NSS_NEED_MIN_VER=22
        
    #nss-utilҪͰ汾3.16.2.3-2
    UTIL_NEED_VER=3.16.2.3
    UTIL_NEED_MIN_VER=2

    #鵱ǰϵͳǷΪָ
    check_os_type "redhat-6.4;redhat-6.5;redhat-6.6;redhat-6.7;redhat-6.8;redhat-6.9;redhat-7;redhat-7.1;redhat-7.2;redhat-7.3;redhat-7.4;redhat-7.5;redhat-7.6;centos-6.4;centos-6.5;centos-6.6;centos-6.7;centos-6.8;centos-6.9;centos-7;centos-7.1;centos-7.2;centos-7.3;centos-7.4;centos-7.5;centos-7.6;rhel-7;rhel-6;euleros-2.0;euleros-2.0sp1;euleros-2.0sp2;euleros-2.0sp3;euleros-2.0sp5;euleros-2.0sp8;euleros-2.0sp9;neokylin-5.5;neokylin-6.9;neokylin-7.2;neokylin-7.4;oracle-7.4;oracle-7.5;oracle-7.6"
    if [ $? -ne 0 ]; then
        log "[ERROR_DEBUG]" "${LINENO}" "${ip}: Do not need to check the NSS version on the current OS."
        return 0
    fi
     
    #nss-softokn.x86_64.rpm汾 
    NSS_SOFTOKN=$(rpm -qa | grep "nss-softokn-[0-9]")
    if [ $? -eq 0 ]; then
        SOFTOKN_VER_S=$(echo "${NSS_SOFTOKN}" | awk -F'-' '{printf("%s", $3)}')
        SOFTOKN_MIN_VER_S=$(echo "${NSS_SOFTOKN}" | awk -F'-' '{printf("%s", $4)}' | awk -F'.' '{printf("%s",$1)}' )
        SOFTOKN_VER_D=$(echo "${SOFTOKN_VER_S}" | awk -F'.' '{printf("%d%03d%03d%03d", $1,$2,$3,$4)}')
        SOFTOKN_MIN_VER_D=${SOFTOKN_MIN_VER_S}
        NSS_NEED_VER_D=$(echo "${NSS_NEED_VER}" | awk -F'.' '{printf("%d%03d%03d%03d", $1,$2,$3,$4)}')

        if [ "$SOFTOKN_VER_D" -lt "$NSS_NEED_VER_D"  ]; then
            UPGRADE_NSS_SOFTOKN=1
        elif [ "$SOFTOKN_VER_D" -eq "$NSS_NEED_VER_D" ] && [ "$SOFTOKN_MIN_VER_D" -lt "$NSS_NEED_MIN_VER" ]; then
            UPGRADE_NSS_SOFTOKN=1
        fi
    else
        NEED_ADD_SOFTOKN=1
    fi

    #nss-util.x86_64.rpm汾 
    NSS_UTIL=$(rpm -qa | grep "nss-util-[0-9]")
    if [ $? -eq 0 ]; then
        UTIL_VER_S=$(echo "${NSS_UTIL}" | awk -F'-' '{printf("%s", $3)}')
        UTIL_MIN_VER_S=$(echo "${NSS_UTIL}" | awk -F'-' '{printf("%s", $4)}'   | awk -F'.' '{printf("%s",$1)}')
        UTIL_VER_D=$(echo "${UTIL_VER_S}" | awk -F'.' '{printf("%d%03d%03d%03d", $1,$2,$3,$4)}')
        UTIL_MIN_VER_D=${UTIL_MIN_VER_S}
        UTIL_NEED_VER_D=$(echo "${UTIL_NEED_VER}" | awk -F'.' '{printf("%d%03d%03d%03d", $1,$2,$3,$4)}')

        if [ "$UTIL_VER_D" -lt "$UTIL_NEED_VER_D" ]; then
            UPGRADE_NSS_UTIL=1
        elif [ "$UTIL_VER_D" -eq "$UTIL_NEED_VER_D" ] && [ "$UTIL_MIN_VER_D" -lt "$UTIL_NEED_MIN_VER" ]; then
            UPGRADE_NSS_UTIL=1
        fi
    else
        NEED_ADD_UTIL=1
    fi

    if [ $NEED_ADD_SOFTOKN -eq 1 ]; then
        log "[ERROR]" "${LINENO}" "${ip}: Need to install nss-softokn.x86_64 rpm package. Required version is ${NSS_NEED_VER}-${NSS_NEED_MIN_VER} or later."
    elif [ $UPGRADE_NSS_SOFTOKN -eq 1 ]; then
        log "[ERROR]" "${LINENO}" "${ip}: Need to upgrade nss-softokn.x86_64 version to ${NSS_NEED_VER}-${NSS_NEED_MIN_VER} or later."
    fi

    if [ $NEED_ADD_UTIL -eq 1 ]; then
        log "[ERROR]" "${LINENO}" "${ip}: Need to install nss-util.x86_64 rpm package. Required version is ${UTIL_NEED_VER}-${UTIL_NEED_MIN_VER} or later."
    elif [ $UPGRADE_NSS_UTIL -eq 1 ]; then
        log "[ERROR]" "${LINENO}" "${ip}: Need to upgrade nss-util.x86_64 version to ${UTIL_NEED_VER}-${UTIL_NEED_MIN_VER} or later."
    fi

    COUNT=$((NEED_ADD_SOFTOKN + NEED_ADD_UTIL + UPGRADE_NSS_SOFTOKN + UPGRADE_NSS_UTIL))
    if [ $COUNT -ne 0 ]; then
        log "[ERROR_DEBUG]" "${LINENO}" "${ip}: Failed to check NSS version and configuration."
        return 1
    fi
    
    return 0
}

#-------------------------------------------------------------------------------------
# 鵱ǰϵͳǷΪָĲϵͳ
# $1 ָĲϵͳͣ"redhat-6.4;redhat-6.5"
#-------------------------------------------------------------------------------------
function check_os_type()
{
    source "$(dirname "$0")"/checkOS.sh > /dev/null 2>&1
    local support="$1"
    local name=""
    
    name=$(get_osname|cut -f1 -d '.')
    
    #ǰosͲredhat/suse/centos֮һ
    if [ $? -ne 0 ]; then
        return 1
    fi
    
    echo "${support}" | grep -q "${name}"
    
    #ǰosͲҪĲϵͳб
    if [ $? -ne 0 ]; then
        return 1
    fi
    
    return 0
}




