#!/bin/bash

#检查是否安装NTP服务
#该检查项需要放置在检查os之后，即必须确保当前os类型满足系统要求

function checkNtp()
{
    ip=$1
    log "[INFO]" "${LINENO}" "${ip}: start checking ntp service."
    
    if [ -z "$(/bin/rpm -qa | grep -w "^ntp")" ];then
        log "[WARNING]" "${LINENO}" "${ip}: The NTP service is not available."
    else
        ntp_version=$(rpm -qa | grep ntp | grep "ntp-4.2.8p3")
        if [ -n "${ntp_version}" ]; then
            log "[ERROR]" "${LINENO}" "${ip}: The NTP version(${ntp_version}) has defects, which may cause an OMS installation failure. Install the system patch to upgrade the system version."
        fi

        ntp_version=$(rpm -qa | grep ntp | grep "ntp-4.2.8p4")
        if [ -n "${ntp_version}" ]; then
            log "[ERROR]" "${LINENO}" "${ip}: The NTP version(${ntp_version}) has defects, which may cause an OMS installation failure. Install the system patch to upgrade the system version."
        fi
        
        ntp_version=$(rpm -qa | grep ntp | grep "ntp-4.2.6")
        if [ -n "${ntp_version}" -a -f "/etc/SuSE-release" ]; then
            log "[ERROR]" "${LINENO}" "${ip}: The NTP version(${ntp_version}) has defects, which may cause a time synchronization failure between the active OMS and other nodes. Install the system patch to upgrade the system version."
        fi
    fi
}

