#!/bin/bash

################################################
# Usage: checkPlatform.sh
# :  鴦
#
################################################

###################################################
#鴦
#
###################################################

function check_platform()
{
    ip=$1
    log "[INFO]" "${LINENO}" "${ip}: start checking file platform."

    local system_uname=""
    local precheck_constants_file="$(dirname "$0")/../../precheck_constants"
    local platform=$(cat ${precheck_constants_file} | grep "g_platform" | awk -F "=" '{print $2}')

    if [ -z "${platform}" ]; then
        log "[ERROR]" "${LINENO}" "${ip}: No 'g_platform' is set in the ${precheck_constants_file} file."
        return 1
    fi

    if [ "${platform}" = "upgrade" ]; then
        log "[INFO]" "${LINENO}" "${ip}: 'g_platform' is upgrade , skip checking."
        return 0
    fi

    system_uname=$(uname -p)

    if [ $? -ne 0 ]; then
        log "[ERROR]" "${LINENO}" "${ip}: 'uname -p' Command execution failed."
        return 1
    fi

    if [ X"$system_uname" != X"$platform" ]; then
        log "[ERROR]" "${LINENO}" "${ip}: Check the information of platform Failed"
    else
        log "[INFO]" "${LINENO}" "${ip}: Check the information of platform successfully"
    fi
}

