#!/bin/bash

########################################################################################
#1Ϊ¼ID
#    0Ŀ¼Ϊã֮ǰĿ¼ạ̃ҵµָ̻
#    1Ŀ¼Ϊãص̷ʧ̣
#
#2ΪӦĹĿ¼
#    磺/srv/BigData/data1
########################################################################################

##
PARANUM=2  #Ϸ

##ӡ
echo `date` "`basename $0` paras:" "[$*]"
echo `date` "`basename $0` para[1]:" "$1"
echo `date` "`basename $0` para[2]:" "$2"

if [ $# -ne ${PARANUM} ]; then
    echo `date` "`basename $0` failed: paras num($#) is not ${PARANUM}"
    exit 1
fi


##ȷϷʼֵ
ALARM_ID=$1
ALARM_TYPE=2                    # ̶ֵ2ʾ澯Ϊ¼ָ
ALARM_DIR="$(readlink -m $2)"   #豸ӦĹصĿ¼
ALARM_MODULE=""                 #ģzookkeep,bookeeperȣԲע
ALARM_INFO=""                   #ϢԲע

#
declare CLOUD_FLAG_FILE="/usr/local/diskmgt/ini/cloud"
declare DISKMGT_NOTIFY_LOG_HOME="/var/log/diskmgt/notify"
declare LOGFILE="${DISKMGT_NOTIFY_LOG_HOME}/cloud_common_notify.log"
declare CONF_DIR="/usr/local/diskmgt/ini-plugin/conf/"

###############################################################
# ־
###############################################################
function LOG()
{
    local log_size=0
    
    if [ ! -d ${DISKMGT_NOTIFY_LOG_HOME} ]; then
        mkdir -p ${DISKMGT_NOTIFY_LOG_HOME}
        chown root:root ${DISKMGT_NOTIFY_LOG_HOME}
        chmod 700 ${DISKMGT_NOTIFY_LOG_HOME}
    fi
    
    if [ ! -e "$LOGFILE" ]; then
        touch "$LOGFILE"
        chown root:root "$LOGFILE"
        chmod 600 ${LOGFILE}
        LOG "INFO" "Set ${LOGFILE} files permission is $(ls -ld ${LOGFILE})"
    fi
    
    printf "`date -d today +\"%Y-%m-%d %H:%M:%S\"`,000 $1 $2\n" >> "$LOGFILE" 2>/dev/null
    
    log_size=`du -ms $LOGFILE |cut -f1`
    if [ $log_size -gt 50 ]; then
        #־ļ50M򱸷־ļ
        mv ${LOGFILE} ${LOGFILE}_bak
    fi
}

###############################################################
# ־ͬʱϢ̨
###############################################################
function LOG_AND_ECHO()
{
    echo `date` $@
    LOG "$@"
}

################################################################################
# Function: get_cur_path
# Description: ȡűڵĿ¼ű
# Parameter:
#   input:
#   N/A
#   output:
#   N/A
# Return: 0 -- success; not 0 -- failure
# Others: N/A
################################################################################
get_cur_path()
{
    cd "$(dirname "${BASH_SOURCE-$0}")"
    g_curPath="${PWD}"
    g_scriptName="$(basename "${BASH_SOURCE-$0}")"
    cd - > /dev/null
}

################################################################################
# Function: verify
# Description: Уű
# Parameter:
#   input:
#   N/A
#   output:
#   N/A
# Return: 0 -- success; not 0 -- failure
# Others: N/A
################################################################################
verify()
{
    if [ $# -ne ${PARANUM} ]; then
        LOG "ERROR" "Verify failed: paras num($#) is not ${PARANUM}."
        return 1
    fi
    
    if [ ! -f ${CLOUD_FLAG_FILE} ]; then
        LOG "ERROR" "Verify failed: file ${CLOUD_FLAG_FILE} doesn't exist. It's not a cloud clouster."
        return 1
    fi
    
    if [ ${ALARM_ID} -ne 0 ] && [ ${ALARM_ID} -ne 1 ]; then
        LOG "ERROR" "Verify failed: First input param can be only 0 or 1. Now it's ${ALARM_ID}."
        return 1
    fi
    
    local inputDir=${ALARM_DIR}
    if [ ! -d ${inputDir} ]; then
        LOG "ERROR" "Verify failed: Second input param ${inputDir} is not a directory."
        return 1
    fi
    
    inputDir="$(readlink -m ${inputDir})"
    mount | grep -q "[[:space:]]${inputDir}[[:space:]]"
    if [ $? -ne 0 ]; then
        LOG "ERROR" "Verify failed: ${inputDir} is not mounted. Please check!"
        return 1
    fi
    
    LOG "INFO" "Verify success."
    return 0
}

################################################################################
# Function: init_params
# Description: ʼҪõnotifyű
# Parameter:
#   input:
#   N/A
#   output:
#   N/A
# Return: 0 -- success; not 0 -- failure
# Others: N/A
################################################################################
init_params()
{
    local script=$1
    local confFile="$(grep -r "${script}" ${CONF_DIR} | head -n 1 | awk -F ':' '{print $1}')"
    local module=""
    if [ -f "$confFile" ]; then
        module="$(grep -w 'name' $confFile | awk -F '=' '{print $2}')" 
    fi
    
    if [ -z "${module}" ]; then
        LOG "WARN" "Failed to get module name for ${script}."
        ALARM_MODULE=${script}
    else
        ALARM_MODULE=${module}
    fi
    
    
    if [ ${ALARM_ID} -eq 0 ]; then
        ALARM_INFO="mount ok"
    fi
    
    if [ ${ALARM_ID} -eq 1 ]; then
        ALARM_INFO="partition lost"
    fi
}
################################################################################
# Function: call_notify_script
# Description: notifyű
# Parameter:
#   input:
#   N/A
#   output:
#   N/A
# Return: 0 -- success; not 0 -- failure
# Others: N/A
################################################################################
call_notify_script()
{
    local retVal=0
    for file in $(ls ${g_curPath})
    do
        if [ "${file}" = "${g_scriptName}" ] || [ "${file}" = "clickhouse_get_replica.py" ]; then
            LOG_AND_ECHO "INFO" "Skip ${file}." 
            continue
        fi
        
        init_params ${file}
        
        local notify_script=${g_curPath}/${file}
        LOG "INFO" "===== Start to call ${file} with params [${ALARM_ID} ${ALARM_TYPE} ${ALARM_DIR} ${ALARM_MODULE} ${ALARM_INFO}]=====."
        LOG "INFO" "Command line: [ sh ${notify_script} ${ALARM_ID} ${ALARM_TYPE} \"${ALARM_DIR}\" \"${ALARM_MODULE}\" \"${ALARM_INFO}\" ]."
        sh ${notify_script} "${ALARM_ID}" "${ALARM_TYPE}" "${ALARM_DIR}" "${ALARM_MODULE}" "${ALARM_INFO}" >> ${LOGFILE} 2>&1
        if [ $? -eq 0 ]; then
            LOG_AND_ECHO "INFO" "Success to execute ${file}."
        else
            LOG_AND_ECHO "ERROR" "Failed to execute ${file}."
            LOG "INFO" "Please view ${DISKMGT_NOTIFY_LOG_HOME}/${file%.sh}.log for detail info."
            retVal=$((${retVal}+1))
        fi
    done
    
    if [ $retVal -eq 0 ]; then
        LOG_AND_ECHO "INFO" "Success to execute all notify scripts."
    else
        LOG_AND_ECHO "ERROR" "Failed to execute ${retVal} notify scripts."
    fi
    
    return $retVal
}

################################
#߼
################################
function main()
{
    LOG_AND_ECHO "INFO" "Start to run cloud_common_notify.sh with param: [$*]."
    
    #õǰumask
    UMASK=0077
    umask "$UMASK"
    
    verify $@
    if [ $? -ne 0 ]; then
        LOG "ERROR" "Failed to verify."
        return 1
    fi
    
    get_cur_path
    
    call_notify_script $@
    if [ $? -ne 0 ]; then
        LOG "ERROR" "Failed to call components notify script."
        return 1
    fi
    
    LOG "INFO" "Success to run cloud_common_notify.sh."
    return 0
}

#ִ
main $@
retVal=$?
if [ $retVal -eq 0 ]; then
    LOG_AND_ECHO "INFO" "Success to run cloud_common_notify.sh."
else
    LOG_AND_ECHO "ERROR" "Failed to run cloud_common_notify.sh. Please view ${LOGFILE} for detail info."
fi

exit $retVal

