#!/bin/bash

###################################################
#
# 功能:  在各节点创建工作空间
#
###################################################
function gen_workspace()
{
    local work_space="$1" #工作空间
    local ipaddr="$2"     #主机名或ip地址

    debug "[${work_space}:${ipaddr}]Enter [${FUNCNAME}:${LINENO}]"

    #入参判断
    if [ -z "$work_space" ] || [ -z "$ipaddr" ]; then
        error "[${FUNCNAME}:${LINENO}]" "Parameter error, work_space:${work_space},ipaddr:${ipaddr}."
        return 1
    fi

    #创建工作目录(先删除,再创建,以保证工作目录为空)
    exec_cmd_r "$ipaddr" "360" "rm -rf ${g_work_space};mkdir ${g_work_space}"
    if [ $? -ne 0 ]; then
        return 1
    fi

    debug "Leave [${FUNCNAME}:${LINENO}]"

    return 0
}

###################################################
#
# 功能:  删除各节点的工作空间
#
###################################################
function del_workspace()
{
    local work_space="$1" #工作空间
    local ipaddr="$2"     #主机名或ip地址

    debug "[${work_space}:${ipaddr}]Enter [${FUNCNAME}:${LINENO}]"

    #入参判断
    if [ -z "$work_space" ] || [ -z "$ipaddr" ]; then
        error "[${FUNCNAME}:${LINENO}]" "Parameter error, work_space:${work_space},ipaddr:${ipaddr}."
        return 1
    fi

    #删除工作空间
    exec_cmd_r "$ipaddr" "120" "rm -rf ${g_work_space}" "0" > /dev/null
    if [ $? -ne 0 ]; then
        error "[${FUNCNAME}:${LINENO}]" "del work space failed on ${ipaddr}"
        return 1
    fi

    debug "Leave [${FUNCNAME}:${LINENO}]"

    return 0
}