#!/bin/bash

######################################################################
#   DESCRIPTION: 设置max_map_count
######################################################################
function set_vm_max_map_count()
{
    set_sysctl "vm.max_map_count" "1048576"
    if [ $? -ne 0 ]; then
        echo "[$(date)] ERROR : Exception occurs when Setting the vm.max_map_count."
        return 1
    fi
    
    return 0
}

######################################################################
#   DESCRIPTION:设置vm主执行函数   
######################################################################
function main()
{
    local os_name=""
    local base_dir=$(dirname $0)
    local adapter_script="${base_dir}/adapter.sh"
    local osperf_conf="${base_dir}/osperf.conf"
    
    . "${osperf_conf}"
    source "${adapter_script}"
    
    if [ "${osperf_vm_max_map_count}" -eq 1 ]; then    
        set_vm_max_map_count
        if [ $? -ne 0 ]; then
            echo "[$(date)] ERROR : Exception occurs when set vm max map count."
            return 1
        fi
    fi

    echo "[$(date)] INFO : Setting vm max map count successfully."    
    
    return 0
}

main
exit $?