#!/bin/bash

#־Ŀ¼ļ
LOGPATH="/var/log/diskmgt/"
LOGFILE="/var/log/diskmgt/diskmgtraid.log"


########################################################################
#  ¼־װ
# 1˵0 ֻʾն
#            1 ֻ¼־ļ
#            2 ʾնˣ¼־ļһҪϢ
#            3 debug־
# 2˵־
#
# ֵ   0 ɹ
#            1 ʧ
########################################################################
function logme()
{
    local log_mode=$1
    local log_info="$2"
    
    UMASK=0027
    umask "$UMASK"
    
    if [ $# -ne 2 ]; then
        echo "logme para invalid."
        return 1
    fi
    
    if [ ! -e "${LOGPATH}" ]; then
        mkdir -p "${LOGPATH}"
    fi
    
    if [ ${log_mode} -eq 0 ]; then
        echo "[$(date)] ${log_info}"
    elif [ ${log_mode} -eq 1 ]; then
        echo "[$(date)] ${log_info}" >>"${LOGFILE}"
    elif [ ${log_mode} -eq 2 ]; then
        echo "[$(date)] ${log_info}" | tee -a "${LOGFILE}"
    elif [ ${log_mode} -eq 3 ]; then
        if [ -f "${DEBUGSWITCH}" ]; then  #ļǿdebugģĬϹرգ̫࣬λʱԿ
            echo "[$(date)] ${log_info}" | tee -a "${LOGFILE}"
        fi
    else
        echo "logme invalid mode para."
        return 1
    fi
    
    return 0
}



########################################################################
#  鵵־
# 1˵
#
# ֵ   0 ɹ
#            1 ʧ
########################################################################
function backup_log_file()
{
    local fileSize=0                #ǰ־ļС
    local timeNow=0                 #ϵͳǰʱ
    local counter=2                 #ѹļ
    local backupFile=""             #ļ
    local allBackupCounter=0        #ļ
    local deleteFileName=0          #ɾѹļ
    
    local MAX_LOG_FILE_SIZE=1024    #־ļС(K)
    local MAX_ALLbackupFile_SIZE=10 #ѹļ
    
    #õǰumask
    UMASK=0027
    umask "$UMASK"
    
    if [ -z "${LOGFILE}" ]; then
        return 1
    fi
    
    if [ ! -f "${LOGFILE}" ]; then
        return 1
    fi
    
    #ȡ־ļС(K)
    fileSize=$(du -a "${LOGFILE}" |cut -f1)
    if [ -z "${fileSize}" ]; then
        return 1
    fi
    
    #ǰ־ССֱӷ
    if [ "${fileSize}" -lt "${MAX_LOG_FILE_SIZE}" ]; then
        return 0
    fi
    
    #ȡõǰʱ
    timeNow=$(date +'%Y%m%d%H%M%S')
    
    #ȡǰѹļ
    backupFile="${LOGFILE}.${timeNow}"
    while [ -f "${backupFile}" ]
    do
        backupFile="${LOGFILE}.${timeNow}_${counter}"
        ((counter++))
    done
    
    #־ļѹ
    cp "${LOGFILE}" "${backupFile}" && cat /dev/null > "${LOGFILE}"    
    gzip "${backupFile}"
    chmod 640 "${backupFile}".gz
    
    #жѹļ 
    local DirPath=$(dirname "${LOGFILE}") 
    local LogName=$(basename "${LOGFILE}") 
    allBackupCounter=$(find "${DirPath}" -type f | grep "${LogName}"* |wc -l)    
    
    #ѹļʱɾ
    while [ "${allBackupCounter}" -gt "${MAX_ALLbackupFile_SIZE}" ]
    do
        deleteFileName=$(ls -lrt $LOGFILE* | awk 'NR==1 {print $NF}')        
        rm -rf "${deleteFileName}"
        allBackupCounter=$(find "${DirPath}" -type f | grep "${LogName}"* |wc -l)
    done
    
    return 0
}
