#!/bin/bash


###############################################################################
#author:   none
#date:     2015/04/30
#function: LSI 2208 RAID
###############################################################################


pushd $(dirname "$0") >/dev/null 2>&1
CUR_DIR="$(pwd)"
popd >/dev/null 2>&1

LOG_SCRIPT="${CUR_PATH}/log.sh"

#־
. ${LOG_SCRIPT}



#ļ
LOCKFILE="${HOME}/diskmgtdraid.lock"


#ÿRAIDҪ޸ĴӦRAIDͺ
RAID_NAME=""
RAID_CMD=""



RAID_LEVEL=""
ALL_CTL_INDEX="${HOME}/all_ctl_index"
PHYSICAL_DRIVES_TMP="${HOME}/raid_physical_drives_tmp"


########################################################################
#  ʾϢ
# 1˵
#
# ֵ   0 ɹ
########################################################################
function show_help()
{
    echo
    echo "Usage: `basename $0` [option]"
    echo "options:"
    echo "-n         Notes: check raid controller."
    echo "-c         Notes: check raid health."
    echo "-g         Notes: get_raid_disk."
    echo
    echo "Example:"
    echo "`basename $0` -n"
    echo "`basename $0` -c"
    echo "`basename $0` -g"
    echo "`basename $0` -h"
    echo
    
    return 0
}



########################################################################
#  жϵǰRAIDǲǸűģ
#            űҪʵָú
# 1˵
#
# ֵ   0 ɹ
#            1 ʧ
########################################################################
function is_adapter_raid()
{
    return 0
}


########################################################################
#  鵱ǰraidĽ״̬
#            űҪʵָúúʱΪ
# 1˵
#
# ֵ   0 
#            1 
########################################################################
function check_raid_health()
{
    return 0
}


########################################################################
#  ǰеĿռĴ̴RAID
#            űҪʵָú
# 1˵
#
# ֵ   0 ɹ
#            1 ʧ
########################################################################
function create_raid_all()
{
    local raid_level=$1
    
    return 0
}



########################################################################
#  ȡеRAIḌûУҪ
#            űҪʵָú
# 1˵
#
# ֵ   0 ɹ
#            1 ʧ
########################################################################
function get_blank_disk_from_raid()
{
    return 0
}


########################################################################
#  
# 1˵
#
# ֵ   
########################################################################
function clean_lock()
{
    rm -rf "${LOCKFILE}"
}


########################################################################
#  źŴ
# 1˵
#
# ֵ   2 źŴ
########################################################################
function sig_catch()
{
    logme 2 "[EMER] [${FUNCNAME}:${LINENO}] catch signal!!"
    clean_lock
    exit 2
}

#ź
trap "sig_catch" INT TERM QUIT
backup_log_file

########################################################################
#  Ϊ㺯ķΧ
# 1˵ű
#
# ֵ   0 ɹ
#            1 ͨʧܴ
#            2 źŴ
#            3 ȡʧܴ
#            4 ϴαǿɱ̵µ
#            5 ̨Ӳ̹
########################################################################
{    
    flock -n 3
    #ȡʧܣҪж֮ǰǷǱǿɱ̵
    if [ $? -ne 0 ]; then
        logme 2 "[ERROR] [none:${LINENO}] `basename $0` locked by another user."
        exit 3
    fi
    
    IS_CHECK=0
    IS_GETDISK=0
    IS_GETNAME=0
    IS_INIT=0
    
    #űвĴ
    while getopts "ni:c:g:h" options;
    do
        case ${options} in
            c)
                IS_CHECK=1  #齡
                RAID_LEVEL=${OPTARG}
                ;;
                
            g)
                IS_GETDISK=1  #ȡհ׵Ĵ
                RAID_LEVEL=${OPTARG}
                ;;
                
            n)
                IS_CHECKNAME=1 #RAIDͺ
                ;;
            i)
                IS_INIT=1    #ʼRAIDеĴ̶RAID
                RAID_LEVEL=${OPTARG}
                ;;
            h)
                show_help  #
                exit $?
                ;;
                
            *)
                logme 2 "[ERROR] [none:${LINENO}] invalid input!!"  #Ƿ
                show_help
                exit 1
                ;;
        esac
    done
    
    #ֹֽͣӿ
    if [ ${IS_CHECKNAME} -eq 1 ]; then
        is_adapter_raid
    elif [ ${IS_CHECK} -eq 1 ]; then
        check_raid_health
    elif [ ${IS_GETDISK} -eq 1 ]; then 
        get_blank_disk_from_raid
    elif [ ${IS_INIT} -eq 1 ]; then 
        create_raid_all "${RAID_LEVEL}"
    else
        logme 2 "[ERROR] [none:${LINENO}] invalid input!!!"
        show_help
        exit 1
    fi
    
    #ɹʧܺͳһӡ
    RESULT=$?
    if [ ${RESULT} -ne 0 ]; then
        logme 2 "[ERROR] [none:${LINENO}] execute `basename $0` failed."
    else
        logme 2 "[INFO] [none:${LINENO}] execute `basename $0` successfully."
    fi
    
    #ض
    clean_lock
    exit ${RESULT}
} 3<>"${LOCKFILE}"



