#!/bin/bash
###################################################
# 功能: 进行OS设置
###################################################

###################################################
# 入口函数
# 备注:
#   模块文件夹规则: 三位的数字 + . + 名字
#                   名字只能是英文和下划线
#   例如: 070.autopart 中的名字为 autopart
#
#   入口函数规则:   模块文件夹的[名字] + _main
###################################################
function autopart_main()
{
    local path="$1"
    local name=""
    local file=""
    local sched_pid=0
    local ret=0
    
    debug "Enter [${FUNCNAME}:${LINENO}]"
    
    if [ "${gc_parted}" -eq 0 ]; then
        info "[${FUNCNAME}:${LINENO}]" "Don't need autopart. gc_parted=${gc_parted}"
        return 0
    fi
    
    debug "gc_parted:${gc_parted}"
    debug "gc_parted_conf:${gc_parted_conf}"
    debug "gc_kms_conf:${gc_kms_conf}"
    
    file="${gc_mian_path}/${path}/autopart/autopart.sh"
    
    if [ ! -f "${file}" ]; then
        info "[${FUNCNAME}:${LINENO}]" "Don't need to setup about ${name}"
        return 0
    fi
    
    #创建进度文件
    echo 0 > "${gc_p_sched_file}"
    
    #启动获取进度的后台进程
    bash ${gc_mian_path}/${path}/schedule.sh "${gc_p_sched_file}" "${gc_sched_file}" &
    
    #保存后台进程的PID
    sched_pid=$!
    
    if [ "${gc_parted}" -eq 1 ]; then
        bash ${file} -n "${gc_parted_conf}" -i -f -r "${gc_p_sched_file}" -e "${gc_kms_conf}" -d "${gc_data_home}"
        ret=$?
    elif [ "${gc_parted}" -eq 2 ]; then
        bash ${file} -p 1 -n "${gc_parted_conf}" -i -f -r "${gc_p_sched_file}" -e "${gc_kms_conf}" -d "${gc_data_home}"
        ret=$?
    elif [ "${gc_parted}" -eq 3 ]; then
        bash ${file} -p 2 -n "${gc_parted_conf}" -i -f -r "${gc_p_sched_file}" -e "${gc_kms_conf}" -d "${gc_data_home}"
        ret=$?
    fi 
    
    #结束后台进程
    kill $sched_pid
    
    if [ $ret -ne 0 ]; then
    	if [ $ret -eq 102 ]; then
            error "[${FUNCNAME}:${LINENO}]" "diskmgt service has been installed"
            return 102
        else
            error "[${FUNCNAME}:${LINENO}]" "run ${file} failed"
            return 70
        fi
    fi
    
    debug "Leave [${FUNCNAME}:${LINENO}]"
    
    return 0
}
