#!/bin/bash

# ---------------------------------------------------------------------------- #
#                                   变量定义                                   #
# ---------------------------------------------------------------------------- #
declare PACKAGE_FULL_PATH=""
declare TMP_WORK_DIR="/opt/repair_dir"
declare TMP_WORK_PACKAGE_DIR="/opt/repair_dir/package"
declare TMP_WORK_PATCH_DIR="/opt/repair_dir/patch"
declare PATH_FILE_FULL_PATH="${TMP_WORK_PATCH_DIR}/ha.bin"

################################################################################
# Function: spin_wait
# Description: 并发执行，显示进度并等待结果
################################################################################
function spin_wait()
{
    STEP_INFO="$1"

    local -i pid=0
    if [ -z "$2" ]; then
        pid=$!
    else
        pid=$2
    fi

    local -i placeholder_num=73

    printf "%-${placeholder_num}s [ %s ]\r" "${STEP_INFO}" "$BLANK"

    while ps | grep -w $pid >/dev/null 2>&1
    do
        for X in '-' '\' '|' '/'
        do 
        printf "%-${placeholder_num}s [ %s ]\r" "${STEP_INFO}" "${X}"
        sleep 0.3
        done 
    done

    wait $pid
    local ret=$?
    if [ $ret -ne 0 ]; then
        printf "%-${placeholder_num}s [\033[31;1m%s\e[m]\r" "${STEP_INFO}" "fail"
    else
        printf "%-${placeholder_num}s [\033[32;1m%s\e[m]\r" "${STEP_INFO}" "done"
    fi
    echo

    return $ret
}

function repair_om_sudo()
{
    local key_str="\"net.ipv4.tcp_tw_reuse\" \"net.ipv4.tcp_tw_recycle\""
    local new_key_str="\"net.ipv4.tcp_tw_reuse\""
    sed -i "s#${key_str}#${new_key_str}#g" "sudoExecute.sh"
    if [ $? -ne 0 ];then
        echo "modify tcp_tw_recycle failed."
        return 1;
    fi
    local value_str="\"10000\" \"1\" \"1\""
    local new_value_str="\"10000\" \"1\""
    sed -i "s#${value_str}#${new_value_str}#g" "sudoExecute.sh"
    if [ $? -ne 0 ];then
        echo "modify tcp_tw_recycle value failed."
        return 1
    fi
    
    local func_lineno=$(awk '/execPython_unPreinstallMPP\(\)/{print NR}' "sudoExecute.sh")
    local replace_lineno=`expr $func_lineno + 17`
    sed -i "${replace_lineno}s/"-d"/"-f"/" "sudoExecute.sh"
    if [ $? -ne 0 ];then
        echo "modify execPython_unPreinstallMPP func failed."
        return 1
    fi
    
    return 0    
}
function repair_agent_sudo()
{
    local agent_package="tmp_agent"
    if [ ! -d "${agent_package}" ];then
        mkdir -p "${agent_package}"
    fi
    rm -rf ${agent_package}/*
    tar -zxf agent-0.0.1.tar.gz -C "${agent_package}/"
    cd "${agent_package}/bin/sudo/runtime/"
    repair_om_sudo
    if [ $? -ne 0 ];then
        echo "modify tcp_tw_recycle value failed."
        return 1
    fi
    cd - >/dev/null
    cd ${agent_package}/
    tar -czf agent-0.0.1.tar.gz *
    if [ $? -ne 0 ];then
        echo "tar -czf agent failed."
        cd - >/dev/null
        return 1
    fi
    cp agent-0.0.1.tar.gz ./../
    cd - >/dev/null
    rm -rf ${agent_package}/
    return 0    
}

function repair_package()
{
    cd "${TMP_WORK_PACKAGE_DIR}"
    local package_full_name=$(basename ${PACKAGE_FULL_PATH})
    tar -zxf "${PACKAGE_FULL_PATH}" -C ${TMP_WORK_PACKAGE_DIR}    
    local packge_full_path_dir=$(find -maxdepth 1 -mindepth 1 -name "FusionInsight*" | grep -v "tar.gz")
    cd - >/dev/null
    
    local packge_full_path=$(find ${TMP_WORK_PACKAGE_DIR}  -maxdepth 1 -mindepth 1 -name "FusionInsight*" | grep -v "tar.gz")
    
    #begin to repair osType.ini
    echo "${package_full_name}" | grep "Manager"
    if [ $? -eq 0 ];then
        cd "${packge_full_path}/software/"
        if [ -f "${packge_full_path}/software/osType.ini" ];then        
            local fi_packge_full_name_dir=$(find -maxdepth 1 -mindepth 1 -name "FusionInsight" | grep -v "tar.gz")
            cat "${packge_full_path}/software/osType.ini" | grep "${osType}" >/dev/null
            if [ $? -ne 0 ];then
                local orgin_str="redhat-7.4;"
                local new_str="${orgin_str}""${osType};"
                sed -i "s#${orgin_str}#${new_str}#g" "${packge_full_path}/software/osType.ini"
                if [ $? -ne 0 ];then
                    echo "modify osType.ini failed in ${PACKAGE_FULL_PATH}."
                    cd - >/dev/null
                   return 1
                   
                fi
            fi
            cd - >/dev/null
            cd "${packge_full_path}/software/om/package/"
            tar -zxf "om.tar.gz" -C "${packge_full_path}/software/om/package/"
            if [ $? -ne 0 ];then
                echo -e "tar -zxf ${om_packge_full_name} -C ${packge_full_path}/software/om/package/"
                return 1
            fi
            local om_packge_full_name_dir=$(find -maxdepth 1 -mindepth 1 -name "om" | grep -v "tar.gz")
            cd - >/dev/null            
            local sudo_package_full_dir_par="${packge_full_path}/software/om/package/om/sbin/sudo/runtime"
            cd "${sudo_package_full_dir_par}"
            repair_om_sudo
            if [ $? -ne 0 ];then
                cd - >/dev/null
                return 1
            fi            
            cd - >/dev/null
            cd "${packge_full_path}/software/om/package/"
            tar -czf "om.tar.gz" om
            if [ $? -ne 0 ];then
                echo "tar -czf om failed."
                cd - >/dev/null
                return 1
            fi
            rm -rf om
            cd - >/dev/null
            cd "${packge_full_path}/software/om/package/"
            repair_agent_sudo
            if [ $? -ne 0 ];then
                cd - >/dev/null
                return 1
            fi            
            
            local packs_package_full_path_par="${packge_full_path}/software/packs/"
            cd "${packge_full_path}/software/packs"
            local base_packs_package_full_name=$(find -maxdepth 1 -mindepth 1 -name "FusionInsight*BASE*.tar.gz")
            if [ -n "${base_packs_package_full_name}" ];then
                tar -zxf "${base_packs_package_full_name}" -C "${packs_package_full_path_par}"
                local base_packs_full_name=$(find -maxdepth 1 -mindepth 1 -name "FusionInsight*BASE*"| grep -v "tar.gz")                    
                
                local components_package_full_path_par="${packs_package_full_path_par}/${base_packs_full_name}/software/"
                cd - >/dev/null
                cd "${components_package_full_path_par}"
                cat "${components_package_full_path_par}/osType.ini" | grep "${osType}" >/dev/null
                if [ $? -ne 0 ];then
                    local orgin_str="redhat-7.4;"
                    local new_str="${orgin_str}""${osType};"
                    sed -i "s#${orgin_str}#${new_str}#g" "${components_package_full_path_par}/osType.ini"
                    if [ $? -ne 0 ];then
                        echo "modify osType.ini failed in ${components_package_full_path_par}."
                        cd - >/dev/null
                        return 1                       
                    fi
                fi
                cd "${packge_full_path}/software/packs"
                tar -czf "${base_packs_package_full_name}" "${base_packs_full_name}"
                if [ $? -ne 0 ];then
                    echo -e "tar -czf ${base_packs_package_full_name} ${base_packs_full_name}"
                    cd - >/dev/null
                    return 1
                fi
                rm -rf "${base_packs_full_name}"                                        
            fi
            
            cd "${TMP_WORK_PACKAGE_DIR}"
            tar -czf "${package_full_name}" "${packge_full_path_dir}"
            if [ $? -ne 0 ];then
                echo -e "tar -czf ${package_full_name} ${packge_full_path_dir}"
                 cd - >/dev/null
                return 1
            fi
        fi
        
        rm -rf "${packge_full_path_dir}"
        return 0
    fi
    
    echo "${package_full_name}" | grep "LibrA" >/dev/null
    if [ $? -eq 0 ];then
        cd "${packge_full_path}/software/"
        if [ -f "${packge_full_path}/software/osType.ini" ];then        
            local fi_packge_full_name_dir=$(find -maxdepth 1 -mindepth 1 -name "FusionInsight" | grep -v "tar.gz")
            cat "${packge_full_path}/software/osType.ini" | grep "${osType}" >/dev/null
            if [ $? -ne 0 ];then
                local orgin_str="redhat-7.4;"
                local new_str="${orgin_str}""${osType};"
                sed -i "s#${orgin_str}#${new_str}#g" "${packge_full_path}/software/osType.ini"
                if [ $? -ne 0 ];then
                   echo "modify osType.ini failed in ${PACKAGE_FULL_PATH}."
                    cd - >/dev/null
                   return 1
                   
                fi
            fi
            cd - >/dev/null
            
            cd "${packge_full_path}/software/om/package/"
            tar -zxf "om.tar.gz" -C "${packge_full_path}/software/om/package/"
            if [ $? -ne 0 ];then
                echo -e "tar -zxf ${om_packge_full_name} -C ${packge_full_path}/software/om/package/"
                return 1
            fi
            local om_packge_full_name_dir=$(find -maxdepth 1 -mindepth 1 -name "om" | grep -v "tar.gz")
            cd - >/dev/null            
            local sudo_package_full_dir_par="${packge_full_path}/software/om/package/om/sbin/sudo/runtime"
            cd "${sudo_package_full_dir_par}"
            repair_om_sudo
            if [ $? -ne 0 ];then
                cd - >/dev/null
                return 1
            fi            
            cd - >/dev/null
            cd "${packge_full_path}/software/om/package/"
            tar -czf "om.tar.gz" om
            if [ $? -ne 0 ];then
                echo "tar -czf om failed."
                cd - >/dev/null
                return 1
            fi
            rm -rf om
            cd - >/dev/null
            cd "${packge_full_path}/software/om/package/"
            repair_agent_sudo
            if [ $? -ne 0 ];then
                cd - >/dev/null
                return 1
            fi   
            
            local packs_package_full_path_par="${packge_full_path}/software/packs/"
            cd "${packge_full_path}/software/packs"
            local base_packs_package_full_name=$(find -maxdepth 1 -mindepth 1 -name "FusionInsight*BASE*.tar.gz")
            if [ -n "${base_packs_package_full_name}" ];then
                tar -zxf "${base_packs_package_full_name}" -C "${packs_package_full_path_par}"
                local base_packs_full_name=$(find -maxdepth 1 -mindepth 1 -name "FusionInsight*BASE*"| grep -v "tar.gz")                    
                
                local components_package_full_path_par="${packs_package_full_path_par}/${base_packs_full_name}/software/"
                cd - >/dev/null
                cd "${components_package_full_path_par}"
                cat "${components_package_full_path_par}/osType.ini" | grep "${osType}" >/dev/null
                if [ $? -ne 0 ];then
                    local orgin_str="redhat-7.4;"
                    local new_str="${orgin_str}""${osType};"
                    sed -i "s#${orgin_str}#${new_str}#g" "${components_package_full_path_par}/osType.ini"
                    if [ $? -ne 0 ];then
                        echo "modify osType.ini failed in ${components_package_full_path_par}."
                        cd - >/dev/null
                        return 1                       
                    fi
                fi
                cd - >/dev/null
                cd "${packge_full_path}/software/packs"
                tar -czf "${base_packs_package_full_name}" "${base_packs_full_name}"
                if [ $? -ne 0 ];then
                    echo -e "tar -czf ${base_packs_package_full_name} ${base_packs_full_name}"
                    cd - >/dev/null
                    return 1
                fi
                rm -rf "${base_packs_full_name}"
                cd - >/dev/null                            
            fi 
            cd "${packge_full_path}/software/packs"
            local mppdb_packs_package_full_name=$(find -maxdepth 1 -mindepth 1 -name "FusionInsight*MPPDB*.tar.gz")
            if [ -n "${mppdb_packs_package_full_name}" ];then
                tar -zxf "${mppdb_packs_package_full_name}" -C "${packs_package_full_path_par}"
                local mppdb_packs_full_name=$(find -maxdepth 1 -mindepth 1 -name "FusionInsight*MPPDB*"| grep -v "tar.gz")                    
                
                local components_package_full_path_par="${packs_package_full_path_par}/${mppdb_packs_full_name}/software/"
                cd - >/dev/null    
                cd "${components_package_full_path_par}"
                cat "${components_package_full_path_par}/osType.ini" | grep "${osType}" >/dev/null
                if [ $? -ne 0 ];then
                    local orgin_str="redhat-7.4;"
                    local new_str="${orgin_str}""${osType};"
                    sed -i "s#${orgin_str}#${new_str}#g" "${components_package_full_path_par}/osType.ini"
                    if [ $? -ne 0 ];then
                        echo "modify osType.ini failed in ${components_package_full_path_par}."
                        cd - >/dev/null
                        return 1                       
                    fi
                fi
                cd - >/dev/null
                cd "${packge_full_path}/software/packs"
                tar -czf "${mppdb_packs_package_full_name}" "${mppdb_packs_full_name}"
                if [ $? -ne 0 ];then
                    echo -e "tar -czf ${mppdb_packs_package_full_name} ${mppdb_packs_full_name}"
                    cd - >/dev/null
                    return 1
                fi
                rm -rf "${mppdb_packs_full_name}"
                cd - >/dev/null                            
            fi 
            cd "${TMP_WORK_PACKAGE_DIR}"
            tar -czf "${package_full_name}" "${packge_full_path_dir}"
            if [ $? -ne 0 ];then
                echo -e "tar -czf ${package_full_name} ${packge_full_path_dir}"
                 cd - >/dev/null
                return 1
            fi
        fi
        
        rm -rf "${packge_full_path_dir}"
        return 0
    fi
    
    cd "${packge_full_path}/software/"
    if [ -f "${packge_full_path}/software/osType.ini" ];then        
        local fi_packge_full_name_dir=$(find -maxdepth 1 -mindepth 1 -name "FusionInsight" | grep -v "tar.gz")
        cat "${packge_full_path}/software/osType.ini" | grep "${osType}" >/dev/null
        if [ $? -ne 0 ];then
            local orgin_str="redhat-7.4;"
            local new_str="${orgin_str}""${osType};"
            sed -i "s#${orgin_str}#${new_str}#g" "${packge_full_path}/software/osType.ini"
            if [ $? -ne 0 ];then
                echo "modify osType.ini failed in ${PACKAGE_FULL_PATH}."
                cd - >/dev/null
                return 1
            fi
        fi
        cd "${TMP_WORK_PACKAGE_DIR}"
        tar -czf "${package_full_name}" "${packge_full_path_dir}"
        if [ $? -ne 0 ];then
            echo -e "tar -czf ${package_full_name} ${packge_full_path_dir}"
            cd - >/dev/null
            return 1
        fi
        rm -rf "${packge_full_path_dir}"
        return 0
    fi
}

main()
{    
    if [ $# -ne 2 ]; then
         echo -e "param invalid,should be repair-setup-tool.sh /opt/FusionInsight_XX_V100R002CXXSPCXXX_XXXX.tar.gz redhat-7.5"
         return 1
    fi 
    
    PACKAGE_FULL_PATH="$1"
    osType="$2"
    if [ ! -f "${PACKAGE_FULL_PATH}" ];then
        echo -e "${PACKAGE_FULL_PATH} does not exists."
        return 1
    fi
    
    if [ ! -d "${TMP_WORK_DIR}" ];then
        mkdir -p "${TMP_WORK_DIR}"
    fi
    rm -rf ${TMP_WORK_DIR}/*
    
    if [ ! -d "${TMP_WORK_PACKAGE_DIR}" ];then
        mkdir -p "${TMP_WORK_PACKAGE_DIR}"
    fi
    rm -rf ${TMP_WORK_PACKAGE_DIR}/*
    
    repair_package &
    spin_wait 'Begin to repair package.' "$!"
    if [ $? -ne 0 ]; then
        echo -e "Repair package failed."
        return 1
    fi
    
    echo -e "Package modified successfully. Please fetch the new package from ${TMP_WORK_PACKAGE_DIR} before you modify the next package."
    return 0
}


main "$@"
exit $?

