#!/bin/bash

declare g_tomcatHome=""
declare g_old_tomcat_install_dir=""
declare g_omsHome=""
declare g_httpdHome=""
declare g_controllerHome=""

main()
{
    local backup_dir="$1"
    local log_file="$2"
    local target_tomcat_name="$3"   
    local tomcat_dir_parent="${BIGDATA_HOME}/om-server/"
    if [ ! -d "${tomcat_dir_parent}" ];then
        tomcat_dir_parent="${BIGDATA_HOME}/"
    fi
    
    g_tomcatHome="${tomcat_dir_parent}/${target_tomcat_name}"    
    local bak_dir="$(echo ${target_tomcat_name}|rev)""_bak"
    g_OldTomcatHome="${tomcat_dir_parent}/${bak_dir}"
    
    local time=$(date)
    echo "$time ready to unpach backup_dir=$backup_dir, log_file=$log_file target_tomcat_name=$target_tomcat_name tomcat_dir_parent=$tomcat_dir_parent" >> "${log_file}"
    
    if [ -d "${g_tomcatHome}" ];then
        chmod 700 "${g_tomcatHome}" -R
        rm -rf "${g_tomcatHome}" >> "${log_file}"
    fi
    
    if [ -d "${g_OldTomcatHome}" ];then
        su - omm -c "mv -f "${g_OldTomcatHome}" "${g_tomcatHome}"" >> "${log_file}"
    fi
    
    if [ ! -d "${g_tomcatHome}" ];then
        echo "uninstall tomcat patch failed." >> "${log_file}"
        return 1
    fi
    
    local omsStatus=$($OMS_RUN_PATH/workspace/ha/module/hacom/script/get_harole.sh | head -n 1)
    local ha_mode=$($OMS_RUN_PATH/workspace/ha/module/hacom/script/config_ha.sh -a |grep "^HaMode" |awk '{ print $2 }')

    if [ ${ha_mode} = "double" ] && [ ${omsStatus} = "active"  ] ;then
        ps -ef |grep ${target_tomcat_name}| grep ${BIGDATA_HOME} |awk '{print $2}'|xargs kill -9
        su - omm -c "sh ${tomcat_dir_parent}/tomcat/bin/startup.sh"
    elif [ ${ha_mode} = "single" ];then
        ps -ef |grep ${target_tomcat_name} | grep ${BIGDATA_HOME} |awk '{print $2}'|xargs kill -9
        su - omm -c "sh ${tomcat_dir_parent}/tomcat/bin/startup.sh"
    fi
    time=$(date)
    echo "$time uninstall tomcat patch succed." >> "${log_file}" 
}

source /home/omm/.profile
main "$@"
exit $?
