#!/usr/bin/python

import ctypes
from AlgorithmID import AlgorithmID

class SccOptions():
    def __init__(self):
        self.primaryKeyFile      = ""
        self.standbyKeyFile      = ""
        self.backupDirectory     = ""
        self.logPath             = ""
        self.logFile             = "scc"
        self.randDevice          = "/dev/random"
        self.logLever            = 0    # 1:debug, 2:info, 3:warn, 4:error
        self.domainCount         = 8
        self.defaultAlgorithm    = AlgorithmID.AES256_CBC
        self.enableChangeFilePermission = 1
        self.semKey              = 0
        self.semPerm             = 384
        self.enableHw            = 0
        self.ak                  = ""
        self.sk                  = ""
        self.kmsUrl              = ""
        self.projectId           = ""
        self.enableSSLVerify     = 0
        self.splitUserLog        = 0


class sig_str_t(ctypes.Structure):
    _fields_ = [('data', ctypes.c_char_p), ('len', ctypes.c_int)]


class kmc_sig_params_t(ctypes.Structure):
    _fields_ = [
        ('AK', sig_str_t),
        ('SK', sig_str_t),
        ('host', sig_str_t),
        ('projectID', sig_str_t)
    ]


class configuration(ctypes.Structure):
    _fields_ = [
        ('confPath', ctypes.c_char_p),
        ('primaryKeyStoreFile', ctypes.c_char_p),
        ('standbyKeyStoreFile', ctypes.c_char_p),
        ('backupFolderName', ctypes.c_char_p),
        ('logPath', ctypes.c_char_p),
        ('logFileName', ctypes.c_char_p),
        ('randomDevice', ctypes.c_char_p),
        ('logLever', ctypes.c_int),
        ('domainCount', ctypes.c_int),
        ('defaultAlgorithm', ctypes.c_int),
        ('enableChangeFilePermission', ctypes.c_int),
        ('semKey', ctypes.c_int),
        ('semPerm', ctypes.c_int),
        ('enableHw', ctypes.c_int),
        ('kmcSigParams', kmc_sig_params_t),
        ('enableSSLVerify', ctypes.c_int),
        ('splitUserLog', ctypes.c_int)
    ]
